class AccountingsController < ApplicationController
  class_desc :display_name => '経理管理'

  #
  # = 検索画面表示アクション =
  #
  def index
    @condition = prepare_session_condition do |condition|
      condition || Accounting::SearchInfo.new(params[:condition])
    end
    if @condition.valid?
      per_page = @condition.disp_count ? @condition.disp_count.to_i : 20
      @accountings = Accounting.paginate(
        @condition.to_find_options(
          :page => params[:page], :per_page => per_page, :order => "accountings.created_at"))
    end

    if session[:accounting_search_cond].nil?
      # 初期表示の場合はフラグをセット
      @condition.none_output_data = true
      @condition.previous_point = false
    end
    # CSVファイル出力の中から検索が呼ばれた場合
    if request.xml_http_request?
      render :partial => "/accountings/search_result", :layout => false, :locals => {:invoked => 'csv'}
    end
  end
end
