class BannerConditionsController < ApplicationController
  class_desc :display_name => 'バナー条件', :auth_as => 'banners', :invisible => true

  # GET /banner_conditions/new
  # GET /banner_conditions/new.xml
  def new
    @banner_condition = BannerCondition.new
    
    respond_to do |format|
      format.html { render(:layout => false) if request.xhr? }
      format.xml  { render :xml => @banner_condition }
    end
  end

  # GET /banner_conditions/1/edit
  def edit
    @banner_condition = BannerCondition.find(params[:id])
  end

  # POST /banner_conditions
  # POST /banner_conditions.xml
  def create
    @banner_condition = BannerCondition.new(params[:banner_condition])

    respond_to do |format|
      if @banner_condition.save
        flash[:notice] = 'BannerCondition was successfully created.'
        format.html { redirect_to(@banner_condition) }
        format.xml  { render :xml => @banner_condition, :status => :created, :location => @banner_condition }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @banner_condition.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /banner_conditions/1
  # PUT /banner_conditions/1.xml
  def update
    @banner_condition = BannerCondition.find(params[:id])

    respond_to do |format|
      if @banner_condition.update_attributes(params[:banner_condition])
        flash[:notice] = 'BannerCondition was successfully updated.'
        format.html { redirect_to(@banner_condition) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @banner_condition.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /banner_conditions/1
  # DELETE /banner_conditions/1.xml
  def destroy
    @banner_condition = BannerCondition.find(params[:id])
    @banner_condition.destroy

    respond_to do |format|
      format.html { redirect_to(banner_conditions_url) }
      format.xml  { head :ok }
    end
  end
end
