class BannerDisplaysController < ApplicationController
  class_desc :display_name => 'バナー表示', :auth_as => 'banners', :invisible => true

  # GET /banner_displays
  # GET /banner_displays.xml
  def index
    @banner_displays = BannerDisplay.all

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @banner_displays }
    end
  end

  # GET /banner_displays/1
  # GET /banner_displays/1.xml
  def show
    @banner_display = BannerDisplay.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @banner_display }
    end
  end

  # GET /banner_displays/new
  # GET /banner_displays/new.xml
  def new
    @banner_display = BannerDisplay.new

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @banner_display }
    end
  end

  # GET /banner_displays/1/edit
  def edit
    @banner_display = BannerDisplay.find(params[:id])
  end

  # POST /banner_displays
  # POST /banner_displays.xml
  def create
    @banner_display = BannerDisplay.new(params[:banner_display])

    respond_to do |format|
      if @banner_display.save
        flash[:notice] = 'BannerDisplay was successfully created.'
        format.html { redirect_to(@banner_display) }
        format.xml  { render :xml => @banner_display, :status => :created, :location => @banner_display }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @banner_display.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /banner_displays/1
  # PUT /banner_displays/1.xml
  def update
    @banner_display = BannerDisplay.find(params[:id])

    respond_to do |format|
      if @banner_display.update_attributes(params[:banner_display])
        flash[:notice] = 'BannerDisplay was successfully updated.'
        format.html { redirect_to(@banner_display) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @banner_display.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /banner_displays/1
  # DELETE /banner_displays/1.xml
  def destroy
    @banner_display = BannerDisplay.find(params[:id])
    @banner_display.destroy

    respond_to do |format|
      format.html { redirect_to(banner_displays_url) }
      format.xml  { head :ok }
    end
  end
end
