# -*- coding: utf-8 -*-
class CampaignTargetProductSkusController < ApplicationController
  class_desc :display_name => 'キャンペーン対象商品管理(Ajax)', :auth_as => 'campaigns', :invisible => true

  include NestedAjax::RenderExt

  # GET /campaign_target_product_skus
  # GET /campaign_target_product_skus.xml
  def index
    @campaign_target_product_skus = CampaignTargetProductSku.all

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @campaign_target_product_skus }
    end
  end

  # GET /campaign_target_product_skus/1
  # GET /campaign_target_product_skus/1.xml
  def show
    @campaign_target_product_sku = CampaignTargetProductSku.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @campaign_target_product_sku }
    end
  end

  # GET /campaign_target_product_skus/new
  # GET /campaign_target_product_skus/new.xml
  def new
    @campaign_target_product_sku = CampaignTargetProductSku.new(params[:campaign_target_product_sku])

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @campaign_target_product_sku }
    end
  end

  # GET /campaign_target_product_skus/1/edit
  def edit
    @campaign_target_product_sku = CampaignTargetProductSku.find(params[:id])
  end

  # POST /campaign_target_product_skus
  # POST /campaign_target_product_skus.xml
  def create
    @campaign_target_product_sku = CampaignTargetProductSku.new(params[:campaign_target_product_sku])

    respond_to do |format|
      if @campaign_target_product_sku.save
        flash[:notice] = 'CampaignTargetProductSku was successfully created.'
        format.html { render_if_xhr(:action => 'show') || redirect_to(:action => 'show', :id => @campaign_target_product_sku.id) }
        format.xml  { render :xml => @campaign_target_product_sku, :status => :created, :location => @campaign_target_product_sku }
      else
        format.html { render_if_xhr(:action => 'new') || render(:action => "new") }
        format.xml  { render :xml => @campaign_target_product_sku.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /campaign_target_product_skus/1
  # PUT /campaign_target_product_skus/1.xml
  def update
    @campaign_target_product_sku = CampaignTargetProductSku.find(params[:id])
    
    respond_to do |format|
      if @campaign_target_product_sku.update_attributes(params[:campaign_target_product_sku])
        # belongs_to, has_one, has_many などの関連のキャッシュをクリアしておきます
        @campaign_target_product_sku.clear_association_cache
        # composed_of などの集約のキャッシュをクリアしておきます
        @campaign_target_product_sku.clear_aggregation_cache
        flash[:notice] = 'CampaignTargetProductSku was successfully updated.'
        format.html { render_if_xhr(:action => 'show') || redirect_to(:action => 'show', :id => @campaign_target_product_sku.id) }
        format.xml  { head :ok }
      else
        format.html { render_if_xhr(:action => 'edit') || render(:action => "edit") }
        format.xml  { render :xml => @campaign_target_product_sku.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /campaign_target_product_skus/1
  # DELETE /campaign_target_product_skus/1.xml
  def destroy
    @campaign_target_product_sku = CampaignTargetProductSku.find(params[:id])
    @campaign_target_product_sku.destroy
    flash[:notice] = 'CampaignTargetProductSku was successfully deleted.'
    respond_to do |format|
      # いきなりザクッと消したい場合はこんな感じで。ただし例外発生時に何も分からなくなるので、
      # 例外のメッセージをinlineでrenderする必要があるかもしれませんので、ご注意を。
      # format.html { render_if_xhr(:inline => '') || redirect_to(party_emails_url) }
      # エフェクトをかけたい場合はこんな感じ。
      format.html { render_if_xhr(:action => 'show') || redirect_to(:action => 'index') }
      format.xml  { head :ok }
    end
  end

  desc :auth_as => :index
  # GET /campaign_target_product_skus/name
  # GET /campaign_target_product_skus/names.xml
  # GET /campaign_target_product_skus/names.json
  def names
    campaign_target_product_skus = CampaignTargetProductSku.find_with_name(params[:name])
    result = campaign_target_product_skus.map{|campaign_target_product_sku|
      [campaign_target_product_sku.name_for_nested_ajax, campaign_target_product_sku.id] }
    respond_to do |format|
      format.html { render :text => auto_complete_html(result)}
      format.json { render :text => result.map{|(name, id)| {:name => name, :id => id} }.to_json }
      format.xml  { render :xml => result.map{|(name, id)| {:name => name, :id => id} } }
    end
  end

end
