# -*- coding: utf-8 -*-

#
# ！ このコントローラは廃止される予定です
#

require 'tmpdir'
require 'pathname'

class CmsCloudFrontController < ApplicationController
  class_desc :display_name => 'CloudFrontアップロード', :invisible => true

  include EcRider::CloudFront
  before_filter :setup_base_path

  def index
    @upload_dates = {}
    @real_files = Dir.glob(File.join(@base_path, 'cms', "**", "*")).sort
    @real_files.delete_if {|path| File.directory?(path)}
    @real_files.each_with_index do |path, index|
      if path =~ /^(\S*)\-(\d{14})(\.\S*)$/
        upload_date = "#{$2}"
        original_path = "#{$1}#{$3}".gsub(@base_path, '')

        @upload_dates[original_path] = @upload_dates[original_path] ? [@upload_dates[original_path], upload_date].max : upload_date
        @real_files[index] = nil
      end
    end
    @real_files = @real_files.compact.map{|path| [path.gsub(@base_path, ''), File.mtime(@base_path).strftime('%Y/%m/%d %H:%M')]}
  end

  def create
    file_check = params[:file_check]
    logger.info("file_check => #{file_check.inspect}")
    if file_check
      uploaded_files = create_and_upload_to_s3(file_check.keys)
      flash[:notice] = "以下のファイルをアップロードしました<br/>" << (uploaded_files || []).join(', ')
    end
    redirect_to :action => 'index'
  end

  private

  def setup_base_path
    # @base_path は、ビューでも使われているインスタンス変数です
    @base_path = File.expand_path(File.join(EcRider.config.ec_front_root, 'public'))
  end

end
