# -*- coding: utf-8 -*-
class CmsProjectApprovalsController < ApplicationController
  class_desc :display_name => 'プロジェクト管理->ワークフロー管理'

  before_filter :find_cms_project

  private
  def find_cms_project
    session[:project_id] ||= params[:project_id]
    if params[:project_id] && session[:project_id] != params[:project_id]
      session[:project_id] = params[:project_id]
    end
    @cms_project = CmsProject.find(session[:project_id], :include => :assigns)
  end
  
  public
  # GET /cms_projects
  # GET /cms_projects.xml
  def index
    @approvals = CmsProjectApproval.find(:all, :include => {:goldberg_user => :cms_project_assigns},
        :conditions => ["cms_project_approvals.cms_project_id = ? and cms_project_assigns.cms_project_id = cms_project_approvals.cms_project_id", @cms_project.id],
        :order => 'cms_project_approvals.created_at')
      
    if @assign = @cms_project.workflow_holder?(current_user.id)
      @approvals << CmsProjectApproval.new
    end
  end

  # POST /cms_projects
  # POST /cms_projects.xml
  def create
    approval = CmsProjectApproval.new(params[:cms_project_approval].merge(
      :cms_project_id => @cms_project.id, :goldberg_user_id => current_user.id))
    approval.save!
    if [:check_passbacked, :approve_passbacked].include?(approval.result_key)
      @cms_project.status_key = :editing
    else
      @cms_project.up_status
    end
    @cms_project.save!
    
    AdminMailer.deliver_project_approval_mail(@cms_project, approval.comment) unless @cms_project.status_key == :approved
    
    case @cms_project.status_key
      when :editing
        flash[:notice] = "編集担当者へ差し戻しました"
      when :requesting_check
        flash[:notice] = "確認担当者へ確認を依頼しました"
      when :requesting_approval
        flash[:notice] = "承認担当者へ承認を依頼しました"
      when :approved
        flash[:notice] = "承認しました"
    end
    redirect_to :action => "index"
  end
end
