# -*- coding: utf-8 -*-
class CountriesController < ApplicationController
  class_desc :display_name => '配送先管理'

  # GET /countries
  # GET /countries.xml
  def index
    redirect_to :action => :list
  end
  
  desc :auth_as => :index
  def list
    @condition = session[:countries_search_cond] if session[:countries_search_cond]
    if params[:condition]
      @condition = Country::SearchCondition.new(params[:condition])
      session[:countries_search_cond] = @condition
    end

    if !@condition.nil? && !@condition.valid?
      flash[:error] = @condition.errors.zip
      return
    end
    
    per_page = (@condition && @condition.disp_count) ? @condition.disp_count.to_i : 20
    @countries = Country.paginate(:page => params[:page], :per_page => per_page, 
                   :conditions => Country.create_condition(@condition), :order => :code)
    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @countries }
    end
  end

  # GET /countries/1
  # GET /countries/1.xml
  def show
    @country = Country.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @country }
    end
  end

  # GET /countries/1/edit
  def edit
    @country = Country.find(params[:id])
  end

  # PUT /countries/1
  # PUT /countries/1.xml
  def update
    @country = Country.find(params[:id])

    respond_to do |format|
      if @country.update_attributes(params[:country])
        flash[:notice] = 'Country was successfully updated.'
        format.html { redirect_to(:action => 'index', :page => params[:page]) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @country.errors, :status => :unprocessable_entity }
      end
    end
  end
end
