class CsvFileDownloadHistoryController < ApplicationController
  class_desc :display_name => 'CSV出力履歴管理'

  def index
    @condition = prepare_session_condition do |condition|
      condition || CsvFileDownloadHistory::SearchCondition.new(params[:condition])
    end
    if @condition.valid?
      per_page = @condition.disp_count.to_i if @condition
      per_page = (per_page.to_i == 0) ? 20 : per_page
      @histories = CsvFileDownloadHistory.paginate(
        :page => params[:page], :per_page => per_page, 
        :include => :pattern, :conditions => @condition.create_condition, :order => 'created_at desc'
      )
    end
  end

  def show
    history = CsvFileDownloadHistory.find(params[:id], :include => :pattern)
    send_file(File.join(EcRider.config.csv_dir, history.file_name), :type => "text/csv charset=#{history.pattern.character_key.to_s}")
  end

  def destroy
    history = CsvFileDownloadHistory.find(params[:id])
    FileUtils.rm_f(File.join(EcRider.config.csv_dir, history.file_name))
    history.destroy
    redirect_to(:action => "index")
  end
end
