class CsvFileUploadController < ApplicationController
  class_desc :display_name => 'CSVファイルアップロード'
    
  def index
    find_csv_file_upload_history
  end

  desc :display_name => 'アップロード'
  def new
    csv_file_upload = CsvFileUpload.new(params[:csv_file_upload])
    uploader = csv_file_upload.uploader
    @file_field_labels = uploader.file_field_labels

    render :layout => false
  end

  desc :display_name => 'アップロード'
  def create
    @csv_file_upload = CsvFileUpload.new(params[:csv_file_upload])
    uploader = @csv_file_upload.uploader
    uploader.errors = nil
    unless uploader.validate?
      @errors = uploader.errors
      find_csv_file_upload_history
      render :action => :index
      return
    end
    
    uploader.upload
    
    redirect_to :action => :index
  end

  private
  def find_csv_file_upload_history
    @csv_file_upload_histories = CsvFileUploadHistory.paginate(:page => params[:page] ||= 1, :per_page => 20, :order => 'processed_at desc')
  end

end
