class CsvFileUploadHistoryController < ApplicationController
  class_desc :display_name => 'CSVファイル取込履歴'

  # GET /csv_file_upload_histories
  # GET /csv_file_upload_histories.xml
  def index
    @csv_file_upload_histories = CsvFileUploadHistory.all

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @csv_file_upload_histories }
    end
  end

  # GET /csv_file_upload_histories/1
  # GET /csv_file_upload_histories/1.xml
  def show
    @csv_file_upload_history = CsvFileUploadHistory.find(params[:id])
    send_file(@csv_file_upload_history.csv_file_path, :type => 'text/csv; charset=utf-8;')
  end

  # GET /csv_file_upload_histories/new
  # GET /csv_file_upload_histories/new.xml
  def new
    @csv_file_upload_history = CsvFileUploadHistory.new

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @csv_file_upload_history }
    end
  end

  # GET /csv_file_upload_histories/1/edit
  def edit
    @csv_file_upload_history = CsvFileUploadHistory.find(params[:id])
  end

  # POST /csv_file_upload_histories
  # POST /csv_file_upload_histories.xml
  def create
    @csv_file_upload_history = CsvFileUploadHistory.new(params[:csv_file_upload_history])

    respond_to do |format|
      if @csv_file_upload_history.save
        flash[:notice] = 'CsvFileUploadHistory was successfully created.'
        format.html { redirect_to(@csv_file_upload_history) }
        format.xml  { render :xml => @csv_file_upload_history, :status => :created, :location => @csv_file_upload_history }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @csv_file_upload_history.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /csv_file_upload_histories/1
  # PUT /csv_file_upload_histories/1.xml
  def update
    @csv_file_upload_history = CsvFileUploadHistory.find(params[:id])

    respond_to do |format|
      if @csv_file_upload_history.update_attributes(params[:csv_file_upload_history])
        flash[:notice] = 'CsvFileUploadHistory was successfully updated.'
        format.html { redirect_to(@csv_file_upload_history) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @csv_file_upload_history.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /csv_file_upload_histories/1
  # DELETE /csv_file_upload_histories/1.xml
  def destroy
    @csv_file_upload_history = CsvFileUploadHistory.find(params[:id])
    @csv_file_upload_history.destroy

    respond_to do |format|
      format.html { redirect_to(:action => "index") }
      format.xml  { head :ok }
    end
  end
end
