# -*- coding: utf-8 -*-
module Goldberg
  class AuthController < ApplicationController
    class_desc :display_name => 'ログイン'

    skip_before_filter :goldberg_security_up

    layout false

    def login
      if request.get?
        unless Goldberg.user #if user goes to login url or hits back button and is already logged in
          reset_session #double check there isn't a stale session
          render :controller => 'goldberg/auth', :action => 'login'
        end
      else
        user = Goldberg::User.find_by_login(params[:login][:login])

        if user and user.check_password(params[:login][:password])
          logger.info "User #{params[:login][:name]} successfully logged in"
          Goldberg.user = user
          Goldberg.set_user(user.id || session[:user])
          if Goldberg.user
            session[:user] = Goldberg.user.id
          end

          # セッションにユーザ情報をセット
          session[:user] = user.id
          session[:current_user] = user

          # redirect_to user.start_path
          redirect_to :controller => '/top', :action => 'index'
        else
          logger.warn "Failed login attempt"
          redirect_to :action => "login"
        end
      end
    end  # def login

    desc :auth_as => :login
    def logout
      reset_session if request.post?
      redirect_to :action => "login"
    end

  end
end
