# -*- coding: utf-8 -*-
class MailHistoryController < ApplicationController
  class_desc :display_name => 'メールログ管理'

  def index
    redirect_to(:action => :list)
  end

  desc :auth_as => :index
  def list
    session[:mail_delivery_search_cond] = nil
  end

  desc :auth_as => :index
  # 検索
  def search
    if params[:condition]
      session[:mail_delivery_search_cond] = trim_values(params[:condition])
    end
    @condition = MailDelivery::SearchConditionForm.new(session[:mail_delivery_search_cond])

    unless @condition.valid?
      flash[:error] = @condition.errors.zip
      render(:action => :list)
      return
    end

    per_page = @condition.disp_count ? @condition.disp_count.to_i : 20
    @mail_deliveries = MailDelivery.paginate(:page => params[:page], :per_page => per_page,
      :conditions => MailDelivery.create_condition(@condition), :include => [:user, :inquiry], :order => 'deliveried_at desc')
                                      
    render :action => :list
  end

  def show
    @mail_delivery = MailDelivery.find(params[:id])
    @pages_current = params[:page]
  end

  desc :category_name => :destroy, :display_name => "メールログ削除"
  def delete
    MailDelivery.destroy(params[:id])
    redirect_to :action => 'search', :page => params[:page], :condition => session[:mail_delivery_search_cond]
  end
end
