# -*- coding: utf-8 -*-
class MsShopSettingsController < ApplicationController
  class_desc :display_name => '店舗設定管理'

  desc :auth_as => :index
  # GET /ms_shop_settings
  # GET /ms_shop_settings.xml
  def init_index
    session[:tmp_shop_settings] = nil
    redirect_to(:action => 'index')
  end

  def index
    @condition = session[:tmp_shop_settings]

    if params[:condition]
      @condition = ShopSetting::SearchInfo.new(params[:condition])
      session[:tmp_shop_settings] = @condition
    end

    if @condition
      @shop_settings = ShopSetting.paginate(@condition.to_paginate_options(:page => params[:page]))
    end

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @shop_settings }
    end
  end

  # GET /ms_shop_settings/1
  # GET /ms_shop_settings/1.xml
  def show
    @shop_setting = ShopSetting.find(params[:id])
    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @shop_setting }
    end
  end

  # GET /ms_shop_settings/new
  # GET /ms_shop_settings/new.xml
  def new
    @shop_setting = ShopSetting.new(:setting_div_key => :shop_name)
    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @shop_setting }
    end
  end

  desc :auth_as => :create
  #
  # 新規登録画面でsetting_divに応じて入力欄を切り替える
  #
  def change_setting_div
    @shop_setting = ShopSetting.new(params[:shop_setting])
    render :partial => 'form_value'
  end

  # GET /ms_shop_settings/1/edit
  def edit
    @shop_setting = ShopSetting.find(params[:id])
  end

  # POST /ms_shop_settings
  # POST /ms_shop_settings.xml
  def create
    @shop_setting = ShopSetting.new(params[:shop_setting])

    respond_to do |format|
      if @shop_setting.save
        format.html { redirect_to(ms_shop_settings_url) }
        format.xml  { head :ok }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @shop_setting.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /ms_shop_settings/1
  # PUT /ms_shop_settings/1.xml
  def update
    @shop_setting = ShopSetting.find(params[:id])

    respond_to do |format|
      if @shop_setting.update_attributes(params[:shop_setting])
        format.html { redirect_to(ms_shop_settings_url, :page => params[:page]) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @shop_setting.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /ms_shop_settings/1
  # DELETE /ms_shop_settings/1.xml
  def destroy
    @shop_setting = ShopSetting.find(params[:id])
    @shop_setting.destroy

    respond_to do |format|
      format.html { redirect_to(ms_shop_settings_url) }
      format.xml  { head :ok }
    end
  end

end
