# -*- coding: utf-8 -*-
class PointSettingController < ApplicationController
  class_desc :display_name => 'ポイント利用設定'


  # 詳細画面表示アクション
  def index
    @point_setting = PointSetting.find(:first)
  end

  # 編集画面表示アクション
  def edit
    if flash[:point_setting]
      @point_setting = flash[:point_setting]
    else
      @point_setting = PointSetting.find(:first)
    end
  end

  # ポイント更新アクション
  def update
    point_setting = PointSetting.find(:first)
    point_setting.attributes = params[:point_setting]
    unless point_setting.valid?
      flash[:point_setting] = point_setting
      return redirect_to :action => :edit
    end
    PointSetting.transaction do
      point_setting.update_and_all_user_point_term_date
    end
    redirect_to :action => :index
  end
end
