# -*- coding: utf-8 -*-
class ProductCategoriesController < ApplicationController
  class_desc :display_name => '商品カテゴリ管理'

  # GET /product_categories
  def index
    @product_categories = ProductCategory.find(:all, :conditions => ["parent_id IS NULL"], :order => 'display_order, id')
  end

  # GET /product_categories/1
  def show
    @product_category = ProductCategory.find(params[:id])
  end

  # GET /product_categories/new
  def new
    @product_category = ProductCategory.new
    @product_category.parent_id = params[:parent_id] if params[:parent_id]
    
    I18n.supported_locales.each do |locale|
      @product_category.displays << ProductCategoryDisplay.new(:locale => locale.to_s)
    end

    # 「上位のカテゴリ」セレクトボックスに表示する情報を取得
    @product_categories = ProductCategory.find(:all, :conditions => ["parent_id IS NULL"], :order => 'display_order, id')
  end

  # GET /product_categories/1/edit
  def edit
    @product_category = ProductCategory.find(params[:id])
    # 「上位のカテゴリ」セレクトボックスに表示する情報を取得
    @product_categories = ProductCategory.find(:all, :conditions => ["parent_id IS NULL"], :order => 'display_order, id')
  end

  # POST /product_categories
  def create
    @product_category = ProductCategory.new(params[:product_category])

    if @product_category.save
      flash[:notice] = '商品カテゴリを登録しました。'
      redirect_to(@product_category)
    else
      # 「上位のカテゴリ」セレクトボックスに表示する情報を取得
      @product_categories = ProductCategory.find(:all, :conditions => ["parent_id IS NULL"], :order => 'display_order, id')
      render :action => "new"
    end
  end

  # PUT /product_categories/1
  def update
    @product_category = ProductCategory.find(params[:id])

    if @product_category.update_attributes(params[:product_category])
      flash[:notice] = '商品カテゴリを更新しました。'
      redirect_to(@product_category)
    else
      # 「上位のカテゴリ」セレクトボックスに表示する情報を取得
      @product_categories = ProductCategory.find(:all, :conditions => ["parent_id IS NULL"], :order => 'display_order, id')
      render :action => "edit"
    end
  end

  # DELETE /product_categories/1
  def destroy
    @product_category = ProductCategory.find(params[:id])
    @product_category.destroy

    redirect_to(product_categories_url)
  end
end
