# -*- coding: utf-8 -*-
class ProductVariationItemsController < ApplicationController
  class_desc :display_name => "商品バリエーション項目", :invisible => true, :auth_as => 'product_variations'

  layout false

  # GET /product_variation_items/new
  def new
    @product_variation_item = ProductVariationItem.new
    I18n.supported_locales.each do |locale|
      @product_variation_item.displays << ProductVariationItemDisplay.new(:locale => locale.to_s)
    end
  end

  # GET /product_variation_items/1/edit
  def edit
    @product_variation_item = ProductVariationItem.find(params[:id])
  end

  # POST /product_variation_items
  def create
    @product_variation_item = ProductVariationItem.new(params[:product_variation_item])

    if @product_variation_item.save
      flash[:notice] = 'ProductVariationItem was successfully created.'
      render :update do |page|
        page.reload
      end
    else
      render :update do |page|
        page[:error_message].replace_html  template_error_messages_for(:product_variation_item)
      end
    end
  end

  # PUT /product_variation_items/1
  def update
    @product_variation_item = ProductVariationItem.find(params[:id])

    if @product_variation_item.update_attributes(params[:product_variation_item])
      flash[:notice] = 'ProductVariationItem was successfully updated.'
      render :update do |page|
        page.reload
      end
    else
      render :update do |page|
        page[:error_message].replace_html  template_error_messages_for(:product_variation_item)
      end
    end
  end

  # DELETE /product_variation_items/1
  def destroy
    @product_variation_item = ProductVariationItem.find(params[:id])
    @product_variation_item.destroy

    redirect_to(:controller => "product_variations", :action => "edit", :id => @product_variation_item.product_variation_id)
  end
end
