module BannerConditionsHelper
  # 項目名選択肢毎に演算子選択、値の入力形式を切り替える実装をしています。
  # このメソッドでの制御は編集画面の初期表示時の入力形式を切り替えます。
  # 選択肢によって切り替える処理はcampaign/_form内のjavascriptで制御しています。
  # 初期に選択されている項目種別ごとに
  # 表示する演算子セレクトタグの表示・非表示を切り替えます。
  def select_operater_cd(f, row_id)
    result = []
    case f.object.type_key
    when :user_occupation || :user_gender || :user_prefecture || :user_country
      result << f.select(:operator_cd,{} ,:id => "operator_eql_only_#{row_id}", :style => 'display: none;', :disabled => 'disabled')
      result << f.select(:operator_cd, [[BannerCondition.operator_name_by_key(:eql),BannerCondition.operator_id_by_key(:eql)]], {} ,:id => "operator_cd_#{row_id}")
    else
      result << f.select(:operator_cd,{} ,:id => "operator_eql_only_#{row_id}")
      result << f.select(:operator_cd, [[BannerCondition.operator_name_by_key(:eql),BannerCondition.operator_id_by_key(:eql)]], {} ,:id => "operator_cd_#{row_id}", :style => 'display: none;', :disabled => 'disabled')
    end
    return result
  end


  # 初期に選択されている項目種別ごとに
  # 表示する値のinputタグの表示・非表示を切り替えます。
  def input_value(f, row_id)
    job = f.select(:value, KbnCode.find_names_by_code(KbnCode.name_div_id_by_key(:job)),{}, :id =>"value_job_#{row_id}")
    job_disable = f.select(:value, KbnCode.find_names_by_code(KbnCode.name_div_id_by_key(:job)),{}, :id =>"value_job_#{row_id}", :disabled => 'disabled', :style => 'display: none;')
    gender = f.select(:value, User.sex_options,{}, :id =>"value_gender_#{row_id}")
    gender_disable =  f.select(:value, User.sex_options,{}, :id =>"value_gender_#{row_id}", :disabled => 'disabled', :style => 'display: none;')
    prefecture = f.select(:value, Prefecture.prefecture_names('ja'),{}, :id =>"value_prefecture_#{row_id}")
    prefecture_disable = f.select(:value, Prefecture.prefecture_names('ja'),{}, :id =>"value_prefecture_#{row_id}", :disabled => 'disabled', :style => 'display: none;')
    country = f.select(:value, Country.country_list,{}, :id =>"value_country_#{row_id}")
    country_disable = f.select(:value, Country.country_list,{}, :id =>"value_country_#{row_id}", :disabled => 'disabled', :style => 'display: none;')
    nomal = f.text_field(:value, :size => 21, :maxlength => 30, :id => "value_nomal_#{row_id}")
    nomal_disable = f.text_field(:value, :size => 21, :maxlength => 30, :disabled => 'disabled', :style => 'display: none;', :id => "value_nomal_#{row_id}")

    result = []
    case f.object.type_key
    when :user_occupation
      result = [job, gender_disable, prefecture_disable, country_disable, nomal_disable]
    when :user_gender
      result = [job_disable, gender, prefecture_disable, country_disable, nomal_disable]
    when :user_prefecture
      result = [job_disable, gender_disable, prefecture, country_disable, nomal_disable]
    when :user_country
      result = [job_disable, gender_disable, prefecture_disable, country, nomal_disable]
    else
      result = [job_disable, gender_disable, prefecture_disable, country_disable, nomal]
    end
    return result
  end
end
