module CampaignEffectsHelper

  # 指定された変数（value_name）の値にしたがって、
  # 指定された行（row_id）のキャンペーン条件演算子の選択肢を切り替えるjavascriptを生成する
  def script_for_change_effect_operator_field(value_name)
    result = "switch (#{value_name}) {"
    CampaignEffect.type_keys().each do |type_key|
      result << "  case '#{CampaignEffect.type_id_by_key(type_key)}':"
      result << "    change_effect_operator_field('#{CampaignEffect.type_entry_by_key(type_key)[:operator]}');"
      result << "    break;"
    end
    result << "}"
  end

  # javascriptのメソッド（change_operator_field）を生成します
  def change_effect_operator_field_function
    result = "function change_effect_operator_field(type) {"
    CampaignEffect.type_entries.map{|v| v[:operator]}.uniq.each do |operator|
      result << "  display_effect_operator_field('#{operator.to_s}', (type == '#{operator.to_s}'));"
    end
    result << "}"
  end

  # 指定された変数（value_name）の値にしたがって、
  # 指定された場所（target_field_id）にキャンペーン効果のsuffixを表示するjavascriptを生成する
  def script_for_display_effect_suffix(target_field_id, value_name)
    result = ""
    type_keys = [:discount_percentage, :discount_price, :point, :shipping_cost]
    result << "switch (#{value_name}) {"
    type_keys.each do |type_key|
      result << "  case '#{CampaignEffect.type_id_by_key(type_key)}':"
      result << "    $('#{target_field_id}').innerHTML = '#{CampaignEffect.type_entry_by_key(type_key)[:suffix]}';"
      result << "    break;"
    end
    result << "}"
  end
  
end
