# -*- coding: utf-8 -*-
module EcRider
  module EcHelper
    module UserPasswordFormTag
      extend MethodDescription

      desc <<-EOS
        <dt>概要：</dt><dd>パスワード変更用のフォームを出力します。</dd>
      EOS
      def user_password_form(&block)
        raise UsageError, "ここでは使用できません。" unless @template.instance_variable_get(:@user)
        @template.form_for(:user, :url => {:controller => 'account', :action => :update_password}) do |f|
          @user = f
          begin
            @template.concat(@template.capture(&block))
          ensure
            @user = nil
          end
        end
      end

      desc <<-EOS
        <dt>概要：</dt><dd>パスワード変更時のエラーメッセージがあればそれを表示します。パスワード変更用のフォーム内で使用してください。</dd>
      EOS
      def user_password_form_error_messages
        @template.template_error_messages_for(:user)
      end

      desc <<-EOS
        <dt>概要：</dt><dd>新しいパスワードを入力するinputタグを出力します。パスワード変更用のフォーム内でのみ使用できます。</dd>
      EOS
      def user_password_form_password(options = {})
        raise UsageError, "ec:user_password_form_new_passwordはec:user_password_formの中で使用してください" unless @user
        options = {:maxLength => 20, :size => 12}.update(options || {})
        if options[:maxlength]
          options[:maxLength] = options[:maxlength]
	      end
        @user.password_field(:password, options)
      end

      desc <<-EOS
        <dt>概要：</dt><dd>新しいパスワード(確認用)を入力するinputタグを出力します。パスワード変更用のフォーム内でのみ使用できます。</dd>
      EOS
      def user_password_form_password_confirmation(options = {})
        raise UsageError, "ec:user_password_form_new_password_confirmationはec:user_password_formの中で使用してください" unless @user
        options = {:maxLength => 20, :size => 12}.update(options || {})
        if options[:maxlength]
          options[:maxLength] = options[:maxlength]
	      end
        @user.password_field(:password_confirmation, options)
      end
    end
  end
end
