# -*- coding: utf-8 -*-
module Goldberg
  module RolesHelper
    
    def check_in_show(site_action)
      return nil unless site_action
      @role.can_access?(site_action) ? "○" : "×"
    end
    
    def site_action_check(f, site_action, options = nil)
      return nil unless site_action
      action_id = site_action.id
      check_id = "action_check_#{action_id}"
      options = {
        :label => h(site_action.short_name),
        :id => check_id,
      }.update(options || {})
      options[:class] = (options[:class] || '') << ' ' << 'site_action_checks'
      label = options.delete(:label)
      label = site_action.display_name if label.blank?
      result = ''
      result << check_box_tag(
        "#{f.object_name}[action_ids][]", site_action.id, 
        @role.can_access?(site_action), options)
      result << "&nbsp;&nbsp;"
      result << content_tag(:label, label, :for => check_id)
      result
    end
  end
end
