module ProductCategoriesHelper
  include EcRider::ProductCategoriesHelper
  
  def list_trees(product_categories, options={:show_root => false})
    html = ""
    html << root if options[:show_root]
    return html unless product_categories.size > 0
    html << "<ul class='product_category'>\n"
    product_categories.each do |product_category|
      html << "<li>"
      html << link_to("[#{h(product_category.code)}] #{h(product_category.name_for_admin)}", {:controller => :product_categories, :action => :show, :id => product_category.id})
      html << "&nbsp;&nbsp;"
      html << "（表示順：#{product_category.display_order}）\n"
      # 子追加、削除の操作リンクを設定
      html << "&nbsp;&nbsp;"
      html << link_to("編集", {:controller => :product_categories, :action => :edit, :id => product_category.id})
      html << "&nbsp;&nbsp;"
      html << link_to("削除", {:controller => :product_categories, :action => :destroy, :id => product_category.id}, :method => :delete, :confirm => '削除してよろしいですか?')
      html << "&nbsp;&nbsp;"
      html << link_to("子要素を作成", {:controller => :product_categories, :action => :new, :parent_id => product_category.parent_id})
      if product_category.children.size > 0
        html << list_trees(product_category.children)
      end
      html << "</li>\n"
    end
    html << "</ul>\n"
  end

  def root
    html = "<ul><li>"
    html << "カテゴリTOP"
    html << "&nbsp;&nbsp;"
    html << link_to("子要素を作成", {:controller => :product_categories, :action => :new}, :class => 'action')
    html << "</li></ul>"
  end

  def options_for(product_categories, options={:clear => true, :show_root => false})
    @options = [] if options[:clear]
    @options << ["カテゴリTOP", nil] if options[:show_root]
    product_categories.each do |category|
      @options << [one_line_category_tree(category), category.id]
      if category.children.size > 0
        options_for(category.children, {:clear => false})
      end
    end
    return @options
  end

end
