# -*- coding: utf-8 -*-
module ProductDialogHelper

  def checked_if_include_product_id?(id)
    (session[:selected_product_ids] && session[:selected_product_ids].include?(id.to_s)) ? "checked='checked'" : ""
  end

  def checked_if_include_product_sku_id?(id)
    (session[:selected_product_sku_ids] && session[:selected_product_sku_ids].include?(id.to_s)) ? "checked='checked'" : ""
  end

  module Client
    def setup_product_dialog(options = nil)
      options = { 
        :name => "product_dialog"
      }.update(options || {})
      dialog_name = options[:name]
      javascript_include_tag('/ec_rider/javascripts/product_dialog.js') <<
        javascript_tag("window.#{dialog_name} = new ProductDialog('#{dialog_name}');")
    end

    def setup_product_sku_dialog(options = nil)
      options = { 
        :name => "product_sku_dialog"
      }.update(options || {})
      dialog_name = options[:name]
      javascript_include_tag('/ec_rider/javascripts/product_dialog.js') <<
        javascript_tag("window.#{dialog_name} = new ProductDialog('#{dialog_name}', {sku: true, present_only: #{(!!options[:present_only]).to_s}});")
    end
  end

  # setup_product_dialogを使用するヘルパーでは、以下のようにincludeしてください。
  # include ProductDialogHelper::Client
  include Client
end
