module ProductFaqHelper
  include ProductDialogHelper::Client

  # 配列ごとに改行した文字列を返却します。
  def array_to_string(array = [])
    array.compact.map{|value| h(value)}.join('<br/>')
  end

  #
  # バリデーションエラーメッセージ
  # キーが「locale」、値が「モデルのオブジェクト」型のハッシュ用
  # メッセージの配列を返します。
  #
  def error_messages_for_locales(hash_name)
    objects = instance_variable_get("@#{hash_name}")
    return if objects.nil? || objects.empty?

    error_messages = []
    objects.each do |locale, object|
      if locale == :common
        error_messages += object.errors.full_messages.map {|msg| content_tag(:li, "#{msg.errors.full_messages}")}
      else
        error_messages += object.errors.full_messages.map {|msg| content_tag(:li, "#{locale_for_display(locale)}: #{msg}")}
      end
    end
    return error_messages
  end

  #
  # バリデーションエラーメッセージ
  # メッセージの配列を返します。
  #
  def create_error_messages(*params)
    objects = params.collect {|object_name| instance_variable_get("@#{object_name}") }.compact
    count   = objects.inject(0) {|sum, object| sum + object.errors.count }
    unless count.zero?
      error_messages = objects.map {|object| object.errors.full_messages.map {|msg| content_tag(:li, msg) } }
      return error_messages
    end
  end

end
