# -*- coding: utf-8 -*-
module TestEnvironmentSetupHelper
  
  def test_environment_publishable?
    @last_cms_publish.nil? || [:opened, :failed].include?(@last_cms_publish.status_key)
  end

  def link_checkable?
    return false unless @last_cms_publish && [:opened, :failed].include?(@last_cms_publish.status_key)
    check = @last_cms_publish.dead_link_checks.first
    check.nil? || [:checked, :failed].include?(check.status_key)
  end
  
  def resource_detail(resource)
    text = h(resource.resource_display)
    
    case resource.resource_key
      when :cms_bind
        if resource.cms_bind.cms_page.cms_shop_page?
          link_to_without_ecr_omission(text, 
            URI.join(EcRider.config.ec_test_url, resource.cms_bind.cms_page.real_local_path).to_s, 
            :popup => true)
        else
          text
        end
      when :cms_template
        link_to_without_ecr_omission(text, EcRider.config.ec_test_url, :popup => true)
      when :product
        link_to(text, {:controller => 'product', :action => 'show', :id => resource.product_id})
      when :product_image
        link_to(text, {:controller => 'product', :action => 'show', :id => resource.product_image.product_id})
      when :product_display
        link_to(text, {:controller => 'product', :action => 'show', :id => resource.product_display.product_id})
      when :banner
        link_to(text, {:controller => 'banners', :action => 'show', :id => resource.banner_id})
      when :banner_display
        link_to(text, {:controller => 'banners', :action => 'show', :id => resource.banner_display.banner_id})
      when :shop_setting
        link_to(text, {:controller => 'ms_shop_settings', :action => 'show', :id => resource.shop_setting_id})
      else
        text
    end
  end
  
end
