module TopHelper
  include EcRider::PluginModule::Extendable

  #TODO
  # 2010.03.08 c-ishikawa
  # ApplicationHelperはプラグインで直接拡張できないので、メニューバー用のヘルパー＆タグリファレンス表示ヘルパーをここに作っています
  # Topヘルパーは本来TOPページ用のヘルパーなので、拡張可能で全てのページから呼ばれるようなヘルパーを別で作ったほうがいいかもしれません

  # メニューバーへのリンク追加
  # プラグインによる拡張用
  def added_menu_links_hash
    result = {:user => []}
  end

  # メニューバーへの追加リンク
  def added_menu_links(category)
    return unless added_menu_links_hash[category]
    added_menu_links_hash[category].join(' ')
  end

  # タグリファレンスを表示するリンクを表示する
  def link_to_tag_reference
    link_to('タグリファレンス(PC)', {:controller => 'tag_references', :action => 'tag_reference'}, {:popup => true})
  end



  # ダッシュボード用
  def print_number(value, suffix, controller, action, options = {})
    str = value.blank? ? 0 : value
    link_to("#{str}#{suffix}", options.merge({:controller => controller, :action => action}))
  end
  
  # ダッシュボード用
  def print_order_count(order_counts, status_key, free_request= false)
    tab_inclusion = Order::SearchInfo.tab_inclusion_id_by_key(:selected_one)
    status_div = OrderShipping.status_div_id_by_key(status_key)
    condition = {:test_flg => CmsPublish.target_id_by_key(:production)}
    condition[:free_request_div] = Order::SearchInfo.free_request_div_id_by_key(:with_input) if free_request
    
    value = order_counts[status_div].blank? ? 0 : order_counts[status_div]
    link_to("#{value}件", {:controller => :order, :action => :index_tab, :inclusion => tab_inclusion, :status_tab => status_div, :order_condition => condition})
  end

  # ダッシュボード用
  def print_sales(value, suffix)
    tab_inclusion = Order::SearchInfo.tab_inclusion_id_by_key(:after_selected)
    status_div = OrderShipping.status_div_id_by_key(:delivered)
    condition = {:test_flg => CmsPublish.target_id_by_key(:production)}
    
    str = value.blank? ? 0 : value
    link_to("#{str}#{suffix}", {:controller => :order, :action => :index_tab, :inclusion => tab_inclusion, :status_tab => status_div, :order_condition => condition})
  end
end
