module UserPointHelper
  
  # 配列で渡ってきたオブジェクトのエラーメッセージを表示します
  def template_error_messages_for_array(user_points = [])
    all_error_messages = []
    error_messages = []
    error_count = 0
    user_points.each do |user_point|
      unless user_point.errors.count.zero?
        error_messages << user_point.errors.full_messages
      end
      error_count = error_count + user_point.errors.count
    end
    unless error_count.zero?
      error_messages.each {|msg| all_error_messages << content_tag(:li, msg) }
      if all_error_messages.size > 0
        render :partial => "common/error_messages_for", :locals => {:messages => all_error_messages}
      end
    end
  end

  #
  def text_field_tag_for_inactive_point(user_point)
    # 仮ポイントの場合書き込み可能とする
    if user_point.inactive_flg
      value = user_point.given_point
      disabled = {}
    else
      value = ""
      disabled = {:disabled => "disabled"}
    end
    return text_field_tag('user_points[' + user_point.id.to_s + '][given_point]', value, {:size => 10, :style => "ime-mode: disabled "}.update(disabled))
  end

  # 発行ポイントの場合書き込み可能とする
  def text_field_tag_for_given_point(user_point)
    # 仮ポイントの場合書き込み可能とする
    unless user_point.inactive_flg
      value = user_point.given_point
      disabled = {}
    else
      value = ""
      disabled = {:disabled => "disabled"}
    end
    return text_field_tag('user_points[' + user_point.id.to_s + '][given_point]', value, {:size => 10, :style => "ime-mode: disabled "}.update(disabled))
  end
end
