# -*- coding: utf-8 -*-
class BannerDisplay < ActiveRecord::Base
  belongs_to :banner

  attr_accessor :image_file # upload_file
  attr_writer :type_key # Banner#type_keyをsave前にコピーしておくための属性

  validates_presence_of :locale

  validates_presence_of :image_file, :if => lambda{|r| r.type_key == :image && r.image_public_path.blank?}
  validates_presence_of :text_title, :text_description, :if => lambda{|r| r.type_key == :text}

  before_save :save_image_file

# 不要になったのでコメントアウト
#  selectable_attr :text_category_cd do
#    entry '01', :greeting, 'あいさつ'
#    entry '02', :memorial, '記念日'
#    entry '03', :purchase, '購入履歴'
#    entry '04', :advice  , 'アドバイス'
#    entry '05', :notice  , 'お知らせ'
#    entry '06', :others  , 'その他'
#  end

  def type_key
    (banner ? banner.type_key : nil) || @type_key
  end


  def useless?
    return false if locale == I18n.default_locale.to_s
    case type_key
    when :image then
      image_file.blank?
    when :text then
      text_description.blank?
    end
  end


  def save_image_file
    return unless image_file
     self.image_public_path = build_image_public_path
     path = File.join(EcRider.config.ec_admin_root, "public", path_from_ec_admin_public)
     logger.info("saving a banner image to #{path}")
     open(path, 'w') do |f|
       f.write(image_file.read)
     end
     # cloudfrontにバナー画像をupload
     targets = [self.image_public_path]
 	   timestamp = Time.now.strftime(ENV['ECR_TIMESTAMP'] || ::EcRider::CloudFront::CLOUD_FRONT_VERSION_FORMAT)
 	   s3 = Object.new
 	   s3.extend(::EcRider::CloudFront)
 	   s3.create_and_upload_to_s3(targets, :timestamp => timestamp)
   end

   def path_from_ec_admin_public
     File.join("/ec_rider", self.image_public_path)
   end

   private

   def build_image_public_path
     ext = File.extname(image_file.original_filename)
     locale_str = (locale.to_s == I18n.default_locale.to_s) ? '' : '_' << locale.to_s
     'banner_images/banner_%010d%s%s' % [self.banner_id, locale_str, ext]
   end


 end
