# -*- coding: utf-8 -*-
class ProductImage < ActiveRecord::Base
  versioned

  belongs_to :product
  
  has_attachment :content_type => :image,
    :storage => :file_system,
    :max_size => 10.megabyte,
    :processor => :rmagick, # これがないとImageScienceがインストールされている環境ではサムネイルの拡張子が.gifから.pngになってしまいます
    :thumbnails => { :thumb => '150x150>',:large => '320x320>',:medium => '140x140>'  ,:small => '46x46>'},
    :path_prefix => "public/ec_rider/#{table_name}"
  
  #validates_as_attachment

  before_create :update_display_order

  validates_presence_of :filename
  #
  # = 同じプロジェクトIDの画像について、表示順とメイン画像フラグを更新します =
  #
  def update_same_product_id_images
    product_images = ProductImage.find(:all, :conditions =>["product_id = ? and id != ?", self.product_id, self.id], :order => :display_order)
    product_images.each_with_index { |product_image, index|
      product_image.update_attributes(:display_order => index + 1)
      product_images.first.update_attributes(:main_flg => true) if index == 0 and self.main_flg == true
    }
  end

  def update_display_order
    self.display_order = ProductImage.count(:conditions => ["parent_id IS NULL AND product_id = ?", self.product_id]) + 1
  end

  #
  # = ファイルパスを指定してサムネイルを作成します =
  #
  def create_thumbnails(file_path)
    attachment_options[:thumbnails].each { |suffix, size| create_or_update_thumbnail(file_path, suffix, *size) }
  end
end
