require 'goldberg'

module Goldberg
  class RoleAction < ActiveRecord::Base
    versioned

    include Goldberg::Model

    belongs_to :role, :class_name => 'Goldberg::Role', :foreign_key => 'role_id'
    belongs_to :action, :class_name => 'Goldberg::SiteAction', :foreign_key => 'site_action_id'

    # 「システム管理者」にすべての権限を与える
    def self.authorize_for_system_admin
      transaction do
        role = Goldberg::Role.find_by_name('システム管理者')
        action_ids = Goldberg::SiteAction.connection.select_values("select id from goldberg_site_actions order by id")
        Goldberg::RoleAction.destroy_all(["site_action_id not in (?)", action_ids])
        role.action_ids = action_ids
        role.save!
      end
    end
  end
end
