# -*- coding: utf-8 -*-
# Settings specified here will take precedence over those in config/environment.rb

# config.gem "rspec", :version => '1.1.12'
# config.gem "rspec-rails", :version => '1.1.12'
config.gem "rcov", :version => '0.8.1.2.0'


# In the development environment your application's code is reloaded on
# every request.  This slows down response time but is perfect for development
# since you don't have to restart the webserver when you make code changes.
config.cache_classes = false

# Log error messages when you accidentally call methods on nil.
config.whiny_nils = true

# Enable the breakpoint server that script/breakpointer connects to
# config.breakpoint_server = true

# Show full error reports and disable caching
config.action_controller.consider_all_requests_local = true
config.action_controller.perform_caching             = false # perform_cachingがfalseだとfragmentキャッシュが聞かないけど、ビューの自動ロードも効かなくなるので、仕方なくfalseにしました。
# config.action_view.cache_template_loading            = true # app/views/layouts/_menu_bar が激遅なので、キャッシュを聞かせておきます。
# config.action_view.cache_template_extensions         = false
config.action_view.debug_rjs                         = true

# Disable delivery errors, bad email addresses will be ignored
# config.action_mailer.raise_delivery_errors = false
# trueならばメール送信エラー時には例外を発生します。
config.action_mailer.raise_delivery_errors = true

# Tell ActionMailer not to deliver emails to the real world.
# The :test delivery method accumulates sent emails in the
# ActionMailer::Base.deliveries array.
config.action_mailer.delivery_method = :smtp
config.action_mailer.smtp_settings = {
  :address => "smtpserver",
  :port => 25,
  :domain => "smtpserver"

  #:address => "smtp.gmail.com",
  #:port => 587,
  #:domain => "localhost",
  #:user_name => "xxxxx@gmail.com",
  #:password => "xxxxx",
  #:authentication => :plain
}

EcRider.config.default_ec_admin_url = "http://localhost:3000"
EcRider.config.default_ec_front_url = "http://localhost:3001"


###############################
# CSV出力ファイルの保存先情報
###############################
EcRider.config.csv_dir = File.join(RAILS_ROOT, 'tmp', 'csv')

GRUFF_FONT = File.expand_path('msgothic.ttc', RAILS_ROOT)

# 簡体字の入力・DB更新を許すか否か
# trueの場合、簡体字のバリデーションを付与
# falseの場合、英数字のみの入力、簡体字のバリデーションは外します。
EcRider.config.chinese_format_using = true

# # Bulletの設定
# #  Bullet: 不要なクエリーやfindの:includeが足らないことをログに出力して教えてくれるgem
# config.after_initialize do
#   Bullet.enable = true 
#   Bullet.bullet_logger = true  
#   Bullet.console = true
#   Bullet.rails_logger = true
#   Bullet.disable_browser_cache = true
#   begin
#     require 'ruby-growl'
#     Bullet.growl = true
#   rescue MissingSourceFile
#     Bullet.alert = true
#   end
# end
