# -*- coding: utf-8 -*-
# Settings specified here will take precedence over those in config/environment.rb

config.gem "capistrano", :version => '2.5.3'


# The production environment is meant for finished, "live" apps.
# Code is not reloaded between requests
config.cache_classes = true

# Use a different logger for distributed setups
# config.logger = SyslogLogger.new

# Full error reports are disabled and caching is turned on
config.action_controller.consider_all_requests_local = false
config.action_controller.perform_caching             = true

# Enable serving of images, stylesheets, and javascripts from an asset server
# config.action_controller.asset_host                  = "http://assets.example.com"

# Disable delivery errors, bad email addresses will be ignored
# config.action_mailer.raise_delivery_errors = false
config.action_mailer.raise_delivery_errors = true

# Tell ActionMailer not to deliver emails to the real world.
# The :test delivery method accumulates sent emails in the
# ActionMailer::Base.deliveries array.

config.action_mailer.delivery_method = :sendmail
config.action_mailer.smtp_settings = {
   :location       => '/usr/sbin/sendmail',
   :arguments      => '-i -t'
}

#config.action_mailer.delivery_method = :smtp
#config.action_mailer.smtp_settings = {
#  :address => "localhost",
#  :port => 25,
#  :domain => "localhost"
#}


# 簡体字の入力・DB更新を許すか否か
# trueの場合、簡体字のバリデーションを付与
# falseの場合、英数字のみの入力、簡体字のバリデーションは外します。
EcRider.config.chinese_format_using = true