#!/bin/bash
# Auto registration host to zabbix server on start/stop.
#
### BEGIN INIT INFO
# Provides:          ec_rider
# Required-Start:    $local_fs $network
# Required-Stop:     $local_fs $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: 
# Description:       Auto registration host to zabbix server on start/stop.
### END INIT INFO

. /lib/lsb/init-functions

case "$1" in
start ) log_daemon_msg "Starting auto registration to zabbix server" "zabbix-register"
        /etc/zabbix-register/zabbix-register.rb -A
        log_end_msg $?
      ;;
stop)   log_daemon_msg "Starting auto de-registration to zabbix server" "zabbix-register"
        /etc/zabbix-register/zabbix-register.rb -R
        log_end_msg $?
      ;;
*)
      echo "Usage: /etc/init.d/zabbix-register.sh [start|stop]" >&2
      exit 2
      ;;
esac
