class RemoveBraceCountFromCampaignConditions < ActiveRecord::Migration
  def self.up
    change_table(:campaign_conditions) do |t|
      t.remove :connector_cd
      t.remove :brace_begin_count
      t.remove :brace_end_count
    end
  end

  def self.down
    change_table(:campaign_conditions) do |t|
        t.string   "connector_cd",      :limit => 2,   :null => false, :comment => "接続演算子"
        t.integer  "brace_begin_count",                :null => false, :comment => "開始括弧数"
        t.integer  "brace_end_count",                  :null => false, :comment => "終了括弧数"
    end
  end
end
