class CreateAccountingDownloadPatternData < ActiveRecord::Migration
  class CreateAccountingDownloadPatternData::CsvDownloadPattern < ActiveRecord::Base
    has_many :items, :class_name => "CreateAccountingDownloadPatternData::CreateAccountingDownloadPatternData::CsvDownloadPatternItem", :foreign_key => 'csv_download_pattern_id', :order => 'csv_download_pattern_items.display_order'
    has_one :accounting_condition, :class_name => "CreateAccountingDownloadPatternData::CreateAccountingDownloadPatternData::CsvDownloadPatternAccountingCondition", :foreign_key => 'csv_download_pattern_id'
  end
  class CreateAccountingDownloadPatternData::CsvDownloadPatternItem < ActiveRecord::Base
  end
  class CreateAccountingDownloadPatternData::CsvDownloadPatternAccountingCondition < ActiveRecord::Base
  end
  def self.up
    CreateAccountingDownloadPatternData::CsvDownloadPattern.transaction do
      # 勘定奉行ｉ
      csv_download_pattern = CreateAccountingDownloadPatternData::CsvDownloadPattern.new(:download_type => "11", :name => "勘定奉行i", :character_code => "1", :file_name => "kanjyobugyo_i")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "*", :display_order => "0", :name => "勘定奉行ｉ")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "1", :name => "伝票区分コード")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "2", :name => "用途区分")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "3", :name => "部門指定方法")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "4", :name => "伝票部門コード")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "500", :display_order => "5", :name => "伝票日付(配送済み・キャンセル完了日付(yyyy/mm/dd))")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "6", :name => "整理区分")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "7", :name => "伝票No.")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "8", :name => "伝票入力形式")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "9", :name => "借方部門コード")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "503", :display_order => "10", :name => "借方勘定科目コード(勘定奉行)")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "11", :name => "借方補助科目コード")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "12", :name => "借方税区分コード")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "13", :name => "借方税率区分コード")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "14", :name => "借方事業区分コード")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "15", :name => "借方消費税計算")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "16", :name => "借方端数処理")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "17", :name => "借方取引先コード")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "505", :display_order => "18", :name => "借方金額")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "19", :name => "借方消費税金額")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "20", :name => "貸方部門コード")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "506", :display_order => "21", :name => "貸方勘定科目コード(勘定奉行)")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "22", :name => "貸方補助科目コード")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "23", :name => "貸方税区分コード")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "24", :name => "貸方税率区分コード")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "25", :name => "貸方事業区分コード")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "26", :name => "貸方消費税自動計算")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "27", :name => "貸方端数処理")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "28", :name => "貸方取引先コード")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "508", :display_order => "29", :name => "貸方金額")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "30", :name => "貸方消費税金額")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "509", :display_order => "31", :name => "摘要")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "32", :name => "付箋色")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000", :value => "", :display_order => "33", :name => "付箋文字列")
      csv_download_pattern.accounting_condition = CreateAccountingDownloadPatternData::CsvDownloadPatternAccountingCondition.new(:none_output_data => "0", :previous_point => "0")
      csv_download_pattern.save_with_validation(false) # valueの整合性チェックがあるが、整合性が取れた状態のデータから直接作成するためバリデーションチェックをしません。

      # 勘定奉行21
      csv_download_pattern = CreateAccountingDownloadPatternData::CsvDownloadPattern.new(:download_type => "11", :name => "勘定奉行21", :character_code => "1", :file_name => "kanjyobugyo21")
      csv_download_pattern.accounting_condition = CreateAccountingDownloadPatternData::CsvDownloadPatternAccountingCondition.new(:none_output_data => "0", :previous_point => "0")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "*", :display_order => "0", :name => "伝票区切"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "", :display_order => "1", :name => "決算処理フラグ"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "501", :display_order => "2", :name => "伝票日付(配送済み・キャンセル完了日付(yymmdd))"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "", :display_order => "3", :name => "伝票番号"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "", :display_order => "4", :name => "部門コード"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "503", :display_order => "5", :name => "借方勘定科目コード(勘定奉行)"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "", :display_order => "6", :name => "借方補助科目コード"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "505", :display_order => "7", :name => "借方金額"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "", :display_order => "8", :name => "借方消費税金額"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "", :display_order => "9", :name => "借方消費税計算区分"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "", :display_order => "10", :name => "借方税区分"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "", :display_order => "11", :name => "借方事業区分"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "", :display_order => "12", :name => "部門コード"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "506", :display_order => "13", :name => "貸方勘定科目コード(勘定奉行)"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "", :display_order => "14", :name => "貸方補助科目コード"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "508", :display_order => "15", :name => "貸方金額"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "", :display_order => "16", :name => "貸方消費税金額"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "", :display_order => "17", :name => "貸方消費税計算区分"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "", :display_order => "18", :name => "貸方税区分"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "", :display_order => "19", :name => "貸方事業区分"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "509", :display_order => "20", :name => "摘要"	)
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(	:code => "000", :value => "0x0d,0x0a", :display_order => "21", :name => "仕訳明細の区切")
      csv_download_pattern.save_with_validation(false) # valueの整合性チェックがあるが、整合性が取れた状態のデータから直接作成するためバリデーションチェックをしません。

      # 弥生会計
      csv_download_pattern = CreateAccountingDownloadPatternData::CsvDownloadPattern.new(:download_type => "11", :name => "弥生会計", :character_code => "1", :file_name => "yayoi")
      csv_download_pattern.accounting_condition = CreateAccountingDownloadPatternData::CsvDownloadPatternAccountingCondition.new(:none_output_data => "0", :previous_point => "0")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "2111",:display_order => "0",:name => "識別フラグ")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "",:display_order => "1",:name => "伝票No.")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "",:display_order => "2",:name => "決算")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "502",:display_order => "3",:name => "伝票日付(配送済み・キャンセル完了日付(yyyymmdd))")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "504",:display_order => "4",:name => "借方勘定科目名称（弥生）")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "",:display_order => "5",:name => "借方補助科目")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "",:display_order => "6",:name => "借方部門")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "課税売上内",:display_order => "7",:name => "借方税区分")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "505",:display_order => "8",:name => "借方金額")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "",:display_order => "9",:name => "借方税金額")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "507",:display_order => "10",:name => "貸方勘定科目名称（弥生）")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "",:display_order => "11",:name => "貸方補助科目")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "",:display_order => "12",:name => "貸方部門")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "課税売上内",:display_order => "13",:name => "貸方税区分")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "508",:display_order => "14",:name => "貸方金額")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "",:display_order => "15",:name => "貸方税金額")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "509",:display_order => "16",:name => "摘要")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "",:display_order => "17",:name => "番号")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "",:display_order => "18",:name => "期日")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "0",:display_order => "19",:name => "タイプ")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "",:display_order => "20",:name => "生成元")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "",:display_order => "21",:name => "仕訳メモ")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "",:display_order => "22",:name => "付箋1")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "",:display_order => "23",:name => "付箋2")
      csv_download_pattern.items << CreateAccountingDownloadPatternData::CsvDownloadPatternItem.new(:code => "000",:value => "",:display_order => "24",:name => "調整")
      csv_download_pattern.save_with_validation(false) # valueの整合性チェックがあるが、整合性が取れた状態のデータから直接作成するためバリデーションチェックをしません。
    end
  end

  def self.down
    patterns = CreateAccountingDownloadPatternData::CsvDownloadPattern.find(:all, :conditions => ["download_type = ?", "11"])
    CreateAccountingDownloadPatternData::CsvDownloadPattern.transaction do
      patterns.each do |pattern|
        pattern.items.each{|item| item.destroy}
        pattern.items.clear
        pattern.accounting_condition.destroy
        pattern.accounting_condition = nil
        pattern.destroy
      end
    end
  end
end
