class DropViewPaymentErrorHistories < ActiveRecord::Migration
  class ViewPaymentErrorHistory < ActiveRecord::Base
  end

  def self.up
    exist_view = DropViewPaymentErrorHistories::ViewPaymentErrorHistory.table_exists?

    if exist_view
      ActiveRecord::Base.connection.execute('drop view view_payment_error_histories;')
    end
  end

  def self.down
    ActiveRecord::Base.connection.execute(<<-EOS)
      CREATE
      or REPLACE VIEW `view_payment_error_histories` AS
      select
      `sph`.`order_id` AS `order_id`,
      `srh`.`sps_order_id` AS `payment_code`,
      NULL AS `approve`,
      `srh`.`tracking_id` AS `tran_id`,
      `srh`.`res_date` AS `tran_date`,
      NULL AS `check_string`,
      `srh`.`res_result` AS `err_code`,
      `srh`.`ecr_result` AS `err_info`,
      `srh`.`created_at` AS `created_at`,
      `srh`.`updated_at` AS `updated_at`,
      `srh`.`deleted_at` AS `deleted_at`,
      `srh`.`lock_version` AS `lock_version`,
      NULL AS `online_payment_batch_exe_id`,
      `srh`.`status_div` AS `status_div`,
      NULL AS `exe_div`,
      _utf8'2' AS `payment_system_div`,
      _utf8'2' AS `payment_div`,
      `srh`.`id` AS `updatable_id`,
      _utf8'SpsResultHistory' AS `updatable_type`,
      `sut`.`id` AS `sps_user_temporary_id`,
      `srh`.`test_flg` AS `test_flg`
      from
      ((`sps_result_histories` `srh` join `sps_parameter_histories` `sph` on((`sph`.`id` = `srh`.`sps_parameter_history_id`)))
      left join `sps_user_temporaries` `sut` on((`sut`.`sps_order_id` = `srh`.`sps_order_id`)))
      where
      ((`srh`.`ecr_result` like _utf8'NG%')
      or (`srh`.`res_result` like _utf8'NG%'))
    EOS
  end
end
