class ChangeColumnSizeForPerformance < ActiveRecord::Migration
  def self.up
    change_column :accountings, :credit_account_div, :string, :limit => 3, :comment => '貸方勘定項目区分'
    change_column :accountings, :debt_account_div, :string, :limit => 3, :comment => '借方勘定項目区分'

    change_column :campaign_effects, :type_cd, :string, :limit => 2, :comment => '効果種別'
    change_column :campaign_effects, :operator_cd, :string, :limit => 2, :comment => '演算子'
    change_column :campaign_effects, :value, :string, :limit => 100, :comment => '値'

    change_column :cms_bind_items, :no, :string, :limit => 3, :comment => 'バインド番号'

    change_column :cms_dead_link_resources, :locale, :string, :limit => 5, :comment => 'ロケール'

    change_column :cms_default_templates, :default_template_position, :string, :limit => 1, :comment => 'デフォルトテンプレート表示位置'
    change_column :cms_default_templates, :terminal, :string, :limit => 1, :comment => '端末(0: PC, 1:携帯)'

    change_column :cms_pages, :terminal, :string, :limit => 1, :comment => '端末(0: PC, 1:携帯)'
    change_column :cms_pages, :controller, :string, :limit => 30, :comment => 'コントローラ名'
    change_column :cms_pages, :action, :string, :limit => 30, :comment => 'アクション'

    change_column :cms_project_approvals, :result_cd, :string, :limit => 1, :comment => '結果'

    change_column :cms_projects, :acceptance_type, :string, :limit => 1, :comment => '承認経路'

    change_column :cms_templates, :display_position, :string, :limit => 1, :comment => '表示可能位置(0: 上, 1:下, 2:左, 3:右, 4:中央, 5:右または左)'
    change_column :cms_templates, :terminal, :string, :limit => 1, :comment => '端末(0: PC, 1:携帯)'

    change_column :countries, :use_language_div, :string, :limit => 2, :comment => '対応言語'
    change_column :countries, :name_order_div, :string, :limit => 1, :comment => '姓名の並び順区分'
    change_column :countries, :address_order_div, :string, :limit => 1, :comment => '住所の並び順区分'

    change_column :csv_download_patterns, :character_code, :string, :limit => 2, :comment => ''
    
    change_column :csv_file_download_histories, :character_code, :string, :limit => 2, :comment => '文字コード'

    change_column :orders, :sender_name_first, :string, :limit => 30, :comment => '送り主 名'
    change_column :orders, :sender_name_last, :string, :limit => 30, :comment => '送り主 姓'
    change_column :orders, :sender_country_code, :string, :limit => 3, :comment => '送り主 国'
    change_column :orders, :sender_zip_code, :string, :limit => 15, :comment => '送り主 郵便番号'
    change_column :orders, :sender_address_1, :string, :limit => 45, :comment => '送り主 都道府県'
    change_column :orders, :sender_address_2, :string, :limit => 90, :comment => '送り主 市区町村町域'
    change_column :orders, :sender_address_3, :string, :limit => 90, :comment => '送り主 番地・マンション名'
    change_column :orders, :sender_tel_num, :string, :limit => 20, :comment => '送り主 電話番号'

    change_column :prefecture_displays, :locale, :string, :limit => 5, :comment => '言語コード'

    change_column :prefectures, :code, :string, :limit => 2, :comment => '都道府県コード'

    change_column :product_images, :content_type, :string, :limit => 30, :comment => 'コンテンツの種類'
    change_column :product_images, :thumbnail, :string, :limit => 10, :comment => 'サムネイルの種類'

    change_column :product_skus, :jan_code, :string, :limit => 22, :comment => 'JANコード'
    change_column :product_skus, :shelf_no, :string, :limit => 50, :comment => '棚番'
    change_column :product_skus, :stockout_display_cd, :string, :limit => 5, :comment => '在庫切れ時の表示'

    change_column :product_variation_items, :code, :string, :limit => 2, :comment => 'コード'

    change_column :shipping_costs, :area_type_div, :string, :limit => 1, :comment => '地域区分'
    change_column :shipping_costs, :area_code, :string, :limit => 5, :comment => '地域コード'

    change_column :users, :kana_name_last, :string, :limit => 30, :comment => 'フリガナ（姓）'
    change_column :users, :kana_name_first, :string, :limit => 30, :comment => 'フリガナ（名）'
  end

  def self.down
    change_column :accountings, :credit_account_div, :string, :comment => '貸方勘定項目区分'
    change_column :accountings, :debt_account_div, :string, :comment => '借方勘定項目区分'

    change_column :campaign_effects, :type_cd, :string, :comment => '効果種別'
    change_column :campaign_effects, :operator_cd, :string, :comment => '演算子'
    change_column :campaign_effects, :value, :string, :comment => '値'

    change_column :cms_bind_items, :no, :string, :comment => 'バインド番号'

    change_column :cms_dead_link_resources, :locale, :string, :comment => 'ロケール'

    change_column :cms_default_templates, :default_template_position, :string, :comment => 'デフォルトテンプレート表示位置'
    change_column :cms_default_templates, :terminal, :string, :comment => '端末(0: PC, 1:携帯)'

    change_column :cms_pages, :terminal, :string, :comment => '端末(0: PC, 1:携帯)'
    change_column :cms_pages, :controller, :string, :comment => 'コントローラ名'
    change_column :cms_pages, :action, :string, :comment => 'アクション'

    change_column :cms_project_approvals, :result_cd, :string, :comment => '結果'

    change_column :cms_projects, :acceptance_type, :string, :comment => '承認経路'

    change_column :cms_templates, :display_position, :string, :comment => '表示可能位置(0: 上, 1:下, 2:左, 3:右, 4:中央, 5:右または左)'
    change_column :cms_templates, :terminal, :string, :comment => '端末(0: PC, 1:携帯)'

    change_column :countries, :use_language_div, :string, :comment => '対応言語'
    change_column :countries, :name_order_div, :string, :comment => '姓名の並び順区分'
    change_column :countries, :address_order_div, :string, :comment => '住所の並び順区分'

    change_column :csv_download_patterns, :character_code, :string, :comment => ''

    change_column :csv_file_download_histories, :character_code, :string, :comment => '文字コード'

    change_column :orders, :sender_name_first, :string, :comment => '送り主 名'
    change_column :orders, :sender_name_last, :string, :comment => '送り主 姓'
    change_column :orders, :sender_country_code, :string, :comment => '送り主 国'
    change_column :orders, :sender_zip_code, :string, :comment => '送り主 郵便番号'
    change_column :orders, :sender_address_1, :string, :comment => '送り主 都道府県'
    change_column :orders, :sender_address_2, :string, :comment => '送り主 市区町村町域'
    change_column :orders, :sender_address_3, :string, :comment => '送り主 番地・マンション名'
    change_column :orders, :sender_tel_num, :string, :comment => '送り主 電話番号'

    change_column :prefecture_displays, :locale, :string, :comment => '言語コード'

    change_column :prefectures, :code, :string, :comment => '都道府県コード'

    change_column :product_images, :content_type, :string, :comment => 'コンテンツの種類'
    change_column :product_images, :thumbnail, :string, :comment => 'サムネイルの種類'

    change_column :product_skus, :jan_code, :string, :comment => 'JANコード'
    change_column :product_skus, :shelf_no, :string, :comment => '棚番'
    change_column :product_skus, :stockout_display_cd, :string, :comment => '在庫切れ時の表示'

    change_column :product_variation_items, :code, :string, :comment => 'コード'

    change_column :shipping_costs, :area_type_div, :string, :comment => '地域区分'
    change_column :shipping_costs, :area_code, :string, :comment => '地域コード'

    change_column :users, :kana_name_last, :string, :comment => 'フリガナ（姓）'
    change_column :users, :kana_name_first, :string, :comment => 'フリガナ（名）'
  end
end
