# -*- coding: utf-8 -*-
module EcrMobile
  module EcHelper
    
    module OrderHistoryTag
      extend ::EcRider::EcHelper::MethodDescription

      desc <<-EOS
        [概要:キャンセル依頼確認ボタンを出力します。ボタンとして表示したい文字列や画像を囲んで使用します。ec:order_history_list内で使用してください。
        [引数 inputタグのHTML属性(任意)]
        [戻り値:キャンセル確認を行うsubmitボタン]]
        [使用例:
           {{{
           <ec:order_history_list>
             <ec:button_for_order_cancel/>
           </ec:order_history_list>
           ⇒ <input type="submit" value="キャンセル依頼" onclick="return cancel_confirm()" name="commit"/>
           }}}
        ]
      EOS
      def button_for_confirm_order_cancel(*args, &block)
        raise ::EcRider::EcHelper::UsageError, "ec:order_cancel_statusはec:order_history_listの中で使用してください" unless @order
        text = @template.capture(&block) if block_given?

        @template.form_tag(:controller => 'member', :action => :confirm_cancel) do
          @template.concat(@template.hidden_field_tag(:id, @order.id))
          @template.concat(@template.hidden_field_tag(:ques, @template.instance_variable_get(:@ques)))
          options ||= {}
          result = @template.submit_tag(text, options) if block_given?
          @template.concat(result) if result && block_given?
        end
      end

      desc <<-EOS
        [概要:キャンセル依頼ボタンを出力します。ボタンとして表示したい文字列や画像を囲んで使用します。
        [引数 inputタグのHTML属性(任意)]
        [戻り値:キャンセル処理を行うsubmitボタン]]
        [使用例:
           {{{
             <ec:button_for_order_cancel/>
           ⇒ <input type="submit" value="キャンセル依頼" onclick="return cancel_confirm()" name="commit"/>
           }}}
        ]
      EOS
      def button_for_order_cancel(*args, &block)
        text = @template.capture(&block) if block_given?
        @template.form_tag(:controller => 'member', :action => :request_cancel) do
          @template.concat(@template.hidden_field_tag(:id, @order.id))
          @template.concat(@template.hidden_field_tag(:ques, @template.instance_variable_get(:@ques)))
          options ||= {}
          result = @template.submit_tag(text, options) if block_given?
          @template.concat(result) if result && block_given?
        end
      end
    end

  end
end

