# -*- coding: utf-8 -*-
module EcrMobile
  module EcHelper

    module ReminderFormTag
      extend ::EcRider::EcHelper::MethodDescription

      desc <<-EOS
        [概要:リマインダー変更用のフォーム（秘密の質問、新パスワード入力画面）を出力します。]
        [引数:なし]
        [使用例:
           {{{
           <ec:reminder_form>
             <ec:reminder_form_remember_question />
             <ec:reminder_form_remember_answer/>
           </ec:reminder_form>
           }}}
        ]
      EOS
      def reminder_form(&block)
        raise ::EcRider::EcHelper::UsageError, "ここでは使用できません。" unless @template.instance_variable_get(:@reminder_form)
        @template.form_for(:reminder_form, :url => {:controller => 'reminder', :action => :reminder_completion}) do |f|
          @reminder_form = f
          @template.concat(@reminder_form.hidden_field(:completion_url_controller))
          @template.concat(@reminder_form.hidden_field(:completion_url_action))
          @template.concat(@reminder_form.hidden_field(:email))
          begin
            @template.concat(@template.capture(&block))
          ensure
            @reminder_form = nil
          end
        end
      end

      desc <<-EOS
        [概要:リマインダー変更用のフォーム（メールアドレス入力画面）を出力します。]
        [引数:なし]
        [使用例:
           {{{
           <ec:reminder_mail_form>
             <ec:reminder_form_email />
           </ec:reminder_mail_form>
           }}}
        ]
      EOS
      def reminder_mail_form(&block)
        raise ::EcRider::EcHelper::UsageError, "ここでは使用できません。" unless @template.instance_variable_get(:@reminder_form)
        @template.form_for(:reminder_form, :url => {:controller => 'reminder', :action => :reminder_question}) do |f|
          @reminder_form = f
          @template.concat(@reminder_form.hidden_field(:completion_url_controller))
          @template.concat(@reminder_form.hidden_field(:completion_url_action))
          begin
            @template.concat(@template.capture(&block))
          ensure
            @reminder_form = nil
          end
        end
      end
    end
  end
end
