# -*- coding: utf-8 -*-
class M0001CreateUserMobiles < ActiveRecord::Migration
  class UserMobile < ActiveRecord::Base
  end

  def self.up
    unless M0001CreateUserMobiles::UserMobile.table_exists?
      create_table "user_mobiles", :force => true, :comment => '会員モバイル機器' do |t|
        t.integer  "user_id",                                         :comment => "会員ID"
        t.string "unique_id", :limit => 32,                          :comment => "固有ID（SIM等の識別コード）"
        t.timestamps
        t.datetime "deleted_at",                                      :comment => ""
        t.integer  "lock_version",                   :default => 0,   :comment => ""
        t.integer  "creator_id",                                      :comment => "データ登録者"
        t.integer  "updater_id",                                      :comment => "データ更新者"
        t.integer  "deleter_id",                                      :comment => "データ削除者"
      end
      
      add_index "user_mobiles", ["unique_id"], :name => "index_user_mobiles_on_unique_id"
    end
  end

  def self.down
    if M0001CreateUserMobiles::UserMobile.table_exists?
      drop_table "user_mobiles"
    end
  end
end
