module EcrMobileAdmin
  module ApplicationHelperExtentionExt
    #
    # act_as_mobileというパラメータが渡された場合は、ボタンではなくリンクを表示します
    #
    def button_to_url_with_ecr_mobile_admin(name, url_options = {}, html_options = {})
      # CMSのプレビューでフロント用のURLが渡されることもある。Routeマッチングしない。
      if url_options.is_a?(String)
        url_options = {:href => url_options}
      end
      if params[:act_as_mobile]
        url_options = {:controller => 'cms', :action => ShopSetting.get_setting(:top_action, I18n.locale)} if url_options.blank?
        url = url_for(url_options)

        link_to(name, url, html_options)
      else
        button_to_url_without_ecr_mobile_admin(name, url_options, html_options)
      end
    end

    #
    # = モバイルでは、button_to_remoteはリンク(link_to_remote)を描画します =
    #
    def button_to_remote(name, options = {}, html_options = {})
      if params[:act_as_mobile]
        link_to_remote(name, options, html_options)
      else
        # オリジナルのbutton_to_remoteと同じ動きにする
        button_to_function(name, remote_function(options), html_options)
      end
    end

  end
end
