require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe ApplicationHelper do

  describe "act_as_mobile" do
    it "モバイル仕様の場合はbutton_to_urlをリンクで描画する" do
      params[:act_as_mobile] = true
      tag = helper.button_to_url('テスト', '/top/index', {:class => 'test1'})
      expected = %{<a href=\"/top/index\" class=\"test1\">テスト</a>}
      tag.should == expected
    end

    it "モバイル仕様の場合はbutton_to_remoteをリンクで描画する" do
      params[:act_as_mobile] = true
      tag =  helper.button_to_remote('テスト', {:url => '/top/index'}, {:class => 'test1'})
      expected = %{<a class=\"test1\" href=\"#\" onclick=\"new Ajax.Request('/top/index', {asynchronous:true, evalScripts:true}); return false;\">テスト</a>}
      tag.should == expected
    end
  end

  describe "for pc" do
    it "通常はbutton_to_urlをボタンで描画する" do
      tag = helper.button_to_url('テスト', '/top/index', {:class => 'test1'})
      expected = %{<input class=\"test1\" onclick=\"location.href='/top/index';\" type=\"button\" value=\"テスト\" />}
      tag.should == expected
    end

    it "通常はbutton_to_remoteをボタンで描画する" do
      tag =  helper.button_to_remote('テスト', {:url => '/top/index'}, {:class => 'test1'})
      expected = %{<input class=\"test1\" onclick=\"new Ajax.Request('/top/index', {asynchronous:true, evalScripts:true});\" type=\"button\" value=\"テスト\" />}
      tag.should == expected
    end
  end

end
