module EcrMobileFront
  module SessionStoreExt
    def self.included(base)
      base.class_eval do
        # reset_session用のパッチを当てます。
        # 参照：http://groups.google.com/group/jpmobile/browse_thread/thread/155a37c0136c72c5/9dc83bfc1fb5818a
        # reset_session_with_mobileは、EcrMobileFront::ApplicationControllerExtを参照
        private
          def set_session(env, sid, session_data)
            ActiveRecord::Base.silence do
              env[ActiveRecord::SessionStore::SESSION_RECORD_KEY] = sid
              record = get_session_model(env, sid, session_data)
              record.data = session_data
              return false unless record.save

              session_data = record.data
              if session_data && session_data.respond_to?(:each_value)
                session_data.each_value do |obj|
                  obj.clear_association_cache if obj.respond_to?(:clear_association_cache)
                end
              end
            end
            return true
          end

          def get_session_model(env, sid, session_data = {})
            if env[ActiveRecord::SessionStore::ENV_SESSION_OPTIONS_KEY][:id].nil? || !session_data.is_a?(ActiveRecord::SessionStore::SessionHash)
              env[ActiveRecord::SessionStore::SESSION_RECORD_KEY] = find_session(sid)
            else
              env[ActiveRecord::SessionStore::SESSION_RECORD_KEY] ||= find_session(sid)
            end
          end
      end
    end
  end
end