# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../spec_helper'

describe CartController do
  fixtures :users, :user_emails, :products, :product_skus

  before(:each) do
    request.stub!(:mobile?).and_return(true)
    request.stub!(:mobile).and_return(mock_model(Jpmobile::Mobile::Docomo, {:supports_cookie? => false}))
    request.session_options[:key] = "session_id"
    ActionController::Base.session_options[:key] = "session_id"
  end

  describe 'DELETE remove_mobile' do
    it 'should render_template empty_cart' do
      get 'index', {:sku_code => '0000000000001-00-00-00', :qty => '1'}
      response.should redirect_to(:action => 'index', :lang => 'ja', :session_id => request.session_options[:id])

      nomal_products = session[:cart].item_list
      nomal_products.size.should == 1

      post 'remove', {:id => nomal_products[0].key}

      response.should redirect_to(:action => 'index', :lang => 'ja', :session_id => request.session_options[:id])
      session[:cart].item_list.should be_empty
    end
  end

  describe 'PUT recalculate' do
    it 'should render_template normal_deli_form' do
      get 'index', {:sku_code => '0000000000001-00-00-00', :qty => '1'}
      response.should redirect_to(:controller => 'cart', :action => 'index', :lang => 'ja', :session_id => request.session_options[:id])

      nomal_products = session[:cart].item_list
      nomal_products.size.should == 1

      post 'recalculate', {:key_and_qtys => [{nomal_products[0].key => '2'}], :cource_div => '1'}

      response.should redirect_to(:action => 'index', :lang => 'ja', :session_id => request.session_options[:id])
      nomal_products = session[:cart].item_list
      nomal_products.size.should == 1
      nomal_products[0].product_sku.sku_code.should == '0000000000001-00-00-00'
      nomal_products[0].qty.should == 2
      items = session[:cart].items.values
      items.size.should == 1
      items[0].product_sku.sku_code.should == '0000000000001-00-00-00'
      items[0].qty.should == 2
    end
  end

end

