# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../spec_helper'

describe ReminderController do
  fixtures :users

  before(:each) do
    request.stub!(:mobile?).and_return(true)
    # デフォルトはDocomoですが、日本語の結果を返すテストをするため、Softbankにします。
    # 照合しやすいように、文字コードがutf-8のSoftbankを指定。
    request.stub!(:mobile).and_return(
      mock_model(Jpmobile::Mobile::Softbank, {:supports_cookie? => false}))
    request.session_options[:key] = "session_id"
    ActionController::Base.session_options[:key] = "session_id"
  end

  describe "reminder_question" do
    it "正しいメールアドレスが入力された場合、パスワード再設定画面に遷移すればOK" do
      post('reminder_question',
        :reminder_form => {
          :email => 'member48@ecrider.com',
          :completion_url_controller => '',
          :completion_url_action => ''
        })
      response.should render_template('reminder/reminder_question_mobile_softbank')
    end

    it "会員登録されていないメールアドレスが入力された場合、メールアドレス入力画面（index）に戻ればOK" do
      post 'reminder_question',
        :reminder_form => {
          :email => 'a@a.com',
          :completion_url_controller => '',
          :completion_url_action => ''
        }
      response.should redirect_to(:controller => 'reminder', :action => 'index', :lang => 'ja', :session_id => request.session_options[:id])
    end
  end
end