# -*- coding: utf-8 -*-
require 'ec_rider'

module EcRider
  # 実行時情報を扱うモジュールです。
  module Runtime

    class << self
      # 現在実行中のプロジェクトがec_adminの時にtrue、それ以外(ec_front/ec_test)はfalseを返します。
      def ec_admin?
        @is_ec_admin ||= !!File.exist?(File.join(RAILS_ROOT, 'app/models_admin'))
      end

      # 現在実行中のプロジェクトがec_frontの時にtrue、それ以外(ec_admin/ec_test)はfalseを返します。
      def ec_front?
        @is_ec_front ||= !ec_admin? && !EcRider.config.ec_test
      end

      # 現在実行中のプロジェクトがec_testの時にtrue、それ以外(ec_admin/ec_front)はfalseを返します。
      def ec_test?
        @is_ec_test ||= !ec_admin? && EcRider.config.ec_test
      end
    end


  end
end
