module EcRider
  module SslConfig
    include EcRider::PluginModule::Extendable

    #
    # SSLが要求されるコントローラ
    # プラグインで追加する場合はself.ssl_required_controllersを拡張します
    #
    SSL_REQUIRED_CONTROLLERS = ["order", "resign", "resigned_reason", "cart", "account", "member", "reminder", "inquiry"]
    def self.ssl_required_controllers
      SSL_REQUIRED_CONTROLLERS
    end

    #
    # SSLを受け付けるコントローラ
    # プラグインで追加する場合はself.ssl_acceptable_controllersを拡張します
    #
    # SSLを受け付けるコントローラ
    SSL_ACCEPTABLE_CONTROLLERS = ["locale", "sps_payment", "common"]
    def self.ssl_acceptable_controllers
      SSL_ACCEPTABLE_CONTROLLERS
    end

  end
end
