module EcRider
  module ValidationExt
    def self.included(mod)
      mod.extend(ClassMethods)
    end

    module ClassMethods
      def validates_numeric_max_length_of(*args)
        options = args.extract_options!
        max_length = options.delete(:maximum)
        raise ArgumentError, "No :maximum option found." unless max_length
        options[:in] = 0..('9' * max_length.to_i).to_i
        options[:message] = I18n.t(:too_long, :count => max_length.to_i, 
          :scope => :'activerecord.errors.messages')
        args << options
        validates_inclusion_of(*args)
      end
    end
  end
end
