require 'jcode'

class ExcelCsvReader
  def self.for_each file, &block
    parse(File.open(file).read).each(&block)
  end
  
  def self.read( file)
    parse(File.open(file).read)
  end

  def self.parse str
    arr = [[""]]
    esc = false
    str = str.each_char
    
    i = 0
    while i < str.size
      if !esc
        if str[i][/\n/]
          arr << [""]
        elsif str[i] == ","
          arr[-1] << ""
        elsif str[i] == "\""
          esc = true
        else
          arr[-1][-1] += str[i]
        end
      else
        if str[i] == "\"" && str[i+1] != "\""
          esc = false
        elsif str[i] == "\"" && str[i+1] == "\""
          arr[-1][-1] += "\""
          i+=1
        else
          arr[-1][-1] += str[i]
        end
      end
      i += 1
    end
    arr
  end

end