// ----------------------------------------------------------------------------
// markItUp!
// ----------------------------------------------------------------------------
// Copyright (C) 2008 Jay Salvat
// http://markitup.jaysalvat.com/
// ----------------------------------------------------------------------------
// Html tags
// http://en.wikipedia.org/wiki/html
// ----------------------------------------------------------------------------
// Basic set. Feel free to add more tags
// ----------------------------------------------------------------------------

//携帯用絵文字
//絵文字のリンクの背景画像をスタイルに追加。
(function(){
  var sheet = null;
  for(var i=0; i<document.styleSheets.length;i++) {
    var s = document.styleSheets[i];
    if (!s.readOnly && s.addRule || s.insertRule) {
      sheet = s;
      break;
    }
  }
  if (!sheet) {
    throw "style not found to addRule";
  }

  try {
    if (document.all) {
      for(var i=1; i<=252;i++) {
        sheet.addRule('.markItUp .emoji .emoji'+ '-'+ i + ' a',
          'background:url(/ec_rider/images/mobile/emoji/' + i + '.gif) no-repeat 0 0');
      }
    } else {
      for(var i=1; i<=252;i++) {
        sheet.insertRule('.markItUp .emoji .emoji'+ '-'+ i + ' a {background:url(/ec_rider/images/mobile/emoji/' + i + '.gif) no-repeat 0 0}',
          sheet.cssRules.length);
      }
    }
  } catch(e) {
    throw e;
  }
})();

//ツールバーのドロップダウン要素を生成。
var emojiAttrs = (function(){
    var skip_emoji = [7, 21, 29, 60, 64, 78, 93, 108, 109, 111, 112, 114, 117, 118, 121, 122, 124, 148, 161, 165, 166, 168, 169, 170, 171, 173, 174, 175, 177, 178, 180, 182, 183, 185, 188, 189, 193, 196, 199, 212, 213, 218, 221, 223, 231, 233, 243, 246];
    var attrs = [];
    for(var i=1; i<=252;i++) {
        if (!skip_emoji.include(i)){
            attrs.push({
                name : i,
                replaceWith : '<ec:emoji code="' + i + '"/>',
                className : 'emoji' + '-' + i
            });
        }
    }
    return attrs;
})();


mySettings = {
    onShiftEnter:	{keepDefault:false, replaceWith:'<br />\n'},
    onCtrlEnter:	{keepDefault:false, openWith:'\n<p>', closeWith:'</p>\n'},
    onTab:		{keepDefault:false, openWith:'	 '},
    //previewTemplatePath:'/javascripts/markitup/markitup/templates/preview.html',
    previewParserPath: '/cms_pages/realtime_preview',
    previewParserVar: 'user_content',
    previewAutoRefresh: false,
    markupSet: [
        {name:'javascript', className:'javascript', replaceWith:'<ec:javascript href="[![JavascriptURL:!:/your_js_file_name]!]"/>'},
        {name:'stylesheet', className:'stylesheet', replaceWith:'<ec:stylesheet href="[![StylesheetURL:!:/your_css_file_name]!]" media="all"/>'},
        {separator:'---------------' },
        {name:'Heading1', key:'1', className:'h1', openWith:'<h1(!( class="[![Class]!]")!)>', closeWith:'</h1>', placeHolder:'Your title here...' },
        {name:'Heading2', key:'2', className:'h2', openWith:'<h2(!( class="[![Class]!]")!)>', closeWith:'</h2>', placeHolder:'Your title here...' },
        {name:'Heading3', key:'3', className:'h3', openWith:'<h3(!( class="[![Class]!]")!)>', closeWith:'</h3>', placeHolder:'Your title here...' },
        {name:'Heading4', key:'4', className:'h4', openWith:'<h4(!( class="[![Class]!]")!)>', closeWith:'</h4>', placeHolder:'Your title here...' },
        //{name:'Heading5', key:'5', className:'h5', openWith:'<h5(!( class="[![Class]!]")!)>', closeWith:'</h5>', placeHolder:'Your title here...' },
        //{name:'Heading6', key:'6', className:'h6', openWith:'<h6(!( class="[![Class]!]")!)>', closeWith:'</h6>', placeHolder:'Your title here...' },
        {name:'Paragraph', className:'paragraph', openWith:'<p(!( class="[![Class]!]")!)>', closeWith:'</p>' },
        {name:'Return', key: 'R', className:'return', replaceWith:'<br/>\n'},
        {separator:'---------------' },
        {name:'Bold[+Alt=>B]',   key:'B', className:'bold', openWith:'(!(<strong>|!|<b>)!)', closeWith:'(!(</strong>|!|</b>)!)' },
        {name:'Italic[+Alt=>I]', key:'I', className:'italic', openWith:'(!(<em>|!|<i>)!)', closeWith:'(!(</em>|!|</i>)!)' },
        {name:'Delete', key:'D', className:'del', openWith:'<del>', closeWith:'</del>' },
        {name:'FontColors', className:'palette', dropMenu: [
                {name:'white',		openWith:'<font color="#FFFFFF">', closeWith:'</font>',	className:"col1-1" },
                {name:'silver',		openWith:'<font color="#C0C0C0">', closeWith:'</font>',	className:"col1-2" },
                {name:'darkgray',	openWith:'<font color="#A9A9A9">', closeWith:'</font>',	className:"col1-3" },
                {name:'gray',		openWith:'<font color="#808080">', closeWith:'</font>',	className:"col1-4" },
                {name:'dimgray',	openWith:'<font color="#696969">', closeWith:'</font>',	className:"col1-5" },
                {name:'black',		openWith:'<font color="#000000">', closeWith:'</font>',	className:"col1-6" },

                {name:'cyan',		openWith:'<font color="#00FFFF">', closeWith:'</font>',	className:"col2-1" },
                {name:'skyblue',	openWith:'<font color="#87CEEB">', closeWith:'</font>',	className:"col2-2" },
                {name:'deepskyblue',    openWith:'<font color="#00BFFF">', closeWith:'</font>',	className:"col2-3" },
                {name:'royalblue',	openWith:'<font color="#4169E1">', closeWith:'</font>',	className:"col2-4" },
                {name:'blue',		openWith:'<font color="#0000FF">', closeWith:'</font>',	className:"col2-5" },
                {name:'darkblue',	openWith:'<font color="#00008B">', closeWith:'</font>',	className:"col2-6" },

                {name:'charteuse', 	openWith:'<font color="#7FFF00">', closeWith:'</font>',	className:"col3-1" },
                {name:'lime',		openWith:'<font color="#00FF00">', closeWith:'</font>',	className:"col3-2" },
                {name:'springgreen',    openWith:'<font color="#00FF7F">', closeWith:'</font>',	className:"col3-3" },
                {name:'olivedrab',	openWith:'<font color="#6B8E23">', closeWith:'</font>',	className:"col3-4" },
                {name:'green',		openWith:'<font color="#008000">', closeWith:'</font>',	className:"col3-5" },
                {name:'darkgreen',	openWith:'<font color="#006400">', closeWith:'</font>',	className:"col3-6" },

                {name:'yallow',		openWith:'<font color="#FFFF00">', closeWith:'</font>',	className:"col4-1" },
                {name:'gold',		openWith:'<font color="#FFD700">', closeWith:'</font>',	className:"col4-2" },
                {name:'sandybrown',	openWith:'<font color="#F4A460">', closeWith:'</font>',	className:"col4-3" },
                {name:'peru',		openWith:'<font color="#CD853F">', closeWith:'</font>',	className:"col4-4" },
                {name:'sienna',		openWith:'<font color="#A0522D">', closeWith:'</font>',	className:"col4-5" },
                {name:'maroon',		openWith:'<font color="#800000">', closeWith:'</font>',	className:"col4-6" },

                {name:'pink',		openWith:'<font color="#FF69B4">', closeWith:'</font>',	className:"col5-1" },
                {name:'hotpink',	openWith:'<font color="#FF1493">', closeWith:'</font>',	className:"col5-2" },
                {name:'salmon',		openWith:'<font color="#FA8072">', closeWith:'</font>',	className:"col5-3" },
                {name:'red',		openWith:'<font color="#FF0000">', closeWith:'</font>',	className:"col5-4" },
                {name:'crimson',	openWith:'<font color="#DC134C">', closeWith:'</font>',	className:"col5-5" },
                {name:'darkred',	openWith:'<font color="#860000">', closeWith:'</font>',	className:"col5-6" },

                {name:'plum',		openWith:'<font color="#DDA0DD">', closeWith:'</font>',	className:"col6-1" },
                {name:'violet', 	openWith:'<font color="#EE82EE">', closeWith:'</font>',	className:"col6-2" },
                {name:'midiumpurple',   openWith:'<font color="#9370DB">', closeWith:'</font>',	className:"col6-3" },
                {name:'darlviolet',	openWith:'<font color="#9400D3">', closeWith:'</font>',	className:"col6-4" },
                {name:'purple', 	openWith:'<font color="#800080">', closeWith:'</font>',	className:"col6-5" },
                {name:'darkmagenta',    openWith:'<font color="#8B008B">', closeWith:'</font>',	className:"col6-6" }
        ]},
        {name:'Emoji for Mobile', className:"emoji", dropMenu: emojiAttrs},
        {separator:'---------------' },
        {name:'Ul', className:'ul', openWith:'<ul>\n  <li>', closeWith:'</li>\n</ul>\n' },
        {name:'Ol', className:'ol', openWith:'<ol>\n  <li>', closeWith:'</li>\n</ol>\n' },
        {name:'Li', className:'li', openWith:'<li>', closeWith:'</li>' },
        {separator:'---------------' },
        {name:'Picture', key:'P', className:'picture', replaceWith:'<ec:image src="[![ImageURL:!:/uploaded_image_file_name]!]" alt="[![Alternative text]!]" />' },
        {name:'Link', key:'L', className:'link', openWith:'<ec:link href="[![LinkURL:!:/your_cms_page_name]!]"(!( title="[![Title]!]")!) text="', closeWith:'"/>', placeHolder:'Your text to link...' },
        {name:'PictureLink', className:'picture_link', replaceWith:'<ec:image_link src="[![ImageURL:!:/your_image_file_name]!]" href="[![LinkURL:!:/your_cms_page_name]!]" alt="[![Alternative text]!]" />' },
        {separator:'---------------' },
        {name:'Table',	openWith:'<table>',	closeWith:'</table>',	placeHolder:"\n  <tr>\n    <(!(td|!|th)!)></(!(td|!|th)!)>\n  </tr>\n",	className:'table'},
        {name:'Tr',     openWith:'<tr>',	closeWith:'</tr>',	placeHolder:"<(!(td|!|th)!)></(!(td|!|th)!)>",	className:'table-row'},
        {name:'Td[+Alt=>Th]',	openWith:'<(!(td|!|th)!)>', 	closeWith:'</(!(td|!|th)!)>',	className:'table-col'},
        {separator:'---------------' },
	{name:'Encode Html special chars', className:"encodechars",
          replaceWith:function(markItUp) {
            container = document.createElement('div');
            container.appendChild(document.createTextNode(markItUp.selection));
            return container.innerHTML;
          }
        },
        {name:'Clean', className:'clean',
          replaceWith:function(markItUp) {
            return markItUp.selection.replace(/<(.*?)>/g, "")
          }
        },
        {name:'Preview', className:'preview', call:'preview' }
    ]
}