ProductDialog = Class.create();
ProductDialog.prototype = {
    initialize: function(name, options){
        this.name = name;
        this.options = Object.extend({
            sku: false,
            present_only: false
        }, options || {});
    },
   
    show: function(){
        if (!this.base_area) {
            this.base_area = document.createElement("div");
            this.base_area.className = "product_dialog_base";
            document.body.appendChild(this.base_area);
        } else {
            Element.show(this.base_area);
        }
        this.base_area.style.top = Math.max(100, window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop) + "px";
        var params = "product_dialog[dialog_name]=" + this.name + "&product_dialog[sku]=" + !!this.options.sku + "&product_dialog[present_only]=" + !!this.options.present_only;
        params = params + "&product_dialog[product_ids]=";
        if (this.onShow){
            params = params + this.onShow().join(",");
        }
        if (this.selected_product_ids) {
            params = params + "&product_dialog[selected_product_ids]=" + this.selected_product_ids.join(",");
        }
        if (this.selected_product_sku_ids) {
            params = params + "&product_dialog[selected_product_sku_ids]=" + this.selected_product_sku_ids.join(",");
        }
        new Ajax.Updater(this.base_area, "/product_dialog", {
            evalScripts: true,
            method: "get",
            parameters: params,
            onComplete: this.onLoadDialog.bind(this)
        });
    },

    onLoadDialog: function(){
        this.hideSearchOptions();
        $$(".product_dialog_base .product_dialog_cancel").each((function(btn){
            Event.observe(btn, "click", this.cancel.bindAsEventListener(this));
        }).bind(this));
        $$(".product_dialog_base .show_search_options").each((function(btn){
            Event.observe(btn, "click", this.showSearchOptions.bindAsEventListener(this));
        }).bind(this));
        $$(".product_dialog_base .hide_search_options").each((function(btn){
            Event.observe(btn, "click", this.hideSearchOptions.bindAsEventListener(this));
        }).bind(this));
        $$(".product_dialog_base .product_dialog_drag_handle").each((function(div){
            new Draggable(this.base_area, {
                handle: div
            });
        }).bind(this));
    },

    bindCommitButton: function(){
        $$(".product_dialog_base .product_dialog_commit").each((function(btn){
            Event.observe(btn, "click", this.commit.bindAsEventListener(this));
        }).bind(this));
    },

    commit: function(event){
        var results = [];
        var product_dialog = this;
        if (!!product_dialog.options.sku){
            if (product_dialog.selected_product_sku_ids == null) {
                product_dialog.selected_product_sku_ids = [];
            }
            //チェックボックスの状態でthis.selected_product_idsを更新する。
            $$(".sku_check").each(function(check){
                if ("" + check.checked == "true"){
                    product_dialog.selected_product_sku_ids.push(check.value * 1);
                } else {
                    for(i = 0; i < product_dialog.selected_product_sku_ids.length; i++){ 
                        if(product_dialog.selected_product_sku_ids[i] == (check.value * 1)){  
                            product_dialog.selected_product_sku_ids.splice(i,1); 
                        }
                    }
                }
            });
            //this.selected_product_idsの中の重複を取り除く。
            product_dialog.selected_product_sku_ids.sort();
            product_dialog.selected_product_sku_ids = this.arrayUnique(product_dialog.selected_product_sku_ids);
            //返す配列を生成する。
            product_dialog.selected_product_sku_ids.each(function(product_sku_id){
                results.push({
                    id : product_sku_id
                });
            });
        } else {
            if (product_dialog.selected_product_ids == null) {
                product_dialog.selected_product_ids = [];
            }
            //チェックボックスの状態でthis.selected_product_idsを更新する。
            $$(".product_check").each(function(check){
                if ("" + check.checked == "true"){
                    product_dialog.selected_product_ids.push(check.value * 1);
                } else {
                    for(i = 0; i < product_dialog.selected_product_ids.length; i++){ 
                        if(product_dialog.selected_product_ids[i] == (check.value * 1)){  
                            product_dialog.selected_product_ids.splice(i,1); 
                        }
                    }
                }
            });
            //this.selected_product_idsの中の重複を取り除く。
            product_dialog.selected_product_ids.sort();
            product_dialog.selected_product_ids = this.arrayUnique(product_dialog.selected_product_ids);
            //返す配列を生成する。
            product_dialog.selected_product_ids.each(function(product_id){
                results.push({
                    id : product_id
                });
            });
        //            $$(".product_check").each(function(check){
        //                if (check.checked){
        //                    var product_tr = check.parentNode.parentNode;
        //                    var td_product_code           = $$("#" + product_tr.id + " .product_code").first();
        //                    var td_product_name_for_admin = $$("#" + product_tr.id + " .product_name_for_admin").first();
        //                    results.push({
        //                        id: check.value * 1,
        //                        product_code: td_product_code.innerHTML,
        //                        product_name_for_admin: td_product_name_for_admin.innerHTML
        //                    });
        //                }
        //            });
        }
        if (this.onCommit){
            this.onCommit(event, "commit", results);
        }
        this.hide();
    },
    
    showSearchOptions: function(){
        $$(".product_dialog_base .search_options").each(Element.show);
        $$(".product_dialog_base .search_options input").each(Form.Element.enable);
        $$(".product_dialog_base .search_options select").each(Form.Element.enable);
        $$(".product_dialog_base .hide_search_options").each(Element.show);
        $$(".product_dialog_base .show_search_options").each(Element.hide);
    },
    
    hideSearchOptions: function(){
        $$(".product_dialog_base .search_options").each(Element.hide);
        $$(".product_dialog_base .search_options input").each(Form.Element.disable);
        $$(".product_dialog_base .search_options select").each(Form.Element.disable);
        $$(".product_dialog_base .hide_search_options").each(Element.hide);
        $$(".product_dialog_base .show_search_options").each(Element.show);
    },
    
    cancel: function(){
        this.hide();
    },
    
    hide: function(){
        $$(".product_dialog_base .product_dialog_list_area").each(function(div){
            div.innerHTML = '';
        });
        Element.hide(this.base_area);
    },
    
    // 配列の重複を取り除き、配列内の値を一意にする処理
    arrayUnique: function(array){
        var storage = {};
        var uniqueArray = [];
        var i,value;
        for ( i=0; i<array.length; i++) {
            value = array[i];
            if (!(value in storage)) { 
                storage[value] = true;
                uniqueArray.push(value);
            }
        }
        return uniqueArray;
    }
};

