# -*- coding: utf-8 -*-
require File.join(File.dirname(__FILE__), '..', 'spec_helper')

describe AccountingsController do
  include EcRider::I18nSupport

  fixtures(:accountings)

   before do
     # adminでログイン
     login_as("admin")
   end
    before(:each) do
      # adminでログイン
      login_as("admin")
    end

  describe "GET index" do
    it "index no session" do
      session[:accounting_search_cond] = nil
      flash[:error] = nil
      get :index
      response.should be_success
    end

    it "index session" do
      cond = Accounting::SearchInfo.new()
      cond.start_date = 'start_date not nil'
      session[:accounting_search_cond] = cond

      flash[:error] = nil
      get :index
      response.should be_success
    end

    it "index session for ajax" do
      request.stub!(:xml_http_request?).and_return(true)
      cond = Accounting::SearchInfo.new()
      cond.start_date = 'start_date not nil'
      session[:accounting_search_cond] = cond

      flash[:error] = nil
      get :index
      response.should be_success
    end
  end

end

