# -*- coding: utf-8 -*-
require File.join(File.dirname(__FILE__), '..', 'spec_helper')

class ApplicationTestController < ApplicationController
  def index
  end
end

describe ApplicationTestController, "ApplicationController" do

  it "When no logged in, GET application_test/index should redirect to login/index." do
    get :index
    response.should redirect_to(:controller => 'goldberg/auth', :action => 'login')
  end

  it "When no logged in, GET login/index should redirect to login/index." do
    get :index, :controller => 'goldberg/auth'
    response.should redirect_to(:controller => 'goldberg/auth', :action => 'login')
  end

  it "When no logged in, unauthorized action, " do
    get :index
    response.should redirect_to("/")
  end
  
  describe "test MailForm" do
    it "test valid" do
      mail = MailForm.new(:from => 'test@test.com', :to => 'test@test.com', :subject => 'test_subject', :body => 'a' * 10000)
      mail.valid?.should == true
    end
    
    it "test body is too long" do
      mail = MailForm.new(:from => 'test@test.com', :to => 'test@test.com', :subject => 'test_subject', :body => 'a' * 10001)
      mail.valid?.should == false
    end
  end


  describe "include Goldberg::Filters" do
    describe "goldberg_security_up" do
      
    end
  end

  describe "current_user" do
    it "はGoldberg::Userを返す" do
      user = Goldberg::User.find_by_name('admin')
      session[:user] = user.id
      current_user = controller.__send__(:current_user) # protectedメソッドなのでsendします。
      current_user.class.should == Goldberg::User
      current_user.should_not be_nil
      current_user.id.should == user.id
      current_user.object_id.should_not == user.object_id
    end
  end


end

