require File.join(File.dirname(__FILE__), '..', 'spec_helper')

describe CmsCloudFrontController do
  fixtures :cms_layouts
  
  def login_as_admin
    login_as("admin")
  end

  describe "GET index" do
    it "should get index" do
      login_as_admin
      get :index
      response.should be_success
    end
    
    it "index should get real_files" do
      base_path = controller.instance_variable_get(:@base_path)
      mock_paths = [
        "#{base_path}/cms/test_01.gif",
        "#{base_path}/cms/test_02.gif",
        "#{base_path}/cms/test_03.gif",
        "#{base_path}/cms/test_01-20090101100000.gif",
        "#{base_path}/cms/test_02-20090201100000.gif",
        "#{base_path}/cms/test_02-20090301100000.gif",
        "#{base_path}/cms/test_02-20090101100000.gif",
        "#{base_path}/cms/common/test_01-20090310100000.gif",
        "#{base_path}/cms/common/test_01.gif"
      ]
      Dir.stub!(:glob).and_return(mock_paths)
      
      login_as_admin
      get :index
      controller.instance_variable_get(:@real_files).size.should == 4
      controller.instance_variable_get(:@real_files)[0][0].should == "/cms/common/test_01.gif"
      controller.instance_variable_get(:@real_files)[1][0].should == "/cms/test_01.gif"
      controller.instance_variable_get(:@real_files)[2][0].should == "/cms/test_02.gif"
      controller.instance_variable_get(:@real_files)[3][0].should == "/cms/test_03.gif"
      controller.instance_variable_get(:@upload_dates)["/cms/test_01.gif"].should == "20090101100000"
      controller.instance_variable_get(:@upload_dates)["/cms/test_02.gif"].should == "20090301100000"
      controller.instance_variable_get(:@upload_dates)["/cms/test_03.gif"].should be_nil
      controller.instance_variable_get(:@upload_dates)["/cms/common/test_01.gif"].should == "20090310100000"
    end
  end
end
