require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe CmsProjectApprovalsController do
  fixtures :cms_projects, :cms_project_assigns, :goldberg_users

  def login_as_admin
    login_as("admin")
    session[:project_id] = cms_projects(:cms_projects_00002).id
  end

  describe "GET index" do
    it "should get index" do
      login_as_admin
      get :index
      response.should be_success
    end
  end

  describe "POST create" do
    it "should get index" do
      login_as_admin
      CmsProjectApproval.destroy_all
      get(:create, {
        :cms_project_approval => {:comment => '確認をお願いします。'}, 
        :result_cd => CmsProjectApproval.result_id_by_key(:requested)
      })
      response.should redirect_to(:controller => 'cms_project_approvals', :action => 'index')
      approvals = CmsProjectApproval.find(:first)
      approvals.goldberg_user_id.should == 1
      approvals.comment.should == '確認をお願いします。'
      CmsProject.find(2).status_key.should == :requesting_check
    end
  end

end
