require File.join(File.dirname(__FILE__), '..', 'spec_helper')

describe CommonController do

  before(:each) do
    login_as("admin")
  end

  describe "zip" do
    before do
      mock_add1 = JpAddress.new(:id => 1, :jiscode => '23106', :zipcode_old => '460', :zipcode => '4600002',
        :prefecture => '愛知県', :city => '名古屋市中区', :address => '丸の内')
      JpAddress.stub!(:find_by_zipcode).with('4600002').and_return(mock_add1)
      JpAddress.stub!(:find_by_zipcode).with('0000000').and_return(nil)
    end

    it "POST to_address with id is '4600002'" do
      post :to_address, :id=>'4600002'
      response.should have_text("['愛知県','名古屋市中区','丸の内']")
    end

    it "POST to_address with id is '0000000'" do
      post :to_address, :id=>'0000000'
      response.should have_text("['','','']")
    end
  end
end