require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe CsvFileDownloadHistoryController do
  fixtures :csv_download_patterns, :csv_download_pattern_items, :csv_download_pattern_user_conditions,
    :csv_file_download_histories
      
  before(:each) do
    login_as("admin")
  end

  describe "GET index" do
    it "index no session" do
      session[:csv_file_download_history_search_cond] = nil
      flash[:error] = nil
      get :index, :condition =>{}
      response.should be_success
    end

    it "index session" do
      cond = CsvFileDownloadHistory::SearchCondition.new()
      cond.outputed_at_from = '1999/9/9'
      session[:csv_file_download_history_search_cond] = cond
      flash[:error] = nil
      get :index
      response.should be_success
    end
  end
  describe "GET show" do
    before(:each) do
      @tmp_dir = File.expand_path(File.join(RAILS_ROOT, "tmp", "test_csv"))
      Dir.glob(File.join(@tmp_dir, '*')) .each{|f| FileUtils.rm_rf(f) }
      FileUtils.mkdir_p(@tmp_dir)
      EcRider.config.stub!(:csv_dir).and_return(@tmp_dir)
    end

    it "show" do
      result = CsvFileDownloadHistory.new(:csv_download_pattern_id => csv_download_patterns(:csv_download_patterns_00015).id,
        :file_name => "test_csv")
      result.save!
      get :show, :id => result.id
    end

    it "削除" do
      result = CsvFileDownloadHistory.new(:csv_download_pattern_id => csv_download_patterns(:csv_download_patterns_00015).id,
        :file_name => "test_csv")
      result.save!
      CsvFileDownloadHistory.find_by_id(result.id).should_not be_nil
      delete :destroy, :id => result.id
      CsvFileDownloadHistory.find_by_id(result.id).should be_nil
      Dir.glob(File.join(@tmp_dir, 'test.csv')).length.should == 0
    end
  end
end
