# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../spec_helper'

describe Goldberg::AuthController do
  
  describe "POST login" do
    
    before do
      # ログインできる権限が必要なため、システム管理者でログインしています。
      login_as("admin")
      
      flash[:error] = nil
    end
    it "login success" do
      post :login, :login => { :login => "admin", :password => "password" }
      response.should redirect_to(:controller => '/top', :action => 'index')
      flash[:error].should(nil)
    end
    
    it "login fail" do
      post :login, :login => { :name => "aaaAAA" }
      response.should redirect_to(:action => 'login')
      flash[:error].should_not(nil)
    end
  end
  
  describe "POST logout" do
    it "logout" do
      post :logout
      session[:user].should(nil)
      session[:current_user].should(nil)
      redirect_to(:controller => 'login' ,:action => 'index')
    end
  end
end
