require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe InventoriesController do
  fixtures :products, :product_skus, :product_sku_inventories, :product_sku_secure_inventories, :product_components
    
  before(:each) do
    login_as("admin")
  end
  
  describe "GET index" do
    it "assigns all product_skus as @product_skus" do
      get :index
      assigns[:product_skus].size.should == 20
      response.should render_template(:index)
    end
  end
  
  describe "GET edit" do
    it "assigns product_sku" do
      get :edit, :id => "282"
      assigns[:product_sku].id.should == 282
      assigns[:inventory].is_a?(ProductSkuInventory::CreateForm).should be_true
      response.should render_template(:edit)
    end
  end

  describe "GET show" do
    it "assigns product_sku and inventories" do
      get :show, :id => "282"
      assigns[:product_sku].id.should == 282
      assigns[:inventories].size.should == 1
      assigns[:inventories].first.id.should == 18
      assigns[:stock_count_at_first_record].should == 99
      response.should render_template(:show)
    end
  end
  
  describe "POST update" do
    it "invalid" do
      post :update, :product_sku_inventory_create_form => {:product_sku_id => 282}
      response.should render_template(:edit)
    end
    it "valid and update" do
      inventory_count = ProductSkuInventory.count()
      post :update, :product_sku_inventory_create_form => {:product_sku_id => 282, :in_out_div => 'in', :count => 10}
      response.should redirect_to(:controller => :inventories, :action => :show, :id => 282)
      ProductSkuInventory.count().should == inventory_count + 1
    end
  end
end
