# -*- coding: utf-8 -*-
require File.join(File.dirname(__FILE__), '..', 'spec_helper')

describe MailHistoryController do
  fixtures :mail_deliveries, :users, :inquiries
  before do
    # adminでログイン
    login_as("admin")
  end

  describe "GET index" do
    it "index" do
      get :index
      response.should redirect_to :action => :list
    end
  end

  describe "GET list" do
    it "list" do
      get :list
      response.should be_success
      session[:mail_delivery_search_cond].should == nil
    end
  end

  describe "GET show" do
    it "show" do
      get :show, :id => 1, :page => 1
      response.should be_success
      controller.instance_variable_get(:@pages_current).should == "1"
      controller.instance_variable_get(:@mail_delivery).should_not == nil
    end
  end

  describe "POST delete" do
    it "delete" do
      post :delete, :id => 1, :page => 1
      response.should redirect_to :action => 'search', :page => 1
    end
  end

  describe "GET search" do
    it "validation ok" do
      get :search, :condition => { :mail_div => "1", :disp_count => "20", :name => "", :email => '',
        :user_code => '', :member_div => ''}, :page => 1
      response.should be_success
    end

    it "validation fail" do
      flash[:error] = nil
      get :search, :condition => {
        :mail_div => "MMM",
        :disp_count => "20",
        :deliveried_at_from => "ERROR",
        }, :page => 1
      response.should be_success
      flash[:error].should_not == nil
    end
  end

end
