# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../spec_helper'

describe NameMasterController do
  fixtures :kbn_codes, :kbn_code_names

  before(:each) do
    login_as("admin")
  end

  describe "GET 'search_index'" do
    it "should be successful" do
      get 'search_index'
      response.should be_success
    end
  end

 describe "GET 'name_master_detail'" do
    it "should be successful show id 250" do
      get('name_master_detail', :id => kbn_codes(:kbn_codes_00021).id)
      response.should be_success
      assigns[:kbn_code].should == kbn_codes(:kbn_codes_00021)
      assigns[:code_names][0].kbn_code_id.should == kbn_codes(:kbn_codes_00021).id
    end
  end

  describe "GET 'update_form'" do
    it "should be successful edit id 250" do
      get('update_form', :id => kbn_codes(:kbn_codes_00021).id)
      response.should be_success
      assigns[:kbn_code].should == kbn_codes(:kbn_codes_00021)
      assigns[:code_names].size.should == 6
    end
  end

  describe "PUT 'update'" do
    it "should be successful update id 250" do
      params = {:id => kbn_codes(:kbn_codes_00021).id, :name_ja => "会社員"}
      I18n.supported_locales.each do |locale|
        params.merge("name_#{locale}".intern => "locale#{name}")
      end
      put('update', params)
      response.should redirect_to(:action => :search)
    end
  end

  describe "DELETE 'delete'" do
    it "should be successful delete id 250" do
      lambda {
        delete('delete', :id => kbn_codes(:kbn_codes_00021).id)
      }.should change(KbnCode, :count).by(-1)
      response.should redirect_to(:action => :search)
    end
  end

  describe "GET 'new'" do
    it "should be successful new" do
      get('new')
      response.should be_success
    end
  end

  describe "POST 'create'" do
    it "should be successful create" do
      pending
      params = {:kbn_code => {:kbn => '51', :code => '100'}}

      I18n.supported_locales.each do |locale|
        params.merge("name_#{locale}".intern => "locale#{name}")
      end
      lambda {
        post('create', params)
      }.should change(KbnCode, :count).by(1)
      response.should redirect_to(:action => :search)
    end

    it "should be validate eroor 'code is not input'" do
      params = {:kbn_code => {:kbn => '51', :code => nil}}

      I18n.supported_locales.each do |locale|
        params.merge("name_#{locale}".intern => "locale#{name}")
      end
      lambda {
        post('create', params)
      }.should change(KbnCode, :count).by(0)
      response.should be_success
    end
  end

  describe "GET 'search'" do
    it "search no condition" do
      get :search
      response.should be_success
    end

    it "search with condition" do
      get :search, :condition => { :kbn => "", :kbn_name => "", :code => "", :name => "", :disp_count => "" }
      response.should be_success
    end
  end


end
