require File.join(File.dirname(__FILE__), '..', 'spec_helper')

describe PointSettingController do
  fixtures :point_settings

  before do
    # adminでログイン
    login_as("admin")
  end

  describe "GET index" do
    it "index no session" do
      get :index
      response.should be_success
    end
  end

  describe "GET edit" do
    it "初期遷移" do
      get :edit
      response.should be_success
    end
    it "エラーで戻ってきた場合" do
      flash[:point_setting] = 'test'
      get :edit
      response.should be_success
      controller.instance_variable_get(:@point_setting).should == "test"
    end
  end

  describe "POST update" do
    it "正常" do
      params = {
        "term_day"=>"",
        "exchangeable_price"=>"",
        "available_flg"=>"true",
        "exchangeable_price_flg"=>"0",
        "issue_price"=>"1000",
        "terminable_flg"=>"false",
        "term_month"=>"",
        "point_period_div"=>"1",
        "exchange_rate"=>"100",
        "exchangeable_point_flg"=>"0",
        "term_div"=>"99"
      }
      get :update , :point_setting => params
      response.should redirect_to :action => :index
      point_setting = PointSetting.find(:first)
      point_setting.issue_price.should == 1000
    end
    it "バリデーションエラーの場合" do
      params = {
        "term_day"=>"aaa",
        "exchangeable_price"=>"",
        "available_flg"=>"true",
        "exchangeable_price_flg"=>"0",
        "issue_price"=>"1000",
        "terminable_flg"=>"true",
        "term_month"=>"",
        "point_period_div"=>"1",
        "exchange_rate"=>"100",
        "exchangeable_point_flg"=>"0",
        "term_div"=>"99"
      }

      get :update , :point_setting => params
      response.should redirect_to :action => :edit
      flash[:point_setting].should_not == nil
    end
  end

end
