# -*- coding: utf-8 -*-
require File.join(File.dirname(__FILE__), '..', 'spec_helper')

describe TopController do
  fixtures :goldberg_users, :users, :orders, :order_shippings, :cms_projects, :inquiries

  describe "一般ユーザー" do
    before do
      # publicでログイン
      login_as("public")
    end

    it "should get index" do
      get :index
      response.should be_success
      response.should render_template(:index)
    end
  end
  
  describe "システム管理者" do
    before do
      # adminでログイン
      login_as("admin")
    end

    it "should get index" do
      get :index
      response.should be_success
      response.should render_template(:dashboard)
      
      controller.instance_variable_get(:@order_counts).is_a?(Hash).should be_true
      controller.instance_variable_get(:@order_counts)[OrderShipping.status_div_id_by_key(:undelivery)].should == 10
      controller.instance_variable_get(:@order_counts)[OrderShipping.status_div_id_by_key(:deliver_request)].should == 1
      
      controller.instance_variable_get(:@order_comment_counts).is_a?(Hash).should be_true
      controller.instance_variable_get(:@order_comment_counts)[OrderShipping.status_div_id_by_key(:undelivery)].should == 8
      
      controller.instance_variable_get(:@inquiry_count).should == 3
      
      controller.instance_variable_get(:@pending_approval_count).should == 0
      controller.instance_variable_get(:@pending_check_count).should == 0
      
      controller.instance_variable_get(:@member_count).should == 35
      
      controller.instance_variable_get(:@this_month_sales).is_a?(Hash).should be_true
      controller.instance_variable_get(:@last_month_sales).is_a?(Hash).should be_true
    end
  end
end
