# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../spec_helper'

describe ApplicationHelper, :type => :helper do
  include ApplicationHelper

  describe "add_br_tag" do
    it "/n test" do
      str = add_br_tag("aaa\nbbb\nccc\n")
      str.should == "aaa<br/>\nbbb<br/>\nccc<br/>\n" 
    end
    it "tag test" do
      str = add_br_tag("<script>alert()</script>\n")
      str.should == "&lt;script&gt;alert()&lt;/script&gt;<br/>\n" 
    end
  end

  describe "current_user" do
    it "はGoldberg::Userを返す" do
      user = Goldberg::User.find_by_name('admin')
      session[:user] = user.id
      # ヘルパー用のテストなので、コントローラのセットアップは自分でやります。
      controller = helper.__send__(:controller)
      controller.stub!(:session).and_return(session)
      current_user = helper.current_user
      current_user.class.should == Goldberg::User
      current_user.should_not be_nil
      current_user.id.should == user.id
      current_user.object_id.should_not == user.object_id
    end
  end
end
