require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe CampaignConditionsHelper do
  describe "script_for_change_condition_operator_field" do
    it "javascript生成" do
      helper.script_for_change_condition_operator_field("value", "'001'").should ==
        "switch (value) {" +
        "  case '01':    change_operator_field('eql', '001');    break;" +
        "  case '02':    change_operator_field('eql', '001');    break;" +
        "  case '03':    change_operator_field('like', '001');    break;" +
        "  case '04':    change_operator_field('eql', '001');    break;" +
        "  case '05':    change_operator_field('compare', '001');    break;" +
        "  case '07':    change_operator_field('compare', '001');    break;" +
        "  case '08':    change_operator_field('compare', '001');    break;" +
        "  case '09':    change_operator_field('compare', '001');    break;" +
        "  case '10':    change_operator_field('compare', '001');    break;" +
        "  case '11':    change_operator_field('compare', '001');    break;" +
        "  case '22':    change_operator_field('eql', '001');    break;" +
        "  case '19':    change_operator_field('eql', '001');    break;" +
        "  case '21':    change_operator_field('compare', '001');    break;" +
        "  case '23':    change_operator_field('compare', '001');    break;" +
        "}"
    end
  end

  describe "script_for_change_condition_value_field" do
    it "javascript生成" do
      helper.script_for_change_condition_value_field("value", "'001'").should ==
        "switch (value) {" +
        "  case '01':    change_value_field('gender', '001');    break;" +
        "  case '02':    change_value_field('country', '001');    break;" +
        "  case '03':    change_value_field('text', '001');    break;" +
        "  case '04':    change_value_field('boolean', '001');    break;" +
        "  case '05':    change_value_field('text', '001');    break;" +
        "  case '07':    change_value_field('text', '001');    break;" +
        "  case '08':    change_value_field('text', '001');    break;" +
        "  case '09':    change_value_field('year', '001');    break;" +
        "  case '10':    change_value_field('month', '001');    break;" +
        "  case '11':    change_value_field('day', '001');    break;" +
        "  case '22':    change_value_field('member_category_div', '001');    break;" +
        "  case '19':    change_value_field('user_rank', '001');    break;" +
        "  case '21':    change_value_field('text', '001');    break;" +
        "  case '23':    change_value_field('text', '001');    break;" +
        "}"
    end
  end

  describe "script_for_display_condition_suffix" do
    it "javascript生成" do
      helper.script_for_display_condition_suffix("target_id", "value").should ==
        "switch (value) {" +
        "  case '01':    $('target_id').innerHTML = '';    break;" +
        "  case '02':    $('target_id').innerHTML = '';    break;" +
        "  case '03':    $('target_id').innerHTML = '';    break;" +
        "  case '04':    $('target_id').innerHTML = '';    break;" +
        "  case '05':    $('target_id').innerHTML = '';    break;" +
        "  case '07':    $('target_id').innerHTML = '例： 2010/01/10 または today';    break;" +
        "  case '08':    $('target_id').innerHTML = '例： 03/15 または today';    break;" +
        "  case '09':    $('target_id').innerHTML = '';    break;" +
        "  case '10':    $('target_id').innerHTML = '';    break;" +
        "  case '11':    $('target_id').innerHTML = '';    break;" +
        "  case '22':    $('target_id').innerHTML = '';    break;" +
        "  case '19':    $('target_id').innerHTML = '';    break;" +
        "  case '21':    $('target_id').innerHTML = '';    break;" +
        "  case '23':    $('target_id').innerHTML = '';    break;" +
        "}"
    end
  end

  describe "change_operator_field_function" do
    it "javascript生成" do
      helper.change_operator_field_function.should ==
        "function change_operator_field(type, num) {" +
        "  display_operator_field('eql', num, (type == 'eql'));" +
        "  display_operator_field('like', num, (type == 'like'));" +
        "  display_operator_field('compare', num, (type == 'compare'));" +
        "}"
    end
  end

  describe "change_value_field_function" do
    it "javascript生成" do
      helper.change_value_field_function.should ==
        "function change_value_field(type, num) {" +
        "  display_value_field('gender', num, (type == 'gender'));" +
        "  display_value_field('country', num, (type == 'country'));" +
        "  display_value_field('text', num, (type == 'text'));" +
        "  display_value_field('boolean', num, (type == 'boolean'));" +
        "  display_value_field('year', num, (type == 'year'));" +
        "  display_value_field('month', num, (type == 'month'));" +
        "  display_value_field('day', num, (type == 'day'));" +
        "  display_value_field('member_category_div', num, (type == 'member_category_div'));" +
        "  display_value_field('user_rank', num, (type == 'user_rank'));" +
        "}"
    end
  end

  describe "年月日セレクトボックス" do
    it "年リスト" do
      list = helper.year_list(2010)
      list.size.should == 101
      list[0].should == 'today'
      list[1].should == "2010"
      list[100].should == "1911"
    end

    it "月リスト" do
      list = helper.month_list
      list.size.should == 13
      list[0].should == 'today'
      list[1].should == "1"
      list[12].should == "12"
    end

    it "日リスト" do
      list = helper.date_list
      list.size.should == 32
      list[0].should == 'today'
      list[1].should == "1"
      list[31].should == "31"
    end
  end
end
