# -*- coding: utf-8 -*-
require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe CampaignEffectsHelper do
  describe "script_for_change_effect_operator_field" do
    it "javascript生成" do
      helper.script_for_change_effect_operator_field("value").should ==
        "switch (value) {" +
        "  case '01':    change_effect_operator_field('assign');    break;" +
        "  case '02':    change_effect_operator_field('assign');    break;" +
        "  case '03':    change_effect_operator_field('add_or_multiply');    break;" +
        "  case '04':    change_effect_operator_field('assign');    break;" +
        "  case '05':    change_effect_operator_field('assign');    break;" +
        "}"
    end
  end

  describe "change_effect_operator_field_function" do
    it "javascript生成" do
      helper.change_effect_operator_field_function.should ==
        "function change_effect_operator_field(type) {" +
        "  display_effect_operator_field('assign', (type == 'assign'));" +
        "  display_effect_operator_field('add_or_multiply', (type == 'add_or_multiply'));" +
        "}"
    end
  end

  describe "script_for_display_effect_suffix" do
    it "javascriptのswitch文が生成される" do
      helper.script_for_display_effect_suffix("target_id", "value").should ==
        "switch (value) {" +
        "  case '01':" +
        "    $('target_id').innerHTML = '% 割引';" +
        "    break;" +
        "  case '02':" +
        "    $('target_id').innerHTML = '円 割引';" +
        "    break;" +
        "  case '03':" +
        "    $('target_id').innerHTML = '';" +
        "    break;" +
        "  case '04':" +
        "    $('target_id').innerHTML = '送料無料';" +
        "    break;" +
        "}"
    end
  end
end
