# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../../spec_helper'

describe EcRider::EcHelper do
  # fixtures :products, :product_displays, :name_masters, :ms_code_names, :ms_shop_settings, :users

  def ec
    helper.ec
  end

  before(:each) do
    @template.output_buffer = ""
  end

  describe "ec:submit" do
    before(:each) do
      @template.extend(ApplicationHelper)
      @template.output_buffer = ''
    end

    it "should work without options" do
      submit = ec.submit
      submit.should == nil
    end

    it "should work with block" do
      ec.submit{ "決済！" }
      submit = @template.output_buffer
      submit.should have_tag("input[type=?]", 'submit')
      submit.should include("決済！")
      submit.should == "<input name=\"commit\" type=\"submit\" value=\"決済！\" />"
    end

    it "should work with text option" do
      submit = ec.submit(:text => "確定〜")
      submit.should have_tag("input[type=?]", 'submit')
      submit.should include("確定〜")
      submit.should == "<input name=\"commit\" type=\"submit\" value=\"確定〜\" />"
    end
  end



end
