# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../../spec_helper'

describe EcRider::EcHelper do

  def ec
    helper.ec
  end

  describe "include_shipping_form_tag" do

    describe "each_included_shippings" do
      before(:each) do
        @template.output_buffer = ""
        mock_address_1 = mock_model(OrderShipping,
          {
            :ordered_at => Time.local(2009, 1, 1, 11, 00, 00)
          })
        mock_address_2 = mock_model(OrderShipping,
          {
            :ordered_at => Time.local(2009, 2, 2, 11, 00, 00)
          })
        @template.instance_variable_set(:@included_shipping_addresses, [mock_address_1, mock_address_2])
        ec.instance_variable_set(:@order_form, mock_model(OrderForm, {:hidden_field => "<input type='hidden' vlaue=''>"}))
      end

      it '<% ec:each_included_shippings do %>～<% end %>' do
        ec.each_included_shippings do
          ec.included_shipping_ordered_at
        end
        @template.output_buffer.should =~ /09\/01\/01/
        @template.output_buffer.should =~ /09\/02\/02/
      end
    end

    describe "included_shipping_address_radio" do
      before(:each) do
        @template.output_buffer = ""
        mock_address = mock_model(OrderShipping,
          {
            :order_id => 1
          })
        ec.instance_variable_set(:@included_shipping_address, mock_address)
        ec.instance_variable_set(:@order_form, mock_model(OrderForm, {:radio_button => "<input type='radio'>"}))
      end

      it '<% ec:included_shipping_address_radio %>' do
        radio_button_tag = ec.included_shipping_address_radio
        radio_button_tag.should have_tag('input[type="radio"]')
        radio_button_tag.should have_tag('script[type="text/javascript"]')
      end
    end

  end
end