# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../../spec_helper'

describe EcRider::EcHelper do
  fixtures :resigned_reasons, :kbn_codes, :kbn_code_names

  def ec
    helper.ec
  end

  before(:each) do
    @template.output_buffer = ""
  end

  def concat(*args)
    args.each{|arg| @template.concat(arg)}
  end

  describe "ec:resignation_form" do
    it "normal usage" do
      @template.instance_variable_set(:@resigned_reason, ResignedReason.new)
      @template.extend(ApplicationHelper)
      ec.resignation_form do
        concat(ec.resignation_form_error_messages || '')
        ec.resignation_form_reason_choice do
          @template.concat(ec.resignation_form_resign_reason_radio)
          @template.concat(ec.resignation_form_resign_reason_label)
        end
        concat(ec.resignation_form_reason_free_text)
        ec.button{ "←前へ戻る"}
        ec.submit{"退会する→"}
        @template.output_buffer
      end
      @template.output_buffer.should have_tag('form[action=?]', "/resign/confirm") do
        with_tag("input#resigned_reason_ms_resigned_reason_id_1[type=?][value=?]", 'radio', '1')
        with_tag("label[for=?]", 'resigned_reason_ms_resigned_reason_id_1', '今後、購入する意思がない')
        with_tag("textarea#resigned_reason_reason")
        with_tag("input[type=?][value=?]", 'button', '←前へ戻る')
        with_tag("input[type=?][value=?]", 'submit', '退会する→')
      end
    end
  end

  describe "ec:resignation_confirmation_form" do
    it "normal usage" do
      @template.instance_variable_set(:@resigned_reason, ResignedReason.new(:ms_resigned_reason_id => 1, :reason => 'ABCD'))
      @template.extend(ApplicationHelper)
      ec.resignation_confirmation_form do
        concat(ec.resignation_confirmation_form_reason_choice).should == ["今後、購入する意思がない"]
        concat(ec.resignation_confirmation_form_reason_free_text).should == ["ABCD"]
        ec.button{ "←前へ戻る"}
        ec.submit{"退会する→"}
        @template.output_buffer
      end
      @template.output_buffer.should have_tag('form[action=?]', "/resign/update_information") do
        with_tag("input[type=?][value=?]", 'button', '←前へ戻る')
        with_tag("input[type=?][value=?]", 'submit', '退会する→')
      end
    end
  end

end
