# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../../spec_helper'

describe EcRider::EcHelper do

  def ec
    helper.ec
  end

  before(:each) do
    @template.output_buffer = ""
  end

  def concat(*args)
    args.each{|arg| @template.concat(arg)}
  end

  describe "ec:secret_question_form" do
    it "normal usage" do
      @template.instance_variable_set(:@user, User.new)
      @template.extend(ApplicationHelper)
      ec.secret_question_form do
        concat(ec.secret_question_form_error_messages || '')
        concat(ec.secret_question_form_remember_question)
        concat(ec.secret_question_form_remember_answer)
        ec.button{ "←前へ戻る"}
        ec.submit{"秘密の質問を変更する→"}
        @template.output_buffer
      end
      @template.output_buffer.should have_tag('form[action=?]', "/account/confirm_security_answer") do
        with_tag("input#user_remember_question")
        with_tag("input#user_remember_answer")
        with_tag("input[type=?][value=?]", 'button', '←前へ戻る')
        with_tag("input[type=?][value=?]", 'submit', '秘密の質問を変更する→')
      end
    end
  end

  describe "ec:secret_question_confirmation_form" do
    it "normal usage" do
      user = User.new
      user.remember_question = '質問'
      user.remember_answer = '回答'
      @template.instance_variable_set(:@user, user)
      @template.extend(ApplicationHelper)
      ec.secret_question_confirmation_form do
        ec.secret_question_confirmation_form_remember_question.should == '質問'
        ec.secret_question_confirmation_form_remember_answer.should == '回答'
        ec.button{ "←前へ戻る"}
        ec.submit{"秘密の質問を変更する→"}
        @template.output_buffer
      end
      @template.output_buffer.should have_tag('form[action=?]', "/account/update_security_answer") do
        with_tag("input[type=?][value=?]", 'button', '←前へ戻る')
        with_tag("input[type=?][value=?]", 'submit', '秘密の質問を変更する→')
      end
    end
  end


end
