# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../../spec_helper'

describe EcRider::EcHelper do
  # fixtures :products, :product_displays, :name_masters, :ms_code_names, :ms_shop_settings, :users

  def ec
    helper.ec
  end

  before(:each) do
    @template.output_buffer = ""
  end

  def concat(*args)
    args.each{|arg| @template.concat(arg)}
  end

  describe "ec:user_password_form" do
    it "normal usage" do
      @template.instance_variable_set(:@user, User.new)
      @template.extend(ApplicationHelper)
      ec.user_password_form do
        concat(ec.user_password_form_error_messages || '')
        concat(ec.user_password_form_password)
        concat(ec.user_password_form_password_confirmation)
        ec.button{ "←前へ戻る"} # ネストするecタグは自動でconcatします。
        ec.submit{"パスワードを変更する"}
        @template.output_buffer
      end
      @template.output_buffer.should have_tag('form[action=?]', "/account/update_password") do
        with_tag("input#user_password")
        with_tag("input#user_password_confirmation")
        with_tag("input[type=?][value=?]", 'button', '←前へ戻る')
        with_tag("input[type=?][value=?]", 'submit', 'パスワードを変更する')
      end
    end
  end


end
