# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../spec_helper'

describe EcRider::I18nSupport do
  include EcRider::I18nSupport

  describe "i18n_message" do
    it "should return messages for locale." do
      i18n_message(:inclusion).should == "は一覧にありません。"
      I18n.locale = 'en'
      i18n_message(:inclusion).should == "is not included in the list"
    end
  end

  describe "i18n_tmp_block" do
    it "should run code block for locale with do end block." do
      I18n.locale.language.should == 'ja'
      i18n_tmp_block('en') do
        I18n.locale.language.should == 'en'
        I18n.t("activerecord.errors.messages.inclusion").should == "is not included in the list"
      end
      I18n.locale.language.should == 'ja'
    end

    it "should run code block for locale with {} block." do
      I18n.locale.language.should == 'ja'
      i18n_tmp_block('en') {I18n.locale.language.should == 'en'}
      I18n.locale.language.should == 'ja'
      result = i18n_tmp_block('en') {[I18n.t("activerecord.errors.messages.inclusion")]}
      result.should == ["is not included in the list"]
      I18n.locale.language.should == 'ja'
    end
  end
end

