# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../spec_helper'

describe Goldberg::RolesHelper do
  include Goldberg::RolesHelper

  describe "check_in_show" do
    it "with nil" do
      check_in_show(nil).should == nil
    end

    it "if role can access" do
      @role = Goldberg::Role.find(1)
      action = Goldberg::SiteAction.find_by_path("countries/index")
      check_in_show(action).should == '○'
    end

    it "if role can't access" do
      @role = Goldberg::Role.find(3)
      action = Goldberg::SiteAction.find_by_path("countries/update")
      check_in_show(action).should == '×'
    end
  end


  describe "site_action_check" do
    it "with nil" do
      @role = Goldberg::Role.find(3)
      fields_for(:role) do |f|
        site_action_check(f, nil).should == nil
      end
    end
    
    it "valid Goldberg::SiteAction" do
      @role = Goldberg::Role.find(3)
      fields_for(:role) do |f|
        action = Goldberg::SiteAction.find_by_path("countries/index")
        action.should_not be_nil
        site_action_check(f, action).should == 
          %(<input class=" site_action_checks" id="action_check_#{action.id}" name="role[action_ids][]" type="checkbox" value="#{action.id}" />&nbsp;&nbsp;<label for="action_check_#{action.id}">検索</label>)
      end
    end
  end


end
