require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe ProductHelper do
  
  #Delete this example and add some real ones or delete this file
  it "is included in the helper object" do
    included_modules = (class << helper; self; end).send :included_modules
    included_modules.should include(ProductHelper)
  end

  before(:each) do
    @product_image1 = ProductImage.new(:thumbnail => "thumb", :filename => "image1.jpg", :main_flg => 1)
    @product_image2 = ProductImage.new(:thumbnail => "thumb", :filename => "image2.jpg", :main_flg => 0)
  end

  describe "product_image_tag" do
    it "画像が無い場合は、「No Image」が表示される" do
      html = helper.product_image_tag(nil)
      html.should have_tag('img[src=?]', "/public/images/no_image.png")
    end

    it "メイン画像の指定があれば、「（メイン画像）」と表示される" do
      html = helper.product_image_tag(@product_image1)
      html.should have_text(/（メイン画像）/)
      html.should have_tag('img[src=?]', "/ec_rider/product_images/0000/0000/image1_thumb.jpg")
    end

    it "画像が表示される" do
      html = helper.product_image_tag(@product_image2)
      html.should have_tag('img[src=?]', "/ec_rider/product_images/0000/0000/image2_thumb.jpg")
    end

  end
end
