# -*- coding: utf-8 -*-
require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe ProductVariationsHelper do
  fixtures :product_variations, :product_variation_displays,
    :product_variation_items, :product_variation_item_displays
  
  #Delete this example and add some real ones or delete this file
  it "is included in the helper object" do
    included_modules = (class << helper; self; end).send :included_modules
    included_modules.should include(ProductVariationsHelper)
  end

  describe "join_to_variation_items" do
    before(:each) do
      @product_variation = ProductVariation.find(:all)
    end

    it "variation_itemsがnil" do
      value = helper.join_to_variation_items(nil)
      value.should == nil
    end

    it "variation_itemsがnil以外" do
      variation_items = @product_variation.first.items
      value = helper.join_to_variation_items(variation_items)
      value.should == "L1, M1, S1"
    end

    it "variation_itemsがnil以外で、オプションを指定する" do
      variation_items = @product_variation.first.items
      value = helper.join_to_variation_items(variation_items, :separetor => "/ ")
      value.should == "L1/ M1/ S1"
    end
  end
  
end
