# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../spec_helper'

describe KbnCode do
  fixtures :kbn_codes, :kbn_code_names
  it "should be a part of condition for :kbn." do
    condition = KbnCode::SearchInfo.new :kbn => '15'
    condition.create_condition.should == ["kbn like ? AND kbn_code_names.locale = ?", "%15%", "ja"]
  end

  it "should be a part of condition for :kbn_name." do
    condition = KbnCode::SearchInfo.new :kbn_name => '職業'
    condition.create_condition.should == ["kbn_name like ? AND kbn_code_names.locale = ?", "%職業%", "ja"]
  end

  it "should be a part of condition for :code." do
    condition = KbnCode::SearchInfo.new :code => '01'
    condition.create_condition.should == ["code like ? AND kbn_code_names.locale = ?", "%01%", "ja"]
  end

  it "should be a part of condition for :name." do
    condition = KbnCode::SearchInfo.new :name => '会社員'
    condition.create_condition.should == ["kbn_code_names.name like ? AND kbn_code_names.locale = ?", "%会社員%", "ja"]
  end

  it "should to_paginate_option to generate options for paginate method" do
      condition = KbnCode::SearchInfo.new
      condition.to_paginate_options.should == {
        :page => nil,
        :per_page => 20,
        :include => :kbn_code_names,
        :order => "kbn_codes.kbn, kbn_codes.code",
        :conditions => ["kbn_code_names.locale = ?", "ja"]
      }

      condition.to_paginate_options(:page => 2).should == {
        :page => 2,
        :per_page => 20,
        :include => :kbn_code_names,
        :order => "kbn_codes.kbn, kbn_codes.code",
        :conditions => ["kbn_code_names.locale = ?", "ja"]
      }

      condition = KbnCode::SearchInfo.new(:kbn => '15', :disp_count => 10)
      condition.to_paginate_options.should == {
        :page => nil,
        :per_page => 10,
        :include => :kbn_code_names,
        :order => "kbn_codes.kbn, kbn_codes.code",
        :conditions => ["kbn like ? AND kbn_code_names.locale = ?", "%15%", "ja"]
      }
      condition.to_paginate_options(:page => 5).should == {
        :page => 5,
        :per_page => 10,
        :include => :kbn_code_names,
        :order => "kbn_codes.kbn, kbn_codes.code",
        :conditions => ["kbn like ? AND kbn_code_names.locale = ?", "%15%", "ja"]
      }
    end
  describe "find_names_by_code" do
    it "" do
      result = KbnCode.find_names_by_code("04")
      result.should == [["一般会員", "000"], ["ParentsChina会員", "001"], ["東軟集団", "101"]]
    end
  end

end
