require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe OrderItemComponent do
  before(:each) do
    @valid_attributes = {
      :qty => 1
    }
  end

  it "should create a new instance given valid attributes" do
    OrderItemComponent.create!(@valid_attributes)
  end

  describe "test get_sku" do
    it "when product_sku is nil" do
      oic = OrderItemComponent.new()
      oic.product_sku = nil
      oic.get_sku.class.name.should == "ProductSku"
      oic.get_sku.id.should be_nil
      oic.get_sku.product_id.should be_nil
      oic.get_sku.sku_code.should be_nil
    end
    it "when product_sku is not nil" do
      oic = OrderItemComponent.new()
      product_sku = ProductSku.new()
      oic.product_sku = product_sku
      oic.get_sku.class.name.should == "ProductSku"
      oic.product_sku.should == product_sku
    end
  end

  describe "test self_if_component" do
    it "when class name is OrderItemComponent" do
      obj = OrderItemComponent.new()
      obj.self_if_component.class.name.should == "OrderItemComponent"
      obj.self_if_component.should == obj
    end
    it "when class name is not OrderItemComponent" do
      obj = OrderItem.new()
      obj.self_if_component.should be_nil
    end
  end
end
