# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../spec_helper'

describe Goldberg do

  describe "clear!" do
    it "clear instance variables" do
      Goldberg.user = Goldberg::User.new # テスト用ダミー
      # Goldberg.credentials = Goldberg::Credentials.new(Goldberg::Role.find(:first).id) # テスト用ダミー
      Goldberg.clear!
      Goldberg.user.should be_nil
      # Goldberg.credentials.should be_nil
    end
  end

  describe "action_authorised?" do
    it "システム管理者" do
      Goldberg.clear!
      Goldberg.set_user(1) # システム管理者 :role_id => 1
      admin_role = Goldberg::Role.find(1) # goldberg_roles(:goldberg_role1) # システム管理者
      Goldberg.user.id.should == admin_role.id
      # credentials = Goldberg::Credentials.new(admin_role.id)
      Goldberg.action_authorised?("inquiry", "index").should == true
      Goldberg.action_authorised?("inquiry", "delete").should == true
      Goldberg.action_authorised?("product", "update").should == true
      Goldberg.action_authorised?("product", "undefined_action").should == false # 存在しないアクション
    end

    it "一般ユーザー" do
      Goldberg.clear!
      Goldberg.set_user(3) # 一般ユーザー :role_id => 3
      user_role = Goldberg::Role.find(3) # goldberg_roles(:goldberg_role3) # 一般ユーザー
      Goldberg.user.id.should == user_role.id
      # credentials = Goldberg::Credentials.new(user_role.id)
      Goldberg.action_authorised?("inquiry", "index").should == true
      Goldberg.action_authorised?("inquiry", "delete").should == false
      Goldberg.action_authorised?("product", "delete").should == false
    end
  end
end
