# To change this template, choose Tools | Templates
# and open the template in the editor.

require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe MailForm do
  before(:each) do
    @mail_form = MailForm.new
  end

  describe "MailForm to test" do
    it "アドレスが単数入力の場合" do
      to_single = "test@ec-one.com"
      mail = MailForm.new(:from => 'test@test.com', :to_single => to_single,
        :subject => 'test_subject', :body => 'a' * 10000, :to_single_use_flg => true)
      mail.valid?.should be_true
    end

    it "アドレスが単数入力の場合(バリデーション不正)" do
      to_single = "test@ec-one.com, test@ec-one.com"
      mail = MailForm.new(:from => 'test@test.com', :to_single => to_single,
        :subject => 'test_subject', :body => 'a' * 10000, :to_single_use_flg => true)
      mail.valid?.should be_false
    end

    it "アドレスが複数入力されている場合" do
      to_list = "test@test.com, test@test.com,  test@test.com"
      mail = MailForm.new(:from => 'test@test.com', :to => to_list,
        :subject => 'test_subject', :body => 'a' * 10000, :to_single_use_flg => false)
      mail.valid?.should be_true
      mail = MailForm.new(:from => 'test@test.com', :to => to_list,
        :subject => 'test_subject', :body => 'a' * 10000)
      mail.valid?.should be_true
    end

    it "アドレスが複数入力されている場合(バリデーション不正)" do
      to_list = "test@test.com, test@test.com,  test@test.com,  "
      mail = MailForm.new(:from => 'test@test.com', :to => to_list,
        :subject => 'test_subject', :body => 'a' * 10000, :to_single_use_flg => false)
      mail.valid?.should be_false
      mail = MailForm.new(:from => 'test@test.com', :to => to_list,
        :subject => 'test_subject', :body => 'a' * 10000)
      mail.valid?.should be_false
    end
  end

  describe "MailForm to_split" do
    it "アドレスが１件のとき" do
      to_list = "test@ec-one.com"
      mail = MailForm.new(:from => 'testfrom@ec-one.com', :to => to_list,
        :subject => 'test_subject', :body => 'a' * 10000, :to_single_use_flg => false)
      mail.to_split.should == ['test@ec-one.com']
    end
    it "アドレスが複数件のとき" do
      to_list = "test@ec-one.com, test@ec-one.com, test@ec-one.com"
      mail = MailForm.new(:from => 'testfrom@ec-one.com', :to => to_list,
        :subject => 'test_subject', :body => 'a' * 10000, :to_single_use_flg => false)
      mail.to_split.should == ['test@ec-one.com', 'test@ec-one.com', 'test@ec-one.com']
      mail.to_split.size.should == 3
    end
    it "アドレスがNULLのとき" do
      to_list = nil
      mail = MailForm.new(:from => 'testfrom@ec-one.com', :to => to_list,
        :subject => 'test_subject', :body => 'a' * 10000, :to_single_use_flg => false)
      mail.to_split.should == []
    end
    it "アドレスが空欄のとき" do
      to_list = ""
      mail = MailForm.new(:from => 'testfrom@ec-one.com', :to => to_list,
        :subject => 'test_subject', :body => 'a' * 10000, :to_single_use_flg => false)
      mail.to_split.should == []
    end
  end
end

