require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe BannerDisplaysController do
  describe "route generation" do
    it "maps #index" do
      route_for(:controller => "banner_displays", :action => "index").should == "/banner_displays"
    end
  
    it "maps #new" do
      route_for(:controller => "banner_displays", :action => "new").should == "/banner_displays/new"
    end
  
    it "maps #show" do
      route_for(:controller => "banner_displays", :action => "show", :id => "1").should == "/banner_displays/1"
    end
  
    it "maps #edit" do
      route_for(:controller => "banner_displays", :action => "edit", :id => "1").should == "/banner_displays/1/edit"
    end

  it "maps #create" do
    route_for(:controller => "banner_displays", :action => "create").should == {:path => "/banner_displays", :method => :post}
  end

  it "maps #update" do
    route_for(:controller => "banner_displays", :action => "update", :id => "1").should == {:path =>"/banner_displays/1", :method => :put}
  end
  
    it "maps #destroy" do
      route_for(:controller => "banner_displays", :action => "destroy", :id => "1").should == {:path =>"/banner_displays/1", :method => :delete}
    end
  end

  describe "route recognition" do
    it "generates params for #index" do
      params_from(:get, "/banner_displays").should == {:controller => "banner_displays", :action => "index"}
    end
  
    it "generates params for #new" do
      params_from(:get, "/banner_displays/new").should == {:controller => "banner_displays", :action => "new"}
    end
  
    it "generates params for #create" do
      params_from(:post, "/banner_displays").should == {:controller => "banner_displays", :action => "create"}
    end
  
    it "generates params for #show" do
      params_from(:get, "/banner_displays/1").should == {:controller => "banner_displays", :action => "show", :id => "1"}
    end
  
    it "generates params for #edit" do
      params_from(:get, "/banner_displays/1/edit").should == {:controller => "banner_displays", :action => "edit", :id => "1"}
    end
  
    it "generates params for #update" do
      params_from(:put, "/banner_displays/1").should == {:controller => "banner_displays", :action => "update", :id => "1"}
    end
  
    it "generates params for #destroy" do
      params_from(:delete, "/banner_displays/1").should == {:controller => "banner_displays", :action => "destroy", :id => "1"}
    end
  end
end
