require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe BannersController do
  describe "route generation" do
    it "maps #index" do
      route_for(:controller => "banners", :action => "index").should == "/banners"
    end
  
    it "maps #new" do
      route_for(:controller => "banners", :action => "new").should == "/banners/new"
    end
  
    it "maps #show" do
      route_for(:controller => "banners", :action => "show", :id => "1").should == "/banners/1"
    end
  
    it "maps #edit" do
      route_for(:controller => "banners", :action => "edit", :id => "1").should == "/banners/1/edit"
    end

  it "maps #create" do
    route_for(:controller => "banners", :action => "create").should == {:path => "/banners", :method => :post}
  end

  it "maps #update" do
    route_for(:controller => "banners", :action => "update", :id => "1").should == {:path =>"/banners/1", :method => :put}
  end
  
    it "maps #destroy" do
      route_for(:controller => "banners", :action => "destroy", :id => "1").should == {:path =>"/banners/1", :method => :delete}
    end
  end

  describe "route recognition" do
    it "generates params for #index" do
      params_from(:get, "/banners").should == {:controller => "banners", :action => "index"}
    end
  
    it "generates params for #new" do
      params_from(:get, "/banners/new").should == {:controller => "banners", :action => "new"}
    end
  
    it "generates params for #create" do
      params_from(:post, "/banners").should == {:controller => "banners", :action => "create"}
    end
  
    it "generates params for #show" do
      params_from(:get, "/banners/1").should == {:controller => "banners", :action => "show", :id => "1"}
    end
  
    it "generates params for #edit" do
      params_from(:get, "/banners/1/edit").should == {:controller => "banners", :action => "edit", :id => "1"}
    end
  
    it "generates params for #update" do
      params_from(:put, "/banners/1").should == {:controller => "banners", :action => "update", :id => "1"}
    end
  
    it "generates params for #destroy" do
      params_from(:delete, "/banners/1").should == {:controller => "banners", :action => "destroy", :id => "1"}
    end
  end
end
