require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe CampaignConditionsController do
  describe "route generation" do
    it "maps #index" do
      route_for(:controller => "campaign_conditions", :action => "index").should == "/campaign_conditions"
    end
  
    it "maps #new" do
      route_for(:controller => "campaign_conditions", :action => "new").should == "/campaign_conditions/new"
    end
  
    it "maps #show" do
      route_for(:controller => "campaign_conditions", :action => "show", :id => "1").should == "/campaign_conditions/1"
    end
  
    it "maps #edit" do
      route_for(:controller => "campaign_conditions", :action => "edit", :id => "1").should == "/campaign_conditions/1/edit"
    end

    it "maps #create" do
      route_for(:controller => "campaign_conditions", :action => "create").should == {:path => "/campaign_conditions", :method => :post}
    end

    it "maps #update" do
      route_for(:controller => "campaign_conditions", :action => "update", :id => "1").should == {:path =>"/campaign_conditions/1", :method => :put}
    end
  
    it "maps #destroy" do
      route_for(:controller => "campaign_conditions", :action => "destroy", :id => "1").should == {:path =>"/campaign_conditions/1", :method => :delete}
    end
  end

  describe "route recognition" do
    it "generates params for #index" do
      params_from(:get, "/campaign_conditions").should == {:controller => "campaign_conditions", :action => "index"}
    end
  
    it "generates params for #new" do
      params_from(:get, "/campaign_conditions/new").should == {:controller => "campaign_conditions", :action => "new"}
    end
  
    it "generates params for #create" do
      params_from(:post, "/campaign_conditions").should == {:controller => "campaign_conditions", :action => "create"}
    end
  
    it "generates params for #show" do
      params_from(:get, "/campaign_conditions/1").should == {:controller => "campaign_conditions", :action => "show", :id => "1"}
    end
  
    it "generates params for #edit" do
      params_from(:get, "/campaign_conditions/1/edit").should == {:controller => "campaign_conditions", :action => "edit", :id => "1"}
    end
  
    it "generates params for #update" do
      params_from(:put, "/campaign_conditions/1").should == {:controller => "campaign_conditions", :action => "update", :id => "1"}
    end
  
    it "generates params for #destroy" do
      params_from(:delete, "/campaign_conditions/1").should == {:controller => "campaign_conditions", :action => "destroy", :id => "1"}
    end
  end
end
