require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe ProductImagesController do
  describe "route generation" do
    it "maps #index" do
      route_for(:controller => "product_images", :action => "index").should == "/product_images"
    end
  
    it "maps #new" do
      route_for(:controller => "product_images", :action => "new").should == "/product_images/new"
    end
  
    it "maps #show" do
      route_for(:controller => "product_images", :action => "show", :id => "1").should == "/product_images/1"
    end
  
    it "maps #edit" do
      route_for(:controller => "product_images", :action => "edit", :id => "1").should == "/product_images/1/edit"
    end

  it "maps #create" do
    route_for(:controller => "product_images", :action => "create").should == {:path => "/product_images", :method => :post}
  end

  it "maps #update" do
    route_for(:controller => "product_images", :action => "update", :id => "1").should == {:path =>"/product_images/1", :method => :put}
  end
  
    it "maps #destroy" do
      route_for(:controller => "product_images", :action => "destroy", :id => "1").should == {:path =>"/product_images/1", :method => :delete}
    end
  end

  describe "route recognition" do
    it "generates params for #index" do
      params_from(:get, "/product_images").should == {:controller => "product_images", :action => "index"}
    end
  
    it "generates params for #new" do
      params_from(:get, "/product_images/new").should == {:controller => "product_images", :action => "new"}
    end
  
    it "generates params for #create" do
      params_from(:post, "/product_images").should == {:controller => "product_images", :action => "create"}
    end
  
    it "generates params for #show" do
      params_from(:get, "/product_images/1").should == {:controller => "product_images", :action => "show", :id => "1"}
    end
  
    it "generates params for #edit" do
      params_from(:get, "/product_images/1/edit").should == {:controller => "product_images", :action => "edit", :id => "1"}
    end
  
    it "generates params for #update" do
      params_from(:put, "/product_images/1").should == {:controller => "product_images", :action => "update", :id => "1"}
    end
  
    it "generates params for #destroy" do
      params_from(:delete, "/product_images/1").should == {:controller => "product_images", :action => "destroy", :id => "1"}
    end
  end
end
