require File.expand_path(File.dirname(__FILE__) + '/../../spec_helper')

describe "/product_categories/edit.html.erb" do
  include ProductCategoriesHelper
  
  before(:each) do
    assigns[:product_categories] = ProductCategory.find(:all)
    assigns[:product_category] = @product_category = stub_model(ProductCategory,
      :new_record? => false,
      :parent_id => 1,
      :name_for_admin => "value for name_for_admin"
    )
  end

  it "renders the edit product_category form" do
    render
    
    response.should have_tag("form[action=#{product_category_path(@product_category)}][method=post]") do
      with_tag('select#product_category_parent_id[name=?]', "product_category[parent_id]")
      with_tag('input#product_category_display_order[name=?]', "product_category[display_order]")
      with_tag('input#product_category_name_for_admin[name=?]', "product_category[name_for_admin]")
      with_tag('select#product_category_url_select[name=?]', "product_category[url]")
      with_tag('input#product_category_url[name=?]', "product_category[url]")
      with_tag('input#product_category_staff_emails[name=?]', "product_category[staff_emails]")
    end
  end
end


