require File.expand_path(File.dirname(__FILE__) + '/../../spec_helper')


describe "/user/edit" do
  fixtures :users, :user_emails, :user_addresses, :mail_templates,
    :mail_deliveries, :kbn_codes, :kbn_code_names,
    :user_points, :user_ranks, :point_settings, :shop_settings
  include UserHelper
  
  before(:each) do
    params[:id] = 1008
    assigns[:user] = @user = User.find(params[:id])
    assigns[:user_address] = assigns[:user].user_address
    assigns[:user_email] = stub_model(UserEmail, :email => 'test@ec-one.com')
    assigns[:shipping_addresses] = []
  end

  it "PCサイト用のEmailアドレスの入力フォームが表示される。" do
    render
    response.should have_tag('input#user_email_email[name=?][size=?][type=?]',
      "user_email[email]", "40", 'text')
    response.should have_tag('input#user_email_user_id[name=?][type=?]',
      'user_email[user_id]', 'hidden')
  end
  
  it "ログインIDの編集フォームが存在する。" do
    render
    response.should have_tag('input#user_login_id[name=?][size=?][type=?]',
      'user[login_id]', '20', 'text')
  end
end
