module DirFixtures

  autoload :Definition, 'dir_fixtures/definition'
  autoload :Backup, 'dir_fixtures/backup'
  autoload :Fixture, 'dir_fixtures/fixture'

  class << self
    def [](path)
      result = definitions[path]
      raise NoDefinitionError, "no definition found: #{path}" unless result
      result
    end

    def definitions
      @definitions ||= {}
    end

    def define(path, &block)
      definition = Definition.new(path)
      definitions[path] = definition
      definition.instance_eval(&block) if block
      definition.after_initialize
      definition
    end

  end

  class NoDefinitionError < StandardError
  end

  class BackupError < StandardError
  end

  class ProtectViolationError < StandardError
  end

  class SubversionViolationError < StandardError
  end


end
