# -*- coding: utf-8 -*-
class RuntimeController < ApplicationController

  # パラメータで指定したURLが有効か判定します。
  def validate_url
    invalid_urls = []
    if params[:url]
      params[:url].each do |url|
        unless url =~ /^\//
          invalid_urls << url
          next
        end
        parted_url = ActionController::Routing::Routes.recognize_path(url)
        controller = (parted_url[:controller].camelize << "Controller").constantize
        if controller.nil?
          invalid_urls << url
        elsif controller == CmsController
          invalid_urls << url unless File.exists?(File.join(EcRider.config.ec_front_root, 'app', 'views', 'cms', "#{parted_url[:action]}.html.erb"))
        else
          invalid_urls << url unless controller.public_instance_methods.include?(parted_url[:action])
        end
      end
    end
    render :json => {:invalid_urls => invalid_urls}.to_json
  end
end
