# -*- coding: utf-8 -*-
module EcRider
  module EcHelper
    module AccountFormTag
      extend MethodDescription

      desc <<-EOS
        [概要: 会員情報変更用のフォームを出力します。]
      EOS
      def account_form(&block)
        unless @template.instance_variable_get(:@user_address) && @template.instance_variable_get(:@user_profile) && @template.instance_variable_get(:@user_email)
          raise UsageError, "ここでは使用できません。"
        end
        @template.form_for(:user_address, @template.instance_variable_get(:@user_address), :url => {:controller => 'account', :action => :confirm_update_information}, :html => {:id => "account_form" }) do |f|
           @template.fields_for(:user_en_address, @template.instance_variable_get(:@user_en_address)) do |f1|
              @template.fields_for(:user_email, @template.instance_variable_get(:@user_email)) do |f2|
                @template.fields_for(:user_profile, @template.instance_variable_get(:@user_profile)) do |f3|
                  @user_address = f
                  @user_en_address = f1
                  @user_email = f2
                  @user_profile = f3
                  begin
                    @template.concat(@template.capture(&block))
                  ensure
                  @user_address = nil
                  @user_en_address = nil
                  @user_email = nil
                  @user_profile = nil
                  end
                end
              end
           end
        end
      end

      desc <<-EOS
        [概要: 会員情報変更のエラーメッセージがあればそれを表示します。会員情報変更用のフォーム内で使用してください。]
      EOS
      def account_form_error_messages
        @template.template_error_messages_for(:user_address, :user_en_address, :user_email, :user_profile)
      end

      desc <<-EOS
        [概要: 登録内容の確認用のフォームを出力します。]
      EOS
      def account_confirmation_form(&block)
        unless @template.instance_variable_get(:@user_address) && @template.instance_variable_get(:@user_email) && @template.instance_variable_get(:@user_profile)
          raise UsageError, "ここでは使用できません。"
        end
        @template.form_for(:user_address, @template.instance_variable_get(:@user_address), :url => {:controller => 'account', :action => :update_information}, :html => {:id => "account_confirmation_form" }) do |f|
           @template.fields_for(:user_en_address, @template.instance_variable_get(:@user_en_address)) do |f1|
              @template.fields_for(:user_email, @template.instance_variable_get(:@user_email)) do |f2|
                @template.fields_for(:user_profile, @template.instance_variable_get(:@user_profile)) do |f3|
                  @user_address = f
                  @user_en_address = f1
                  @user_email = f2
                  @user_profile = f3
                  begin
                    @template.concat(@template.capture(&block))
                  ensure
                  @user_address = nil
                  @user_en_address = nil
                  @user_email = nil
                  @user_profile = nil
                end
              end
            end
          end
        end
      end

    end
  end
end
