# -*- coding: utf-8 -*-
module EcRider
  module EcHelper
    
    # フォームに関係する共通的なタグを定義します
    module FormTag
      extend MethodDescription
      
      desc <<-EOS
        [概要: サブミットボタン(<input type="submit"/>)を出力します。]
      EOS
      def submit(options = {}, &block)
        options ||= {}
        text = options.delete(:text)
        text = @template.capture(&block) if block_given?
        result = @template.submit_tag(text, options) if text
        # ブロックが渡されたメソッド(空でない中身を持つecタグ)は <%= %> ではなく <% %>で出力されるので、
        # 結果をoutput_bufferに出力するようにconcatします
        @template.concat(result) if result && block_given?
        result
      end

      desc <<-EOS
        [概要: ボタンを二度押し防止のJavaScriptを出力します。]
      EOS
      def prevent_double_submit
        @template.render(:partial => "layouts/double_submitt_prevention")
      end
      alias_method :prevent_double_subbmit, :prevent_double_submit


    end
  end
end
