module EcRider
  module ProductCategoriesHelper
    #
    # = カテゴリ階層を一行で表示します =
    #
    def one_line_category_tree(category, options={:link => false, :separator => " > "})
      display_link = options[:link]
      html = ""
      return html if category == nil
      if category.parents.size > 0
        category.parents.each do |parent|
          html << one_line_category_name(display_link, parent)
          html << (options[:separator] == nil ? " > " : options[:separator])
        end
      end
      html << one_line_category_name(display_link, category)
      return html
    end

    #
    # = カテゴリ名をリンクもしくは文字列で表示します =
    #
    def one_line_category_name(display_link, category)
      if display_link
        # リンクで表示する場合
        return link_to(category.name_for_admin, {:controller => "cms", :action => category.url, :category => category.code})
      else
        # 文字列で表示する場合
        return category.name_for_admin
      end
    end

  end
end
