class CmsProjectAssign < ActiveRecord::Base

  belongs_to :cms_project, :foreign_key=> "cms_project_id"
  belongs_to :goldberg_user, :class_name => "Goldberg::User", :foreign_key=> "goldberg_user_id"

  selectable_attr :role do
    entry '0', :editor, '作成者'
    entry '1', :checker, '確認者'
    entry '2', :approver, '承認者'
  end

  # =セレクトボックス用リストを返します=
  def self.supervisor_list
    @supervisor_options = Goldberg::User.find(:all, :select => 'id, name', :order => 'name').
      map{|goldberg_user| [goldberg_user.name, goldberg_user.id] }
  end

  # =ユーザー名がキー、メールアドレスが値のハッシュを返します=
  def self.supervisor_mail_addresses
    supervisor_mail_addresses = Goldberg::User.find(:all, :select => 'id, email').
      map{|goldberg_user| [goldberg_user.id, "'#{goldberg_user.email}'"] }
    Hash[*supervisor_mail_addresses.flatten]
  end
end
