class DistributorDeliveryTime < ActiveRecord::Base
  # :delivery_time_displaysは凡長なので、定義し直しました。
  # 互換性のために古い定義も残しておきます。今後、この定義は使用しないようにしてください。
  has_many :delivery_time_displays, :class_name => "DistributorDeliveryTimeDisplay", :foreign_key => "distributor_delivery_time_id"
  accepts_nested_attributes_for :delivery_time_displays

  has_many :displays, :class_name => "DistributorDeliveryTimeDisplay", :foreign_key => "distributor_delivery_time_id"
  accepts_nested_attributes_for :displays

  validates_format_of :code, :with => /^[a-zA-Z0-9_\-]*$/
  validates_length_of :code, :maximum=>5, :allow_nil => true

  def self.get_name(country_code, code, locale)
    country = Country.find_by_code(country_code)
    return '' if country.nil? || country.distributor.nil?
    where = "distributor_delivery_times.distributor_id = ? AND distributor_delivery_time_displays.locale = ? AND distributor_delivery_times.code = ?"
    time_display = DistributorDeliveryTimeDisplay.find(:first, :include => :distributor_delivery_time, :conditions => [where, country.distributor.id, locale, code])
    return time_display ? time_display.name : ''
  end
end
