# -*- coding: utf-8 -*-
require 'ec_rider/selectable_attr_ext'

class KbnCodeName < ActiveRecord::Base
  versioned
  belongs_to :kbn_code, :class_name => 'KbnCode', :foreign_key => 'kbn_code_id'

  def validate
    if self.locale == I18n.default_locale && self.name.blank?
      errors.add("name", "日本語[ja] は必ず入力してください。")
    end
  end

  def self.find_code_names_by_kbn_code_id(kbn_code_id)
    code_names = []
    I18n.supported_locales.each do |locale|
      code_name = KbnCodeName.find(:first, :conditions => ['kbn_code_id = ? and locale = ?', kbn_code_id, locale.to_s])
      code_names << (code_name.nil? ? KbnCodeName.new({:locale => locale.to_s}) : code_name)
    end
    return code_names
  end
end
