module LocaleDisplayable
  def display_name(locale = I18n.locale.to_s)
    locale = I18n.regularize(locale)
    display_names[locale] || display_names['ja'] 
  end
  
  def display_names(force_load = false)
    if @display_names.nil? || force_load
      @display_names = self.displays.inject({}) do |dest, display|
        dest[display.locale.to_s] = display.name unless display.name.blank?
        dest
      end
    end
    @display_names
  end
  
  def build_displays(value)
    value.each do |locale, name|
      displays.build(:locale => locale.to_s, :name => name.to_s)
    end
    @display_names = nil
  end

  def save_displays(display_hash = nil)
    display_hash ||= @display_names
    return unless display_hash
    display_names = display_hash.dup
    self.displays.each do |display|
      display.name = display_names.delete(display.locale)
      if display.name.blank?
        display.destroy
      else
        display.save!
      end
    end
    display_names.each do |locale, name|
      locale = I18n.regularize(locale)
      next if name.blank?
      disp = self.displays.create(:locale => locale, :name => name.to_s)
    end
    @display_names = nil
  end

end
