# -*- coding: utf-8 -*-
class MailForm < ActiveForm

  attr_accessor :from, :to, :subject, :body, :to_single, :to_single_use_flg, :locale

  validates_length_of  :subject, :minimum => 1, :message => :EM990001
  validates_presence_of :to_single, :message => :EM990001, :if => :to_single?
 	validates_presence_of :to, :message => :EM990001, :if => :not_to_single?
  validates_length_of  :body, :minimum => 1, :message => :EM990001
  validates_length_of  :body, :maximum => 10000, :message => :EM990012

 	# 送信メールアドレス(１箇所)のチェック
  validates_format_of  :to_single,  :with => /^([a-zA-Z0-9])+([a-zA-Z0-9\._+-])*@([a-zA-Z0-9_-])*\.([a-zA-Z0-9_-])+([a-zA-Z0-9\._-]+)+$/,
 		      :message => :EM990007, :if => :to_single?
 	# 送信メールアドレス(複数)のチェック
 	validates_format_of  :to,
 		      :with => /^([a-zA-Z0-9])+([a-zA-Z0-9\._+-])*@([a-zA-Z0-9_-])*\.([a-zA-Z0-9_-])+([a-zA-Z0-9\._-]+)+((\s)*,(\s)*([a-zA-Z0-9])+([a-zA-Z0-9\._+-])*@([a-zA-Z0-9_-])*\.([a-zA-Z0-9_-])+([a-zA-Z0-9\._-]+))*$/,
 		      :message => :EM990007, :if => :not_to_single?

  def to_single?
    to_single_use_flg
  end

  def not_to_single?
    !to_single_use_flg
  end

  # 複数のメール送信先文字列を配列にして返却します。
  def to_split
    to_list = []
    unless (self.to.nil? || self.to.blank?)
      self.to.split(/\s*,\s*/).each do |to|
        to_list << to.strip
      end
    end
    return to_list
  end

end
