module ModelSerializable
  def self.included(mod)
    mod.extend(ClassMethods)
  end

  module ClassMethods
    def attr_deserializable_array(objects_attr, class_name, ids_attr)
      method_definition = <<-"EOS"
        def #{objects_attr}(&block)
          unless @#{objects_attr}
            if @#{ids_attr}
              @#{objects_attr} = #{class_name}.find(:all, :conditions => ['id in (?)', @#{ids_attr}])
              @#{ids_attr} = nil
            else
              @#{objects_attr} = []
            end
          end
          block ?
            @#{objects_attr}.select(&block) :
            @#{objects_attr}
        end
      EOS
      module_eval(method_definition)
    end
  end
end
