# -*- coding: utf-8 -*-
class OrderItemComponent < ActiveRecord::Base
  include EcRider::ValidationExt
  versioned
  acts_as_paranoid

  belongs_to :order_item
  belongs_to :product_sku, :class_name => 'ProductSku', :foreign_key => 'component_sku_id', :with_deleted => true

  # 対象の商品SKUを返す
  # 紐付く商品SKUが無い場合（削除されている場合）は、新規ProductSkuインスタンスを返す
  def get_sku
    return self.product_sku if self.product_sku
    return ProductSku.new()
  end

  # クラス名が OrderItemComponent の場合、自分自身を返す
  # そうでない場合、nilを返す
  def self_if_component
    return self if self.class.name == "OrderItemComponent"
    return nil
  end
end
