class Prefecture < ActiveRecord::Base
  has_many :prefecture_displays, :class_name => "PrefectureDisplay", :foreign_key => "prefecture_id"
  
  # ロケールごとの都道府県名称を配列で返却します。
  def self.prefecture_names(locale = "")
    find_options = {
      :select => 'name',
      :joins => 'left outer join prefectures on (prefecture_displays.prefecture_id = prefectures.id)',
      :conditions => ["locale = ?", locale],
      :order => 'code'
    }
    names = []
    PrefectureDisplay.find(:all, find_options).each{|dispay| names << dispay.name}
    return names
  end
  # ロケールごとの都道府県名称を配列で返却します。
  def prefecture_name(locale = "")
    self.prefecture_displays.each do |display|
      if display.locale == locale
        return display.name
      end
    end
  end
  
  # 都道府県名から都道府県データを取得します。
  def self.find_by_name(name = "")
    Prefecture.find(:first, :conditions => ['prefecture_displays.name = ?', name], :include => :prefecture_displays)
  end

  # 都道府県コードから送料データを取得します。
  def shipping_costs
    ShippingCost.find(:all, :conditions => ['area_code = ?', self.code], :order => 'id')
  end
end
