class ProductComponent < ActiveRecord::Base
  versioned

  belongs_to :product_sku
  belongs_to :component_sku, :class_name => 'ProductSku', :foreign_key => 'component_sku_id'

  validates_presence_of :count
  validates_numericality_of :count, :greater_than => 0, :less_than_or_equal_to => 9999, :if => Proc.new{|c| !c.count.blank?}

  # 渡されたSKUのリストに対して仮引き当て数を取得してセットする
  def self.set_component_parent_sku_id(product_skus)
    sku_ids = product_skus.map{|sku| sku.id }
    product_components = count('id', :conditions => ['product_sku_id IN (?)', sku_ids], :group => 'product_sku_id')
    product_skus.each do |sku|
      sku.component_parent_sku_id = (product_components[sku.id] ? sku.id : nil)
    end
    return product_skus
  end
end
