# -*- coding: utf-8 -*-
class ResignedReason < ActiveRecord::Base
  acts_as_paranoid
  belongs_to :user

  #文字数バリデーション
  validates_length_of   :reason, :maximum => 1000, :message => :EM990012, :if => :check_reason?
  #（半角英数＋半角記号＋半角スペース）
  validates_format_of :reason, :with => /^[A-Za-z0-9,_\.\-\+\(\)\s]*$/, :message => :EM990028, :if => :is_english_format?

  # 退会理由
  selectable_attr :ms_resigned_reason_id do
    update_with_kbn KbnCode.name_div_id_by_key(:reasons)
  end

  # 自由記入欄が入力されていたらtrueを返す
  def check_reason?
    return !reason.blank?
  end

  # 英数チェックする場合はtrueを返す
  def is_english_format?
    I18n.locale.to_s != 'ja'
  end

end
