# -*- coding: utf-8 -*-
# http://www.yotabanana.com/hiki/ja/ruby-locale-rails-howto.html

# ロケールのYAML内でERBを使えるようにします。
I18n.backend = I18n::Backend::Erb.new

# 翻訳ファイルが置かれているディレクトリを指定します。
locale_files = Dir[ File.join(RAILS_ROOT, 'config', 'locales', '*.{rb,yml}') ].reject{|locale| /translation_/ =~ locale}
I18n.load_path += locale_files

# このアプリケーションがサポートしているロケールを指定します。
# これはRuby-Locale for Ruby on Railsが提供する追加機能です。
# 指定がない場合は、特にロケールを限定することなく、WWWブラウザから与えられたロケール情報を
# 値として使用します。
# リソースを適切に絞り込むためにはこの設定が必須です。
# 環境変数により、ロケールを絞り込むよう設定がされています。
I18n.supported_locales = EcRider.config.ec_locale #%w(ja ko zh_CN zh_TW en th) # locale_files.map{|v| File.basename(v, ".*")}.uniq

# デフォルトのロケールを設定します。"en"以外を指定したい場合のみ、この値を使用します。
# Ruby-Localeでは優先度のもっとも低いロケールとしてこの値が使われます。
# I18n.default_locale = "pt-BR"
# I18n.default_locale = "ja-JP" # これだと、config/locales/ja.ymlを読んでくれません。
# I18n.default_locale = :ja
I18n.default_locale = 'ja'

# このアプリケーションが単一のロケールのみを使う場合はI18n.default_localeとともに、
# Locale.defaultを指定してください。この設定はRuby-Localeでロケールを強制的に指定するものです。
# Locale.default = "ja-JP"
