class RenameModelGenerator < Rails::Generator::NamedBase
  self.config do |options|
    options[:file_patterns] = [
      "app/controllers/**/*.{rb,rhtml,erb}", 
      "app/helpers/**/*.{rb,rhtml,erb}", 
      "app/views/**/*.{rb,rhtml,erb}", 
      "app/mailers/**/*.{rb,rhtml,erb}", 
      "config/**/*.{rb,rhtml,erb,yml}", 
      "lib/**/*.{rb,rhtml,erb}", 
      "spec/controllers/**/*.rb", 
      "spec/helpers/**/*.rb", 
      "spec/views/**/*.rb", 
      "spec/fixtures/**/*.{yml,yaml}", 
      "test/**/*.rb", 
      "test/fixtures/**/*.{yml,yaml}"]
    # options[:mv_path_keywords] = [:model_path, :spec_model_path, :unit_test_path, :fixture_yml_path, :fixture_yaml_path, :fixture_csv_path]
    options[:mv_path_keywords] = [:model_path, :spec_model_path]
    # options[:replace_keywords] = [:class_name, :foreign_key_name, :unit_test_name, :table_name]
    options[:replace_keywords] = [:class_name]
  end
  
  def self.update_assigned_names(names)
    # If you want to replace something name, comment off followings
    #   names[:xxxx] = "#{names[:class_name]}Xxxx"
    # And change a line into self.config 
    #   options[:replace_keywords] = [:class_name, :foreign_key_name, :unit_test_name, :table_name, :xxxx]
    # 
    # If you use ar_formatter plugin, append following lines
    #   names[:formatter_path] = "app/helpers/formatters/#{names[:file_path]}_formatter.rb"
    #   names[:formatter_class_name] = "#{names[:class_name]}Formatter"
    # and add :formatter_path to options[:mv_path_keywords]
    # and add :formatter_class_name to options[:replace_keywords]
  end
end
