class CreateOrderItemComponents < ActiveRecord::Migration
  def self.up
    create_table :order_item_components, :comment => "注文商品構成" do |t|
      t.integer :order_item_id, :comment => "注文商品ID"
      t.integer :component_sku_id, :comment => "子商品SKUのID"
      t.integer :qty, :comment => "子商品SKUの総数量"
      t.string :product_name, :limit => 120, :comment => "商品名1"
      t.string :order_product_name_1, :limit => 120, :comment => "管理用商品名（日本語）"
      t.string :order_product_name_2, :limit => 120, :comment => "管理用商品名（英語）"
      t.datetime :created_at, :comment => ""
      t.datetime :updated_at, :comment => ""
      t.datetime :deleted_at, :comment => ""
      t.integer :creator_id, :comment => "データ登録者"
      t.integer :updater_id, :comment => "データ更新者"
      t.integer :deleter_id, :comment => "データ削除者"
    end

    add_index "order_item_components", ["order_item_id"], :name => "index_order_item_components_on_order_item_id"
    add_index "order_item_components", ["component_sku_id"], :name => "index_order_item_components_on_component_sku_id"
    add_index "order_item_components", ["creator_id"], :name => "index_order_item_components_on_creator_id"
    add_index "order_item_components", ["deleter_id"], :name => "index_order_item_components_on_deleter_id"
    add_index "order_item_components", ["updater_id"], :name => "index_order_item_components_on_updater_id"
  end

  def self.down
    drop_table :order_item_components
  end
end
