class CreateOrderCampaigns < ActiveRecord::Migration
  def self.up
    create_table :order_campaigns, :comment => "注文キャンペーン" do |t|
      t.integer :order_id, :comment => "注文ID"
      t.integer :campaign_id, :comment => "キャンペーンID"
      t.string :campaign_code, :limit => 10, :comment => "キャンペーンコード"
      t.string :campaign_name, :limit => 60, :comment => "キャンペーン名称"
      t.string :campaign_name_for_admin, :limit => 60, :comment => "管理用キャンペーン名称"
      t.datetime :created_at, :comment => ""
      t.datetime :updated_at, :comment => ""
      t.datetime :deleted_at, :comment => ""
      t.integer :creator_id, :comment => "データ登録者"
      t.integer :updater_id, :comment => "データ更新者"
      t.integer :deleter_id, :comment => "データ削除者"
    end

    add_index "order_campaigns", ["order_id"], :name => "index_order_campaigns_on_order_id"
    add_index "order_campaigns", ["campaign_id"], :name => "index_order_campaigns_on_campaign_id"
  end

  def self.down
    drop_table :order_campaigns
  end
end
