# -*- coding: utf-8 -*-
class AddCommentToAnyTables < ActiveRecord::Migration
  def self.up
    column_comments :inquiries, {
      "user_id" => "会員ID",
      "inquiry_div" => "問合せ区分",
      "name_last" => "姓",
      "name_first" => "名",
      "kana_name_last" => "カナ姓",
      "kana_name_first" => "カナ名",
      "address_1" => "都道府県",
      "address_2" => "市区町村町域",
      "address_3" => "番地・マンション名",
      "email" => "メールアドレス",
      "inquiry" => "問合せ内容",
      "status_div" => "ステータス"
    }

    column_comments :inquiriy_memos , {
      "inquiry_id" => "問合せID",
      "creator_name" => "記入者名",
      "memo" => "メモ"
    }

    table_comment("kbn_code_names", :comment => "名称項目")

    column_comments :kbn_codes , {
      "kbn" => "区分",
      "kbn_name" => "区分名称",
      "code" => "コード"
    }

    column_comments :mail_deliveries , {
      "user_id" => "会員ID",
      "deliveried_at" => "送信日時",
      "header" => "ヘッダー",
      "subject" => "件名",
      "site_div" => "サイト区分",
      "mail_body" => "本文",
      "message_id" => 'メッセージID',
      "to_address" => '宛先',
      "from_address" => '送信元',
      "order_id" => '注文ID'
    }

    column_comments :mail_templates , {
      "name" => "名称",
      "mail_type_div" => "メール区分",
      "pc_subject_template" => "PC用タイトル",
      "pc_text" => "PC用本文（テキスト）",
      "pc_html" => "PC用本文（HTML）",
      "mobile_subject_template" => "モバイル用タイトル",
      "mobile_text" => 'モバイル用本文（テキスト）',
      "mobile_html" => 'モバイル用本文（HTML）'
    }

    column_comments :order_items , {
      "order_shipping_id" => "注文配送ID",
      "unit_price" => "単価"
    }
    
    table_comment("order_shippings", :comment => "注文配送")
    column_comments :order_shippings , {
      "order_id" => "注文ID",
      "order_code" => "注文配送コード",
      "status_div" => "ステータス",
      "name_last" => '配送先（姓）',
      "name_first" => "配送先（名）",
      "kana_name_last" => '配送先（カナ姓）',
      "kana_name_first" => '配送先（カナ名）',
      "address_1" => "配送先住所１",
      "address_2" => "配送先住所２",
      "address_3" => "配送先住所３",
      "arrival_date" => "配送予定日",
      "arrival_hour" => "配送予定時間",
      "payment_type_div" => '支払い方法',
      "delivery_div" => "配送区分",
      "shipping_cost" => "送料＋手数料"
    }

    table_comment("orders", :comment => "注文")
    column_comments :order_shippings , {
      "ec_order_code" => "注文コード",
      "user_id" => "会員ID",
      "ordered_at" => "注文日時",
      "free_request" => '自由記入欄'
    }

    column_comments :products , {
      "product_code" => "商品コード"
    }

    column_comments :resigned_reasons , {
      "user_id" => "会員ID",
      "ms_resigned_reason_id" => "退会理由",
      "reason" => "退会理由（その他）"
    }

    column_comments :user_addresses , {
      "user_id" => "会員ID",
      "name_last" => "姓",
      "name_first" => "名",
      "kana_name_last" => "カナ姓",
      "kana_name_first" => "カナ名",
      "address_1" => "住所１",
      "address_2" => "住所２",
      "address_3" => "住所３"
    }

    column_comments :user_emails , {
      "user_id" => "会員ID",
      "email" => "メールアドレス",
      "mail_address_pc_mobile_div" => "PCメール、携帯メール区分"
    }

    column_comments :users , {
      "user_code" => "会員コード",
      "name_last" => "姓",
      "name_first" => "名",
      "birth_year" => "生年月日（年）",
      "birth_month" => "生年月日（月）",
      "birth_day" => "生年月日（日）",
      "resigned_at" => "退会日時",
      "sex" => "性別",
      "remember_answer" => "秘密の質問回答",
      "regist_div" => "登録サイト区分",
      "job_div" => "職業",
      "dm_send_div" => "DM送付希望区分",
      "csv_output_div" => "CSV出力区分"
    }
  end

  def self.down
    column_comments :inquiries , {
      "user_id" => "",
      "inquiry_div" => "",
      "name_last" => "",
      "name_first" => "",
      "kana_name_last" => "",
      "kana_name_first" => "",
      "address_1" => "",
      "address_2" => "",
      "address_3" => "",
      "email" => "",
      "inquiry" => "",
      "status_div" => ""
    }

    column_comments :inquiriy_memos , {
      "inquiry_id" => "",
      "creator_name" => "",
      "memo" => ""
    }

    table_comment("kbn_code_names", :comment => "")

    column_comments :kbn_codes , {
      "kbn" => "",
      "kbn_name" => "",
      "code" => ""
    }

    column_comments :mail_deliveries , {
      "user_id" => "",
      "deliveried_at" => "",
      "header" => "",
      "subject" => "",
      "site_div" => "",
      "mail_body" => "",
      "message_id" => '',
      "to_address" => '',
      "from_address" => '',
      "order_id" => ''
    }

    column_comments :mail_templates , {
      "name" => "",
      "mail_type_div" => "",
      "pc_subject_template" => "",
      "pc_text" => "",
      "pc_html" => "",
      "mobile_subject_template" => "",
      "mobile_text" => '',
      "mobile_html" => ''
    }

    column_comments :order_items , {
      "order_shipping_id" => "",
      "unit_price" => ""
    }

    table_comment("order_shippings", :comment => "注文見出し")
    column_comments :order_shippings , {
      "order_id" => "",
      "order_code" => "",
      "status_div" => "",
      "name_last" => '',
      "name_first" => "",
      "kana_name_last" => '',
      "kana_name_first" => '',
      "address_1" => "",
      "address_2" => "",
      "address_3" => "",
      "arrival_date" => "",
      "arrival_hour" => "",
      "payment_type_div" => '',
      "delivery_div" => "",
      "shipping_cost" => ""
    }

    table_comment("orders", :comment => "ECサイト注文見出し")
    column_comments :order_shippings , {
      "ec_order_code" => "",
      "user_id" => "",
      "ordered_at" => "",
      "free_request" => ''
    }

    column_comments :products , {
      "product_code" => ""
    }

    column_comments :resigned_reasons , {
      "user_id" => "",
      "ms_resigned_reason_id" => "",
      "reason" => ""
    }

    column_comments :user_addresses , {
      "user_id" => "",
      "name_last" => "",
      "name_first" => "",
      "kana_name_last" => "",
      "kana_name_first" => "",
      "address_1" => "",
      "address_2" => "",
      "address_3" => ""
    }

    column_comments :user_emails , {
      "user_id" => "",
      "email" => "",
      "mail_address_pc_mobile_div" => "P"
    }

    column_comments :users , {
      "user_code" => "",
      "name_last" => "",
      "name_first" => "",
      "birth_year" => "",
      "birth_month" => "",
      "birth_day" => "",
      "resigned_at" => "",
      "sex" => "",
      "remember_answer" => "",
      "regist_div" => "",
      "job_div" => "",
      "dm_send_div" => "",
      "csv_output_div" => ""
    }
  end
end
