class MigrateDefaultTemplatesForCmsProjects < ActiveRecord::Migration
  class CmsProject < ActiveRecord::Base
  end
  class CmsTemplate < ActiveRecord::Base
  end
  class CmsDefaultTemplate < ActiveRecord::Base
  end
  
  def self.up
    # 各プロジェクトごとにデフォルトテンプレートをセットする
    MigrateDefaultTemplatesForCmsProjects::CmsDefaultTemplate.transaction do
      MigrateDefaultTemplatesForCmsProjects::CmsProject.find(:all).each do |project|
        conditions = ["cms_project_id = ? AND default_template_position IS NOT NULL AND delete_at_publish IS NULL", project.id]
        templates = MigrateDefaultTemplatesForCmsProjects::CmsTemplate.find(:all, :conditions => conditions)
        templates.each do |template|
          attributes = {
            :cms_project_id => project.id,
            :default_template_position => template.default_template_position,
            :terminal => template.terminal
          }
          default_template = MigrateDefaultTemplatesForCmsProjects::CmsDefaultTemplate.find(:first, :conditions => attributes)
          default_template ||= MigrateDefaultTemplatesForCmsProjects::CmsDefaultTemplate.new(attributes.merge(:cms_template_code => template.template_code))
          default_template.save!
        end
      end
    end
  end

  def self.down
    MigrateDefaultTemplatesForCmsProjects::CmsDefaultTemplate.destroy_all
  end
end
