class DeleteColumnDefaultTemplatePositionFromCmsTemplates < ActiveRecord::Migration
  class CmsProject < ActiveRecord::Base
  end
  class CmsTemplate < ActiveRecord::Base
  end
  class CmsDefaultTemplate < ActiveRecord::Base
  end

  def self.up
    remove_column :cms_templates, :default_template_position
  end

  def self.down
    add_column :cms_templates, :default_template_position, :string, :comment => "デフォルトテンプレート表示位置(0: 上, 1:下, 2:左, 3:右, 4:中央)"

    # 各プロジェクトごとにデフォルトテンプレートをセットする
    DeleteColumnDefaultTemplatePositionFromCmsTemplates::CmsTemplate.transaction do
      DeleteColumnDefaultTemplatePositionFromCmsTemplates::CmsProject.find(:all).each do |project|
        conditions = ["cms_project_id = ? AND default_template_position IS NOT NULL AND deleted_at IS NULL", project.id]
        default_templates = DeleteColumnDefaultTemplatePositionFromCmsTemplates::CmsDefaultTemplate.find(:all, :conditions => conditions)
        default_templates.each do |default_template|
          template_conditions = ["cms_project_id = ? AND template_code = ? AND terminal = ? AND delete_at_publish IS NULL", project.id, default_template.cms_template_code, default_template.terminal]
          template = DeleteColumnDefaultTemplatePositionFromCmsTemplates::CmsTemplate.find(:first, :conditions => template_conditions)
          template[:default_template_position] = default_template.default_template_position
          template.save!
        end
      end
    end
  end
end
