class CreateFavorites < ActiveRecord::Migration
  def self.up
    create_table :favorites, :comment => "お気に入り" do |t|
      t.integer :user_id, :comment => "会員ID"
      t.integer :product_sku_id, :comment => "商品SKU"
      t.string :site_type_div, :limit => 5, :comment => "登録媒体(1:PCサイト,2:モバイルサイト)"
      t.datetime :cart_addition_time, :comment => "カート追加日時"
      t.boolean  :test_flg, :comment => "テスト環境フラグ"
      t.datetime :created_at, :comment => ""
      t.datetime :updated_at, :comment => ""
      t.datetime :deleted_at, :comment => ""
      t.integer :lock_version, :default => 0, :comment => ""
      t.integer :creator_id, :comment => "データ登録者"
      t.integer :updater_id, :comment => "データ更新者"
      t.integer :deleter_id, :comment => "データ削除者"
    end

    add_index "favorites", ["creator_id"], :name => "index_favorites_on_creator_id"
    add_index "favorites", ["deleter_id"], :name => "index_favorites_on_deleter_id"
    add_index "favorites", ["updater_id"], :name => "index_favorites_on_updater_id"
    add_index "favorites", ["user_id"], :name => "index_favorites_on_user_id"
    add_index "favorites", ["product_sku_id"], :name => "index_favorites_on_product_sku_id"
  end

  def self.down
    drop_table :favorites
  end
end
