# -*- coding: utf-8 -*-
class ReminderQuestionForm < ActiveForm
  include ActiveRecord::Validations

  attr_accessor :email, :remember_question, :remember_answer,  :password, :password2, :back_to_url, :completion_url_controller, :completion_url_action, :reminder_question

  #未入力バリデーション
  validates_presence_of :email, :message => :EM990001

  #メールアドレスフォーマット
  validates_format_of      :email,  :with => /^([a-zA-Z0-9])+([a-zA-Z0-9\._-])*@([a-zA-Z0-9_-])*\.([a-zA-Z0-9_-])+([a-zA-Z0-9\._-]+)+$/, :message => :EM990007

  # 完了後の遷移先がある場合フォームにセットします。
  def set_completion_url(url)
    unless url.nil?
      unless (url[:controller].nil? || url[:action].nil?) || (url[:controller].empty? || url[:action].empty?)
        self.completion_url_controller = url[:controller]
        self.completion_url_action = url[:action]
      end
    end
  end
  # 完了後の遷移先がある場合trueを返却します。
  def other_redirect?
    unless (self.completion_url_controller.nil? || self.completion_url_action.nil?)
      unless (self.completion_url_controller.empty? || self.completion_url_action.empty?)
        return true
      end
    end
    return false
  end

  def validate
    errors.add(:base, :EM030003) unless is_exist_email?
  end

  #
  # メールアドレスが存在するかチェックします。
  # 存在しない場合はfalseを返します。
  #
  def is_exist_email?
    UserEmail.find(:all, :conditions => ["email = ?", self.email]).empty? ? false : true
  end
end
