# EcrMobile
module EcrMobile

  unless defined?(TAG_MODULE_NAMES_FOR_MOBILE)
    TAG_MODULE_NAMES_FOR_MOBILE = [
      :EzloginFormTag,
      :ProductTag,
      :OrderHistoryTag,
      :OrderFormTag,
      :CartTag,
      :SignupFormTag,
      :ShippingTag,
      :ShippingFormTag,
      :ReminderFormTag,
      :HtmlTag
    ]
  end

  # ECタグを拡張する仕組みです（モバイル用）
  module PluginModule
    module TagExtender
      class << self
        def mobile_ec_helpers
          EcrMobile::TAG_MODULE_NAMES_FOR_MOBILE.map{|value|"EcrMobile::EcHelper::#{value.to_s}"} + added_mobile_ec_helpers
        end

        def added_mobile_ec_helpers
          $added_mobile_ec_helpers ||= []
        end

        def register(*module_names)
          options = module_names.extract_options!
          module_names.each do |module_name|
            register_module(module_name, options)
          end
        end

        private

        def register_module(module_name, options)
          added_mobile_ec_helpers << module_name
        end
      end
    end
  end
end
