# モバイル用の入力モードを設定するHashを返します
module MobileInputMode
  # 半角英数
  def self.alphabet(request)
    if EcRider.config.ec_admin
      return {:style => 'ime-mode: inactive'}
    elsif request.mobile.class.name == "Jpmobile::Mobile::Docomo"
      return {:escape=>false, :format=>"*m", :mode=>"alphabet", :style=>"-wap-input-format:&quot;*&lt;ja:en&gt;&quot;; -wap-input-format:*m;"}
    else
      return {:format=>"*m", :mode=>"alphabet"}
    end
  end

  # 半角数字
  def self.numeric(request)
    if EcRider.config.ec_admin
      return {:style => 'ime-mode: inactive'}
    elsif request.mobile.class.name == "Jpmobile::Mobile::Docomo"
      return {:escape=>false, :format=>"*N", :mode=>"numeric", :style=>"-wap-input-format:&quot;*&lt;ja:n&gt;&quot;; -wap-input-format:*N;"}
    else
      return {:format=>"*N", :mode=>"numeric"}
    end
  end

  # 半角カナ（無ければ全角かな）
  def self.hankana(request)
    if EcRider.config.ec_admin
      return {:style => 'ime-mode: active'}
    elsif request.mobile.class.name == "Jpmobile::Mobile::Docomo"
      return {:escape=>false, :format=>"*M", :mode=>"hankakukana", :style=>"-wap-input-format:&quot;*&lt;ja:hk&gt;&quot;; -wap-input-format:*M;"}
    else
      return {:format=>"*M", :mode=>"hankakukana"}
    end
  end

  # 全角カナ（無ければ全角かな）
  def self.katakana(request)
    if EcRider.config.ec_admin
      return {:style => 'ime-mode: active'}
    elsif request.mobile.class.name == "Jpmobile::Mobile::Docomo"
      return {:escape=>false, :format=>"*M", :mode=>"katakana", :style=>"-wap-input-format:&quot;*&lt;ja:h&gt;&quot;; -wap-input-format:*M;"}
    else
      return {:format=>"*M", :mode=>"katakana"}
    end
  end
end
