# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../../spec_helper'
describe EcRider::EcHelper do
  fixtures :users, :orders, :order_shippings, :order_items

  before do
    request.stub!(:mobile?).and_return(true)
    request.stub_chain(:mobile, :supports_cookie?).and_return(false)
    @template.extend(ApplicationHelper)
    @template.output_buffer = ""
  end

  def ec
    helper.ec(:mobile)
  end

  describe "ec:button_for_confirm_order_cancel" do
    it "should return button" do
      @orders = Order.paginate(
        :per_page => 1, :page => 1,
        :conditions => {:user_id => 1005},
        :include => [{:order_shippings => :order_items}],
        :order => 'orders.id DESC')
      ec.instance_variable_set(:@orders, @orders)

      ec.order_history_list do
        ec.button_for_confirm_order_cancel{"キャンセル依頼確認"}
      end

      # TODO もう少しスマートな方法で書きたいです
      if EcRider.config.ec_admin
        @template.output_buffer.should have_tag('form[action=?]', "/member/confirm_cancel") do
          with_tag("input#id[type=?]", 'hidden')
          with_tag("input#ques[type=?]", 'hidden')
          with_tag("input[type=?][value=?]", 'submit', 'キャンセル依頼確認')
        end
      else
        @template.output_buffer.should have_tag('form[action=?]', "/member/confirm_cancel?session_id=#{request.session_options[:id]}") do
          with_tag("input#id[type=?]", 'hidden')
          with_tag("input#ques[type=?]", 'hidden')
          with_tag("input[type=?][value=?]", 'submit', 'キャンセル依頼確認')
        end
      end

    end
  end

  describe "ec:button_for_order_cancel" do
    it "should return button" do
      @orders = Order.paginate(
        :per_page => 1, :page => 1,
        :conditions => {:user_id => 1005},
        :include => [{:order_shippings => :order_items}],
        :order => 'orders.id DESC')
      ec.instance_variable_set(:@orders, @orders)

      ec.order_history_list do
        ec.button_for_order_cancel{"キャンセル依頼"}
      end

      # TODO もう少しスマートな方法で書きたいです
      if EcRider.config.ec_admin
        @template.output_buffer.should have_tag('form[action=?]', "/member/request_cancel") do
          with_tag("input#id[type=?]", 'hidden')
          with_tag("input#ques[type=?]", 'hidden')
          with_tag("input[type=?][value=?]", 'submit', 'キャンセル依頼')

        end
      else
        @template.output_buffer.should have_tag('form[action=?]', "/member/request_cancel?session_id=#{request.session_options[:id]}") do
          with_tag("input#id[type=?]", 'hidden')
          with_tag("input#ques[type=?]", 'hidden')
          with_tag("input[type=?][value=?]", 'submit', 'キャンセル依頼')
        end
      end

    end
  end

end
