# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../../spec_helper'
describe EcRider::EcHelper do
  fixtures :users

  def ec
    helper.ec(:mobile)
  end

  before do
    request.stub!(:mobile?).and_return(true)
    request.stub_chain(:mobile, :supports_cookie?).and_return(true)
    @template.extend(ApplicationHelper)
    @template.output_buffer = ""
  end

  def concat(*args)
    args.each{|arg| @template.concat(arg)}
  end

  describe "reminder_mail_form" do
    it "再設定画面のタグを取得出来ればOK" do
      @template.instance_variable_set(:@reminder_form, ReminderForm.new())
      @template.extend(ApplicationHelper)
      ec.reminder_mail_form do
        concat(ec.reminder_form_error_messages || '')
        concat(ec.reminder_form_email)

        ec.submit{"次へ"}
        @template.output_buffer
      end
      @template.output_buffer.should have_tag('form[action=?]', "/reminder/reminder_question") do
        with_tag("input#reminder_form_email")
        with_tag("input[type=?][value=?]", 'submit', '次へ')
      end
    end
  end

  describe "ec:reminder_form" do
    it "完了画面のタグが取得出来ればOK" do
      @template.instance_variable_set(:@reminder_form, ReminderForm.new())
      @template.extend(ApplicationHelper)
      ec.reminder_form do
        concat(ec.reminder_form_error_messages || '')
        concat(ec.reminder_form_remember_question)
        concat(ec.reminder_form_remember_answer)
        concat(ec.reminder_form_password)
        concat(ec.reminder_form_password_confirmation)

        ec.submit{"再設定"}
        @template.output_buffer
      end
      @template.output_buffer.should have_tag('form[action=?]', "/reminder/reminder_completion") do
        with_tag("input#reminder_form_remember_question")
        with_tag("input#reminder_form_remember_answer")
        with_tag("input#reminder_form_password")
        with_tag("input#reminder_form_password_confirmation")

        with_tag("input[type=?][value=?]", 'submit', '再設定')
      end
    end
  end
end
