# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../../spec_helper'
describe EcRider::EcHelper do
  fixtures :users, :user_addresses, :user_emails, :countries

  def ec
    helper.ec(:mobile)
  end

  before(:each) do
    request.stub!(:mobile?).and_return(true)
    request.stub_chain(:mobile, :supports_cookie?).and_return(true) # テストを簡略化するため、クッキーを使用する設定にする。
    @template.extend(ApplicationHelper)
    @template.output_buffer = ""
  end

  def concat(*args)
    args.each{|arg| @template.concat(arg)}
  end

  describe "shipping_form_tag" do

    before(:each) do
      @template.output_buffer = ""
      @user = User.find(1006, :include => [:user_address, :user_email])
      shipping_addresses = @user.user_and_shipping_addresses
      @shipping_address = shipping_addresses.pop
      @template.instance_variable_set(:@user_address, @shipping_address)
      @template.instance_variable_set(:@user_profile, @user)
      @template.instance_variable_set(:@edit_target_index, 1)
      @template.extend(ApplicationHelper)
    end

    describe "ec:shipping_form" do
      it "<ec:shipping_form>～</ec:shipping_form>" do
        params[:controller] = 'order'
        params[:action] = 'new_shipping_address'
        ec.shipping_form do
          ec.shipping_form_error_messages || ''
        end
        @template.output_buffer.should have_tag('form[action=?]', "/order/confirm_address")
      end
    end

    describe "ec:shipping_confirmation_form" do
      fixtures :countries

      it "<ec:shipping_confirmation_form>～</ec:shipping_confirmation_form>" do
        params[:controller] = 'order'
        ec.shipping_confirmation_form do
          ec.shipping_confirmation_form_full_name.should == '空川 助左衛門'
          ec.shipping_confirmation_form_kana_last_name.should == 'ソラカワ'
          ec.shipping_confirmation_form_kana_first_name == 'スケザエモン'
          ec.shipping_confirmation_form_country.should == 'Japan'
          ec.shipping_confirmation_form_zip_code.should == '〒5300002'
          ec.shipping_confirmation_form_prefecture.should == '大阪府'
          ec.shipping_confirmation_form_full_address == '大阪市北区 曽根崎新地４－２－７３田中マンション３０５号'
          ec.shipping_confirmation_form_tel_num == '000-111-2225'
          ec.if_address_japanese_format{'be_true'}
        end
        @template.output_buffer.should have_tag('form')
        @template.output_buffer.should =~ /be_true/
      end
    end

  end


  
end