# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../spec_helper'

describe MobileInputMode do

  if EcRider.config.ec_admin
    it "alphabet" do
      MobileInputMode.alphabet(nil).should == {:style => 'ime-mode: inactive'}
    end
    it "numeric" do
      MobileInputMode.numeric(nil).should == {:style => 'ime-mode: inactive'}
    end
    it "hankana" do
      MobileInputMode.hankana(nil).should == {:style => 'ime-mode: active'}
    end
    it "katakana" do
      MobileInputMode.katakana(nil).should == {:style => 'ime-mode: active'}
    end
  end

  if EcRider.config.ec_front
    describe "alphabet" do
      it "docomo" do
        request = mock_model(Object, :mobile => mock_model(Jpmobile::Mobile::Docomo))
        MobileInputMode.alphabet(request).should == {:escape=>false, :format=>"*m", :mode=>"alphabet", :style=>"-wap-input-format:&quot;*&lt;ja:en&gt;&quot;; -wap-input-format:*m;"}
      end
      it "other_carrier" do
        request = mock_model(Object, :mobile => mock_model(Jpmobile::Mobile::Au))
        MobileInputMode.alphabet(request).should == {:format=>"*m", :mode=>"alphabet"}
      end
    end

    describe "numeric" do
      it "docomo" do
        request = mock_model(Object, :mobile => mock_model(Jpmobile::Mobile::Docomo))
        MobileInputMode.numeric(request).should == {:escape=>false, :format=>"*N", :mode=>"numeric", :style=>"-wap-input-format:&quot;*&lt;ja:n&gt;&quot;; -wap-input-format:*N;"}
      end
      it "other_carrier" do
        request = mock_model(Object, :mobile => mock_model(Jpmobile::Mobile::Au))
        MobileInputMode.numeric(request).should == {:format=>"*N", :mode=>"numeric"}
      end
    end

    describe "hankana" do
      it "docomo" do
        request = mock_model(Object, :mobile => mock_model(Jpmobile::Mobile::Docomo))
        MobileInputMode.hankana(request).should == {:escape=>false, :format=>"*M", :mode=>"hankakukana", :style=>"-wap-input-format:&quot;*&lt;ja:hk&gt;&quot;; -wap-input-format:*M;"}
      end
      it "other_carrier" do
        request = mock_model(Object, :mobile => mock_model(Jpmobile::Mobile::Au))
        MobileInputMode.hankana(request).should == {:format=>"*M", :mode=>"hankakukana"}
      end
    end

    describe "katakana" do
      it "docomo" do
        request = mock_model(Object, :mobile => mock_model(Jpmobile::Mobile::Docomo))
        MobileInputMode.katakana(request).should == {:escape=>false, :format=>"*M", :mode=>"katakana", :style=>"-wap-input-format:&quot;*&lt;ja:h&gt;&quot;; -wap-input-format:*M;"}
      end
      it "other_carrier" do
        request = mock_model(Object, :mobile => mock_model(Jpmobile::Mobile::Au))
        MobileInputMode.katakana(request).should == {:format=>"*M", :mode=>"katakana"}
      end
    end
  end
end