# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../spec_helper'

describe ReminderQuestionForm, :type => :model do
  fixtures :users, :user_addresses, :user_emails

  describe "メールアドレスの存在チェック" do
    before(:each) do
      @param = {:email => 'member48@ecrider.com'}
    end
    it "正しいメールアドレスの場合、trueであればOK" do
      form = ReminderQuestionForm.new(:email => 'member48@ecrider.com')
      form.valid?.should == true
    end
    it "ドメインまで入力されているが、存在しない場合はエラーメッセージが出力されればOK" do
      form = ReminderQuestionForm.new(:email => 'abc@zzz.com')
      form.valid?.should == false
    end
  end
end