# -*- coding: utf-8 -*-
require 'fileutils'

plugin_name = :ecr_mobile

namespace plugin_name do
  namespace :db do
    desc "create tables for #{plugin_name}"
    task :migrate => :environment do
      EcRider::PluginModule::Migration.call_migrations(
        File.join(File.dirname(__FILE__), '../migrations'), :up)
    end

    desc "drop tables for #{plugin_name}"
    task :rollback => :environment do
      EcRider::PluginModule::Migration.call_migrations(
        File.join(File.dirname(__FILE__), '../migrations'), :down)
    end
  end
  
  namespace :fixtures do
    desc "copy fixtures for #{plugin_name}"
    task :copy do
      dest_dir = File.expand_path(File.join(RAILS_ROOT, 'test/fixtures'))
      src_dir = File.expand_path(File.join(File.dirname(__FILE__), '../spec/fixtures'))
      Dir[File.join(src_dir, '*')].each do |fixture|
        FileUtils.cp_r(fixture, 
          File.join(dest_dir, File.basename(fixture)), 
          :verbose => true)
      end
    end
    
    desc "delete fixtures for #{plugin_name}"
    task :delete do
      dest_dir = File.expand_path(File.join(RAILS_ROOT, 'test/fixtures'))
      src_dir = File.expand_path(File.join(File.dirname(__FILE__), '../spec/fixtures'))
      Dir[File.join(src_dir, '*')].each do |fixture|
        FileUtils.rm_rf(File.join(dest_dir, File.basename(fixture)), 
          :verbose => true)
      end
    end
  end
  
end
