module EcrMobileAdmin
  module UserControllerExt
    protected
      # UserController#new の拡張
      def user_email_instance_for_new_with_ecr_mobile_admin
        user_email_instance_for_new_without_ecr_mobile_admin
        if flash[:user_email_mobile]
          @user_email_mobile = flash[:user_email_mobile]
            @user_email_mobile.errors.full_messages.each do |message|
              @error_messages << message
            end
        else
          @user_email_mobile = UserEmail.new
        end
      end

      # UserController#create の拡張
      # Emailをインスタンス変数に設定
      def user_email_instance_for_create_with_ecr_mobile_admin
        user_email_instance_for_create_without_ecr_mobile_admin
        if !params[:user_email_mobile].nil? && !params[:user_email_mobile][:email].blank?
          @user_email_mobile = UserEmail.new(params[:user_email_mobile])
          @user_email_mobile.pc_mobile_div_key = :mobile
          @user_email_mobile.mail_address_pc_mobile_div = UserEmail.check_by_emall(@user_email_mobile.email)
          @user.user_email_mobile = @user_email_mobile
          @user_email_mobile.user = @user
        end
      end
      # Emailの入力チェックの実行
      def valid_user_email_for_create_with_ecr_mobile_admin
        valid_user_email_for_create_without_ecr_mobile_admin
        @user_email_mobile.valid? if @user_email_mobile
      end
      # 入力チェックエラー件数の取得
      def invalid_error_count_with_user_email_for_create_with_ecr_mobile_admin
        error_count = invalid_error_count_with_user_email_for_create_without_ecr_mobile_admin
        error_count += @user_email_mobile.errors.length if @user_email_mobile
        return error_count
      end
      # flashにEmail情報を設定
      def flash_user_for_create_with_ecr_mobile_admin
        flash_user_for_create_without_ecr_mobile_admin
        flash[:user_email_mobile] = @user_email_mobile
      end
      # Email情報をDBに登録
      def save_user_email_for_create_with_ecr_mobile_admin
        save_user_email_for_create_without_ecr_mobile_admin
        @user_email_mobile.save! if @user_email_mobile
      end
      # 会員登録完了メール送信（WEB会員の場合に送信します）
      def send_signup_mail_with_ecr_mobile_admin
        if @user.member_div_key == :membership
          email = @user.user_email.nil? ? @user.user_email_mobile.email : @user.user_email.email
          AdminMailer.send_signup_mail(@user.id.to_s, email)
        end
      end

      # UserController#edit の拡張
      def user_email_instance_for_edit_with_ecr_mobile_admin
        user_email_instance_for_edit_without_ecr_mobile_admin
        if flash[:user_email_mobile]
          @user_email_mobile = flash[:user_email_mobile]
          @user_email_mobile.errors.full_messages.each do |message|
            @error_messages << message
          end
        else
          @user_email_mobile = @user.user_email_mobile
        end
      end

      # UserController#update の拡張
      # Emailをインスタンス変数に設定
      def user_email_instance_for_update_with_ecr_mobile_admin
        @user_email_mobile = @user.user_email_mobile
      end
      # Emailのパラメータを更新
      def update_parame_user_email_instance_for_update_with_ecr_mobile_admin
        update_parame_user_email_instance_for_update_without_ecr_mobile_admin
        if !params[:user_email_mobile].nil? && ! params[:user_email_mobile][:email].blank?
          if @user_email_mobile # 更新
            @user_email_mobile.attributes = params[:user_email_mobile]
          else # 新規作成
            @user_email_mobile = UserEmail.new(params[:user_email_mobile])
            @user_email_mobile.pc_mobile_div_key = :mobile
            @user.user_email_mobile = @user_email_mobile # DBが更新されます。
            @user_email_mobile.user = @user
          end
        else
          @user_email_mobile.destroy if @user_email_mobile # 削除
          @user_email_mobile = nil
          @user.user_email_mobile = nil
        end
      end
      # Email情報をDBに登録
      def save_user_email_for_update_with_ecr_mobile_admin
        save_user_email_for_update_without_ecr_mobile_admin
        @user_email_mobile.save! if @user_email_mobile
      end
      # バリデーション結果をセット
      def flash_user_for_update_with_ecr_mobile_admin
        flash_user_for_update_without_ecr_mobile_admin
        @user_email_mobile.valid? if @user_email_mobile
        flash[:user_email_mobile] = @user_email_mobile
      end
  end
end
