module EcrMobileAdmin
  module TagReferencesHelperExt

    # 指定されたタグのモバイル用のdescriptionを返す
#    def sorted_descriptions_for_mobile_with_ecr_mobile_admin(tag_name)
    def sorted_descriptions_for_mobile(tag_name)
      base_descriptions = []
      if EcRider::EcHelper.constants.include?(tag_name.to_s)
        base_descriptions = EcRider::EcHelper.const_get(tag_name).desc_sort
      end
      mobile_descriptions = []
      module_names = mobile_tag_helpers[tag_name.to_s] || []
      module_names.each do |module_name|
        mobile_descriptions = mobile_descriptions + module_name.constantize.desc_sort
      end
      return unique_descriptions(base_descriptions + mobile_descriptions)
    end

    # タグリファレンスの本文を表示する
#    def render_reference_for_mobile_with_ecr_mobile_admin(tag_name, comment='')
    def render_reference_for_mobile(tag_name, comment='')
      result = ''
      result << "<div class=\"tag #{to_class_name(tag_name)}\">"
      result << '   <table class="standard_table">'
      result << '     <tbody>'
      sorted_descriptions_for_mobile(tag_name).each do |desc|
        if desc[1]
          result << '   <tr>'
          result << "     <th width=\"18%\">#{add_wbr_tag(desc[0])}</th>"
          result << "     <td><table class=\"description\">#{desc[1]}</table></td>"
          result << '   </tr>'
        end
      end
      result << '    </tbody>'
      result << '  </table>'
      result << comment
      result << '</div>'
    end

    # タグリファレンスのメニュー（その他）を表示する
    # プラグインによる拡張用
#    def render_tag_reference_menu_other_for_mobile_with_ecr_mobile_admin
    def render_tag_reference_menu_other_for_mobile
    end

    # タグリファレンスの本文（その他）を表示する
    # プラグインによる拡張用
#    def render_tag_reference_other_for_mobile_with_ecr_mobile_admin
    def render_tag_reference_other_for_mobile
    end

    private

    # モバイル用に拡張されたタグの一覧をハッシュで返す
    def mobile_tag_helpers
      return @mobile_tag_helpers if @mobile_tag_helpers
      @mobile_tag_helpers = {}
      EcrMobile::PluginModule::TagExtender.mobile_ec_helpers.each do |module_name|
        plugin_tag_name = /.*::([^:]+)/.match(module_name).to_a[1] #ヘルパー名だけ取得する
        plugin_tag_name.sub!('TagMobile', 'Tag')
        @mobile_tag_helpers[plugin_tag_name] ||= []
        @mobile_tag_helpers[plugin_tag_name] << module_name
      end
      @mobile_tag_helpers
    end
  end
end
