require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe UserHelper do

  it "print_email" do
    user = User.new()
    user.user_email = UserEmail.new()
    helper.print_email(user).should have_tag('table')
  end

  it "print_email with email" do
    user = User.new()
    user.user_email = UserEmail.new(:email => 'test1@test.com')
    user.user_email_mobile = UserEmail.new(:email => 'test2@test.com')
    result = helper.print_email(user)
    result.should have_tag('table')
    result.should =~ /test1@test\.com/
    result.should =~ /test2@test\.com/
  end

  it "render_email_input_form は、user_email_mobileを読み込みます。" do
    helper.should_receive(:render).with(:partial => 'user_email_mobile')
    helper.render_email_input_form
  end

  it "render_emailは、_user_email_mobile_printを読み込みます。" do
    helper.should_receive(:render).with(:partial => 'user_email_mobile_print')
    helper.render_email
  end
end
