module EcrMobileFront
  module ReminderControllerExt
    unloadable

    #
    # メールアドレス入力画面
    # params[:completion_url]がわたってきた場合は、リマインダー登録後その値の遷移先に遷移します。
    # params[:completion_url] = {:controller => 遷移させたいコントローラ名, :action => 遷移させたいアクション名 }
    #
    def index_with_ecr_mobile_front
      return index_without_ecr_mobile_front unless request.mobile? && request.post?
      @reminder_form = flash[:reminder_form] || ReminderForm.new()
      @reminder_form.set_completion_url(params[:completion_url])
      render :action => :index
    end

    #
    # パスワード再設定画面
    #
    def reminder_question
      return index_without_ecr_mobile_front unless request.mobile? && request.post?
      reminder_form = params[:reminder_form]
      reminder_question_form = ReminderQuestionForm.new(reminder_form)
      unless reminder_question_form.valid?
        flash[:reminder_form] = reminder_question_form
        redirect_to :action => :index
        return
      end
      @reminder_form = ReminderForm.new(reminder_form)
      @reminder_form.set_remember_question
      @reminder_form.set_completion_url(params[:completion_url])
    end

    #
    # パスワード変更完了画面
    #
    def reminder_completion_with_ecr_mobile_front
      return reminder_completion_without_ecr_mobile_front unless request.mobile? && request.post?
      @reminder_form = ReminderForm.new(params[:reminder_form])
      unless @reminder_form.valid?
        flash[:reminder_form] = @reminder_form
        render :action => :reminder_question
        return
      end

      unless User.remind(@reminder_form.email, @reminder_form.remember_question, @reminder_form.remember_answer, @reminder_form.password, @reminder_form.password_confirmation)
        @reminder_form.errors.add(:remember_answer, i18n_message(:EM030002))
        flash[:reminder_form] = @reminder_form
        redirect_to :action=> :reminder_question
      end

      self.current_user = User.authenticate(@reminder_form.email, @reminder_form.password)
      reset_session_with_keep_content # セッションを作り直しています。中身は一緒
      # :completion_urlがある場合はその値にリダイレクトします。
      if @reminder_form.other_redirect?
        redirect_to :controller => @reminder_form.completion_url_controller, :action => @reminder_form.completion_url_action
      end
    end
  end
end