require 'ecr_mobile_front'
require 'ecr_mobile_front/url_for_extention'

::EcRider::HelperExtention.module_eval do
  include EcrMobileFront::UrlForExtention
end

EcRider::PluginModule.register(
  "EcrMobileFront::ApplicationControllerExt",
  "EcrMobileFront::CartControllerExt",
  "EcrMobileFront::AccountControllerExt",
  "EcrMobileFront::MemberControllerExt",
  "EcrMobileFront::OrderControllerExt",
  "EcrMobileFront::InquiryControllerExt",
  "EcrMobileFront::ApplicationHelperExtentionExt",
  "EcrMobileFront::ReminderControllerExt"
)

# reset_session用のパッチを当てます。
# 参照：http://groups.google.com/group/jpmobile/browse_thread/thread/155a37c0136c72c5/9dc83bfc1fb5818a
ActiveRecord::SessionStore.send :include, EcrMobileFront::SessionStoreExt

EcRider::Config.class_eval do
  # モバイルの場合、有効なIPアドレスかどうかチェックするかしないかを返します。
  attr_accessor_with_default(:valid_ip_check) do
    @valid_ip_check ||= EcRider.config.ec_front && ENV['ECR_VALID_IP_CHECK'] ? true : false
    @valid_ip_check ||= false
  end
end
