# -*- coding: utf-8 -*-
require 'ec_rider'

module EcRider

  class ConditionForm < ActiveForm
    DEFAULT_PER_PAGE = 20

    attr_accessor :cleared

    def cleared?
      !!cleared
    end

    def self.default_per_page(value = nil)
      @default_per_page = value if value
      @default_per_page || DEFAULT_PER_PAGE
    end

    def self.method_for_find(value = nil)
      @method_for_find = value if value
      @method_for_find || :to_find_options
    end

    def page
      @page || 1 # デフォルトの開始ページ番号は1。0だとエラーになる。
    end  

    def page=(value)
      @page = [1, value.to_i].max
    end

    def per_page
      @per_page || self.class.default_per_page
    end
    alias_method :disp_count, :per_page

    def per_page=(value)
      @per_page = (value.to_i == 0) ? nil : value.to_i
    end
    alias_method :disp_count=, :per_page=


    def to_paginate_options(options = nil)
      result = send(self.class.method_for_find, options) || {}
      result.update(:per_page => per_page.to_i)
      result.update(:page => page) # :page parameter required
      result
    end

  end
end
