# -*- coding: utf-8 -*-
module EcRider
  # 標準添付ライブラリerbに含まれるERB::Utilの拡張を行うモジュールです。
  module ErbUtilExt
    def self.included(mod)
      mod.module_eval do 
        alias_method_chain :html_escape, :ec_rider
        alias_method :h_without_ec_rider, :h
        alias_method :h, :html_escape_with_ec_rider
      end
    end

    def self.extended(obj)
      obj.instance_eval do
        alias html_escape_without_ec_rider html_escape
        alias html_escape html_escape_with_ec_rider
        alias h_without_ec_rider h
        alias h html_escape_with_ec_rider
      end
    end


    # vendor/rails/actionpack/lib/action_view/template_handlers/erb.rbにある定義
    # HTML_ESCAPE = { '&' => '&amp;',  '>' => '&gt;',   '<' => '&lt;', '"' => '&quot;' }
    HTML_ESCAPE = { '&' => '&amp;',  '>' => '&gt;',   '<' => '&lt;', '"' => '&quot;' ,
      "'" => '&#39;'}

    def html_escape_with_ec_rider(s)
      s.to_s.gsub(/[&"'><]/) { |special| HTML_ESCAPE[special] }
    end

  end
end
