# -*- coding: utf-8 -*-
module SelectableAttr
  class Enum

    # 区分値テーブルの内容でselectable_attrの項目を更新する
    def update_with_kbn(kbn)
      # TODO order byするためのカラムをname_mastersに追加する
      select = <<-"EOS"
        select code, name
          from kbn_codes left join kbn_code_names on kbn_codes.id = kbn_code_names.kbn_code_id
          where kbn = '#{kbn}' and locale = :locale order by code
      EOS
      update_by(select, :when => :everytime)
    end

    # プラグインからselectable_attrの項目を更新する
    def update_with_plugins(model, method)
      @model_for_update = model
      @method_for_update = method
      @update_timing = :everytime
      self.extend(InstanceMethodsForPlugin) unless respond_to?(:update_entries)
    end

    # プラグインからselectable_attrにentryを追加するためのモジュールです
    module InstanceMethodsForPlugin
      def entries
        update_entries if must_be_updated?
        @entries
      end

      def must_be_updated?
        return false if @update_timing == :never
        return true if @update_timing == :everytime
      end

      def update_entries
        unless @original_entries
          updated_entries = @model_for_update.to_s.constantize.send(@method_for_update, self)
          if updated_entries
            @original_entries = @entries.dup
            @entries = updated_entries
          end
        end
      end
    end
  end
end
