# -*- coding: utf-8 -*-
namespace :jp_address do
  namespace :db do
    
    desc 'Insert all address data into jp_address table after drops and create the jp_address table.'
    task :reflesh => [:drop_table, :create_table, :data_load]

    desc 'Create the jp_address table.'
    task :create_table => :environment do
      require_create_jp_address
      CreateJpAddress.up
    end

    desc 'Drops the jp_address table.'
    task :drop_table => :environment do
      require_create_jp_address
      CreateJpAddress.down
    end
    
    desc 'Insert all address data into jp_address table.'
    task :data_load => :environment do
      JpAddress.insert_from_csv
    end

    #
    # RAILS_ROOT/db/migrate/*_create_jp_address.rb を require します。
    #
    def require_create_jp_address
      Dir.glob(File.join(RAILS_ROOT, 'db', 'migrate', '*_create_jp_address.rb')) { |filename| require filename }
    end

  end
end