require 'rubygems'
require 'active_support'
require 'yaml/encoding' unless RUBY_PLATFORM =~ /java/
class String
  alias :old_to_yaml :to_yaml
  def to_yaml(ops = {})
    old_to_yaml(ops)
  end
end

require "yaml"
class String
  def is_binary_data?
    false
  end

  def decode
    gsub(/\\x(\w{2})/){[Regexp.last_match.captures.first.to_i(16)].pack("C")}
  end
end

ObjectSpace.each_object(Class){|klass|
  klass.class_eval{
    if method_defined?(:to_yaml) && !method_defined?(:to_yaml_with_decode)
      def to_yaml_with_decode(*args)
        result = to_yaml_without_decode(*args)
        if result.kind_of? String
          result.decode
        else
          result
        end
      end
      alias_method :to_yaml_without_decode, :to_yaml
      alias_method :to_yaml, :to_yaml_with_decode
    end
  }
}

namespace :db do
  namespace :data do
    desc "dump data from database for sharing among developers"
    task :dump => :environment do
      sql = "SELECT * from %s order by id"
      skip_tables = ["schema_info"]
      ActiveRecord::Base.establish_connection
      (ActiveRecord::Base.connection.tables - skip_tables).each do |table_name|
        i = "000"
        FileUtils.mkdir_p("#{RAILS_ROOT}/db/data")
        File.open("#{RAILS_ROOT}/db/data/#{table_name}.yml", 'w') do |file|
          data = ActiveRecord::Base.connection.select_all(sql % table_name)
          file.write data.inject({}) { |hash, record|
            hash["#{table_name}_#{i.succ!}"] = record 
            hash
          }.to_yaml()
        end
      end
      puts('dump finished.')
    end

    desc "load data to database for sharing among developers"
    task :load2 => :environment do
      require 'active_record/fixtures'
      ActiveRecord::Base.establish_connection(RAILS_ENV.to_sym)
      (ENV['FIXTURES'] ? ENV['FIXTURES'].split(/,/) : Dir.glob(File.join(RAILS_ROOT, 'db', 'data', '*.{yml,csv}'))).each do |fixture_file|
        Fixtures.create_fixtures('db/data', File.basename(fixture_file, '.*'))
      end
      puts('load finished.')
    end

  end
end
