require 'pathname'
require 'fileutils'

locales = ARGV
directories = Dir.entries("app/views")
directories.delete_if {|path| /^\./ =~ path}

locales.each do |locale|
  Dir.delete("views_#{locale}") if File.exist?("views_#{locale}")
  Dir.mkdir("views_#{locale}")
  Dir.chdir("views_#{locale}")

  directories.each do |directory|
    Dir.mkdir(directory)
    src_dir = "../app/views/#{directory}"
    dest_dir = "./#{directory}"
    files = Dir.entries(src_dir)
    files.delete_if {|path| /^\./ =~ path}

    files.each do |file|
      src_action, ext = file.split('.', 2)
      next if src_action =~ /\_[a-zA-Z]{2}$|\_[a-zA-Z]{2}-[a-zA-Z]{2}$/
      target = "#{src_action}_#{locale}.#{ext}"

      if File.exist?("#{src_dir}/#{target}")
        FileUtils.cp("#{src_dir}/#{target}", "#{dest_dir}/#{target}")
      else
        FileUtils.cp("#{src_dir}/#{file}", "#{dest_dir}/#{target}")
      end
    end
  end

  Dir.chdir("..")
end
