require File.join(File.dirname(__FILE__), '..', 'spec_helper')

describe RuntimeController do

  describe "GET validate_url" do
    it "valid" do
      get :validate_url, :url => ["/account", "/member/show_addresses", "/show/1", "/cart/index"]
      response.should be_success
      ActiveSupport::JSON.decode(response.body).should == {"invalid_urls"=>[]}
    end
    
    it "invalid" do
      get :validate_url, :url => ["/xx_account", "/member/show_addresses", "/show/1", "/cart/cart_index"]
      response.should be_success
      ActiveSupport::JSON.decode(response.body).should == {"invalid_urls"=>["/xx_account", "/cart/cart_index"]}
    end
    
    it "10000url" do
      url = []
      2500.times{url << '/xxxxxx/yyyyyyyy'}
      2500.times{url << '/resigned_reason/resigned_reason'}
      2500.times{url << '/order/zzzzz'}
      2500.times{url << '/wrong_wrong_wrong'}
      get :validate_url, :url => url
      response.should be_success
      result = ActiveSupport::JSON.decode(response.body)
      result["invalid_urls"].length.should == 7500
    end
  end
end