# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../spec_helper'

describe ApplicationHelper, :type => :helper do
  include ApplicationHelper

  describe "in Japanese" do

    describe "Format of format_date" do
      it "should be 'YYYY年MM月DD日' with '2009/01/14" do
        date = Time.parse("2009/01/14")
        format_date(date).should == date.strftime("%Y年%m月%d日")
      end
      it "should be nil with nil." do
        format_date(nil).should be_nil
      end
    end
    
    describe "add_br_tag" do
      it "/n test" do
        str = add_br_tag("aaa\nbbb\nccc\n")
        str.should == "aaa<br/>\nbbb<br/>\nccc<br/>\n" 
      end
      it "tag test" do
        str = add_br_tag("<script>alert()</script>\n")
        str.should == "&lt;script&gt;alert()&lt;/script&gt;<br/>\n" 
      end
    end
  end
end
