# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../../spec_helper'

describe EcRider::EcHelper do

  def ec
    helper.ec
  end

  describe "include_shipping_tag" do
    before(:each) do
      mock_included_shipping_address = mock_model(OrderShipping,
        {
          :ordered_at => Time.local(2009, 1, 1, 11, 00, 00),
          :name_first => "漢字名（姓）",
          :name_last => "漢字名（名）",
          :zip_code => "123-1234",
          :address_1 => "埼玉県",
          :address_2 => "秩父市番場町",
          :address_3 => "１－２",
          :tel_num => "03-1234-1234"
        })
      ec.instance_variable_set(:@included_shipping_address, mock_included_shipping_address)
    end
    
    describe "included_shipping_ordered_at" do
      it '<%= ec:included_shipping_ordered_at %>' do
        ec.included_shipping_ordered_at.should == "09/01/01"
      end
      it "<%= ec:included_shipping_ordered_at(:format => '%y年%m月%d日') %>" do
        ec.included_shipping_ordered_at(:format => '%y年%m月%d日').should == "09年01月01日"
      end
    end
    
    describe "included_shipping_name_first" do
      it '<%= ec:included_shipping_name_first %>' do
        ec.included_shipping_name_first.should == "漢字名（姓）"
      end
    end
    
    describe "included_shipping_name_last" do
      it '<%= ec:included_shipping_name_last %>' do
        ec.included_shipping_name_last.should == "漢字名（名）"
      end
    end
    
    describe "included_shipping_zipcode" do
      it '<%= ec:included_shipping_zipcode %>' do
        ec.included_shipping_zipcode.should == "〒123-1234"
      end
    end
    
    describe "included_shipping_address" do
      it '<%= ec:included_shipping_address %>' do
        ec.included_shipping_address.should == "埼玉県秩父市番場町１－２"
      end
    end
    
    describe "included_shipping_telnum" do
      it '<%= ec:included_shipping_telnum %>' do
        ec.included_shipping_telnum.should == "03-1234-1234"
      end
    end

    describe "button_to_included_shipping_address" do
      before(:each) do
        @template.output_buffer = ""
      end
    
      it '<% ec:button_to_included_shipping_address do %>同送を指定する<% end %>' do
        ec.button_to_included_shipping_address{"同送を指定する"}
        @template.output_buffer.should have_tag('input[type="button"][value="同送を指定する"]')
      end

      it '<% ec:button_to_close_included_shipping_address do %>×閉じる<% end %>' do
        ec.button_to_close_included_shipping_address{"×閉じる"}
        @template.output_buffer.should have_tag('input[type="button"][value="×閉じる"]')
      end
    end

  end
end