# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../../spec_helper'

describe EcRider::EcHelper do
  # fixtures :products, :product_displays, :name_masters, :ms_code_names, :ms_shop_settings, :users

  def ec
    helper.ec
  end

  before(:each) do
    @template.output_buffer = ""
  end

  def concat(*args)
    args.each{|arg| @template.concat(arg)}
  end

  describe "ec:reminder_form" do
    it "normal usage" do
      @template.instance_variable_set(:@reminder_form, ReminderForm.new(:back_to_url => '/login/login'))
      @template.extend(ApplicationHelper)
      ec.reminder_form do
        concat(ec.reminder_form_error_messages || '')
        concat(ec.reminder_form_email)
        concat(ec.reminder_form_remember_question)
        concat(ec.reminder_form_remember_answer)
        concat(ec.reminder_form_password)
        concat(ec.reminder_form_password_confirmation)

        ec.reminder_form_button_to_back{ "←前へ戻る"}
        ec.submit{"進む→"}
        @template.output_buffer
      end
      @template.output_buffer.should have_tag('form[action=?]', "/reminder/reminder_completion") do
        with_tag("input#reminder_form_email")
        with_tag("input#reminder_form_remember_question")
        with_tag("input#reminder_form_remember_answer")
        with_tag("input#reminder_form_password")
        with_tag("input#reminder_form_password_confirmation")

        with_tag("input[type=?][value=?][onclick=?]", 'button', '←前へ戻る', "location.href='/login/login';")
        with_tag("input[type=?][value=?]", 'submit', '進む→')
      end
    end
  end

end
