# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../../spec_helper'

describe EcRider::EcHelper do
 fixtures :shop_settings

  def ec
    helper.ec
  end

  before(:each) do
    @template.extend(ApplicationHelper)
  end

  describe "ec:shop_name" do
    it '<%= ec:shop_name %>' do
      ec.shop_name.should == "いーしーらいだー"
    end
  end

  describe "ec:shop_zip_code" do
    it '<%= ec:shop_zip_code %>' do
      ec.shop_zip_code.should == "447-0055"
    end
  end

  describe "ec:shop_address" do
    it '<%= ec:shop_address %>' do
      ec.shop_address.should == "名古屋市中区丸の内二丁目9-40\nEC_RIDERビル101階"
    end
  end

  describe "ec:shop_tel_num" do
    it '<%= ec:shop_tel_num %>' do
      ec.shop_tel_num.should == "052-000-0000"
    end
  end

  def set_shop_logo
    setting = ShopSetting.new(
      :setting_div => ShopSetting.setting_div_id_by_key(:shop_logo),
      :value => 'logo.gif',
      :locale => 'ja')
    setting.save!
  end

  describe "ec:shop_name" do
    it '<%= ec:shop_logo %>' do
      ec.shop_logo.should == nil
      set_shop_logo
      ec.shop_logo.should have_tag('img[src^=/images/logo.gif][alt="いーしーらいだー"]')
    end
  end

  describe "ec:shop_logo_link" do
    it '<%= ec:shop_logo_link %>' do
      ec.shop_logo_link.should == nil
      set_shop_logo
      ec.shop_logo_link(:href => "/", :alt => 'ロゴ', :width => "50%", :height => "50%").should have_tag('a[href="/"]') do
        with_tag('img[src^=/images/logo.gif][alt="ロゴ"][height="50%"][width="50%"]')
      end
    end
  end

  describe "ec:shop_mail" do
    it '<%= ec:shop_mail %>' do
      ec.shop_mail.should == 'test_webadministrator@ecrider.com'
      setting = ShopSetting.new(:setting_div => ShopSetting.setting_div_id_by_key(:shop_mail), :value => 'test@ecrider.com', :locale => 'ja')
      setting.save!
      ec.shop_mail.should == "test@ecrider.com"
    end
  end
end
