# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../spec_helper'

describe EcRider::ErbUtilExt, :type => :helper do
  include EcRider::ErbUtilExt
  
  describe "#867 HTMLエスケープ処理にシングルクォート(')のエスケープも対応する" do 
    include EcRider::ErbUtilExt 
    
    it "ERB::Util.h" do 
      ERB::Util.h('<').should == "&lt;" 
      ERB::Util.h('>').should == "&gt;" 
      ERB::Util.h('"').should == "&quot;" 
      ERB::Util.h("'").should == "&#39;" # という風になるべきだけど、標準のhメソッドではなりません。 
    end 
    
    it "ERB::Util.html_escape" do 
      ERB::Util.html_escape('<').should == "&lt;" 
      ERB::Util.html_escape('>').should == "&gt;" 
      ERB::Util.html_escape('"').should == "&quot;" 
      ERB::Util.html_escape("'").should == "&#39;" # という風になるべきだけど、標準のhメソッドではなりません。 
    end 
    
    it "hメソッド" do 
      # ヘルパーメソッドhはActionView::BaseがincludeするERB::Utilに宣言されています。 
      # これはRails内部ではなく、標準添付ライブラリであるerbに記述されています。 
      h('<').should == "&lt;" 
      h('>').should == "&gt;" 
      h('"').should == "&quot;" 
      h("'").should == "&#39;" # という風になるべきだけど、標準のhメソッドではなりません。 
    end 
    
    it "html_escapeメソッド" do 
      html_escape('<').should == "&lt;" 
      html_escape('>').should == "&gt;" 
      html_escape('"').should == "&quot;" 
      html_escape("'").should == "&#39;" # という風になるべきだけど、標準のhメソッドではなりません。 
    end 
    
  end
end
