# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../../spec_helper'

describe EcRider::HelperExtention do # , :type => :helper do
  include EcRider::HelperExtention

  describe "url_for" do
    it "コントローラとアクションで指定" do
      url_for(:controller => 'cart', :action => 'index', :a => 1, :b => 2).should == '/cart?a=1&amp;b=2'
    end
    it "コントローラとアクションで指定 with escape_false" do
      url_for(:controller => 'cart', :action => 'index', :a => 1, :b => 2, :escape => false).should == '/cart?a=1&b=2'
    end
    it "文字列" do
      url_for('http://www.test.com/?a=1&b=1').should == 'http://www.test.com/?a=1&amp;b=1'
    end
    it "href" do
      url_for(:href => 'http://www.test.com/?a=1&b=1').should == 'http://www.test.com/?a=1&amp;b=1'
    end
    it "href with escape_false" do
      url_for(:href => 'http://www.test.com/?a=1&b=1', :escape => false).should == 'http://www.test.com/?a=1&b=1'
    end
  end
end
