# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../spec_helper'

describe MemberHelper, :type => :helper do
  fixtures :products
  include ApplicationHelper
  include MemberHelper

  describe "in Japanese" do
    it "print_status should \"配送準備中\" for OrderShipping.status_div_key equals :undelivery" do
      order_shipping = OrderShipping.new({:status_div => 0})
      order_shipping.status_div_key.should == :undelivery
      print_status(order_shipping).should == "配送準備中"
    end

    it "print_status should \"まもなく配送されます\" for OrderShipping.status_div_key equals :deliver_request" do
      order_shipping = OrderShipping.new({:status_div => 1})
      order_shipping.status_div_key.should == :deliver_request
      print_status(order_shipping).should == "発送手配中"
    end

    it "print_status should \"出荷済\" for OrderShipping.status_div_key equals :delivered" do
      order_shipping = OrderShipping.new({:status_div => 2})
      order_shipping.status_div_key.should == :delivered
      print_status(order_shipping).should == "出荷済"
    end

    it "print_status should \"出荷済\" for OrderChapter.status_div_key equals :deliver_advised" do
      order_shipping = OrderShipping.new({:status_div => 3})
      order_shipping.status_div_key.should == :deliver_advised
      print_status(order_shipping).should == "出荷済"
    end

    it "print_status should \"キャンセル完了\" for OrderShipping.status_div_key equals :canceled" do
      order_shipping = OrderShipping.new({:status_div => 8})
      order_shipping.status_div_key.should == :canceled
      print_status(order_shipping).should == "キャンセル完了"
    end

    it "print_status should \"キャンセル依頼中\" for OrderShipping.status_div_key equals :cancel_request" do
      order_shipping = OrderShipping.new({:status_div => 10})
      order_shipping.status_div_key.should == :cancel_request
      print_status(order_shipping).should == "キャンセル依頼中"
    end
  end
end

