require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe CsvFileDownloadHistory do
  before(:each) do
    @valid_attributes = {
      :upload_id => 1,
      :input_count => 1,
      :success_count => 1,
      :error_count => 1,
    }
  end
  #it "レコード登録時に処理日時が登録されること" do
  #  history = CsvFileUploadHistory.create!(@valid_attributes)
  #  history.processed_at.should_not be_nil
  #end

  describe "バリデーション" do
    it "正常" do
      condition = CsvFileDownloadHistory::SearchCondition.new(:outputed_at_from => '', :outputed_at_to => '', :file_name => '')
      condition.valid?
      condition.errors.count.should == 0
    end
    it "処理開始日不正" do
      condition = CsvFileDownloadHistory::SearchCondition.new(:outputed_at_from => 'aaaaa', :outputed_at_to => '', :file_name => '')
      condition.valid?
      condition.errors.count.should == 2
    end
    it "処理終了日不正" do
      condition = CsvFileDownloadHistory::SearchCondition.new(:outputed_at_from => '', :outputed_at_to => '9999/00/00', :file_name => '')
      condition.valid?
      condition.errors.count.should == 1
    end
  end
  
  it "create_condition" do
    condition = CsvFileDownloadHistory::SearchCondition.new(:outputed_at_from => '2008/01/02', :outputed_at_to => '2009/01/02', :file_name => 'aa')
    condition.create_condition.should == ["file_name like ? AND created_at >= ? AND created_at <= ?", 
      "%aa%", Time.parse('Wed Jan 02 00:00:00 +0900 2008'), Time.parse('Fri Jan 02 23:59:59 +0900 2009')]
  end
end
