# -*- coding: utf-8 -*-
require File.dirname(__FILE__) + '/../spec_helper'
describe Prefecture do
  fixtures :prefectures, :prefecture_displays, :shipping_costs
  describe "test for database reration" do
    it "has_many prefecture_display" do
      prefecture = Prefecture.new()
      prefecture.code = "C1"
      prefecture.save!
      prefecture_id = prefecture.id
      result1 = Prefecture.find(prefecture_id)
      result1.prefecture_displays.size.should == 0
      display1 = PrefectureDisplay.new(:name => "県名１", :locale => "1", :prefecture_id => prefecture_id)
      display2 = PrefectureDisplay.new(:name => "県名２", :locale => "2", :prefecture_id => prefecture_id)
      display1.save!
      display2.save!
      result2 = Prefecture.find_by_id(prefecture_id)
      result2.prefecture_displays.size.should == 2
    end
  end
  describe "test prefecture_names" do
    it "prefecture_names" do
      ja_prefecture_names = Prefecture.prefecture_names('ja')
      ja_prefecture_names.size.should == 47
      ja_prefecture_names[0].should == '北海道'
      ja_prefecture_names[1].should == '青森県'
      en_prefecture_names = Prefecture.prefecture_names('en')
      en_prefecture_names.size.should == 2
      en_prefecture_names[0].should == 'Hokkaido'
      en_prefecture_names[1].should == 'Gunma'
    end
  end

  describe "test prefecture_names" do
    it "prefecture_names" do
      ja_prefecture_names = Prefecture.prefecture_names('ja')
      ja_prefecture_names.size.should == 47
      ja_prefecture_names[0].should == '北海道'
      ja_prefecture_names[1].should == '青森県'
      en_prefecture_names = Prefecture.prefecture_names('en')
      en_prefecture_names.size.should == 2
      en_prefecture_names[0].should == 'Hokkaido'
      en_prefecture_names[1].should == 'Gunma'
    end
  end

  describe "test prefecture_names" do
    it "find_by_name" do
      result = Prefecture.find(:first, :conditions => ['code = ?', "23"])
      result.prefecture_name('ja').should == "愛知県"
    end
  end
  describe "test shipping_costs" do
    it "find_by_name" do
      result = Prefecture.find_by_name('愛知県')
      result.shipping_costs.size.should == 11
    end
  end
end
