require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe ProductDisplay do
  fixtures :product_displays, :products
  
  before(:each) do
    @valid_attributes = {
      :product_id => 1,
      :locale => "ja",
      :product_name_1 => "value for product_name_1",
      :product_name_2 => "value for product_name_2",
      :product_outline => "value for product_outline",
      :product_explanation => "value for product_explanation",
      :normal_explanation => "value for normal_explanation",
      :regular_explanation => "value for regular_explanation",
      :recommendation => "value for recommendation",
      :recommendation_2 => "value for recommendation_2",
      :product_keyword => "value for product_keyword"
    }
  end

  it "should create a new instance given valid attributes" do
    ProductDisplay.create!(@valid_attributes)
  end

  describe "check validates length" do
    before do
      @product_display = ProductDisplay.find(:first)
    end
    
    it "product_explanation can save 4000character" do
      @product_display.product_explanation = 'a'*4000
      @product_display.valid?.should == true
    end
    it "product_explanation can save 4001character" do
      @product_display.product_explanation = 'a'*4001
      @product_display.valid?.should == false
    end
    
    it "product_outline can save 400character" do
      @product_display.product_outline = 'a'*4000
      @product_display.valid?.should == true
    end
    it "product_outline can save 401character" do
      @product_display.product_outline = 'a'*4001
      @product_display.valid?.should == false
    end
    
    it "recommendation can save 400character" do
      @product_display.recommendation = 'a'*400
      @product_display.valid?.should == true
    end
    it "recommendation can save 401character" do
      @product_display.recommendation = 'a'*401
      @product_display.valid?.should == false
    end
    
    it "recommendation_2 can save 400character" do
      @product_display.recommendation_2 = 'a'*400
      @product_display.valid?.should == true
    end
    it "recommendation_2 can save 401character" do
      @product_display.recommendation_2 = 'a'*401
      @product_display.valid?.should == false
    end
    
    it "product_keyword can save 255character" do
      @product_display.product_keyword = 'a'*255
      @product_display.valid?.should == true
    end
    it "product_keyword can save 256character" do
      @product_display.product_keyword = 'a'*256
      @product_display.valid?.should == false
    end
  end

end
