# -*- coding: utf-8 -*-
require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe ShopSetting do

  fixtures :shop_settings, :countries

  before(:each) do
    @valid_attributes = {
      :setting_div_key => :shop_name,
      :value => 'いーしーらいだー'
    }
  end

  describe "test setting_div" do
    it "test setteing_div_entry[:hint]" do
      m1 = ShopSetting.new()
      m1.setting_div = '0000'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      ※ 16文字以内で指定してください。
      入力例：　EC-Rider商会
    END_OF_HINT

      m1.setting_div = '0001'
      m1.setting_div_entry[:hint].should == "入力例：　810-0001"

      m1.setting_div = '0002'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      入力例：
      　名古屋市中区丸の内二丁目9-40
      　EC_RIDERビル101階
    END_OF_HINT

      m1.setting_div = '0003'
      m1.setting_div_entry[:hint].should == "入力例：　092-123-1234"

      m1.setting_div = '0004'
      m1.setting_div_entry[:hint].should be_nil

      m1.setting_div = '0005'
      m1.setting_div_entry[:hint].should == "入力例：　tenpo_address@ecrider.com"

      m1.setting_div = '0006'
      m1.setting_div_entry[:hint].should be_nil

      m1.setting_div = '0007'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      入力例：　shukka_shiji1@deliver.com, shukka_shiji2@deliver.com, shukka_shiji3@deliver.com"
    END_OF_HINT

      m1.setting_div = '0008'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      ※ ページ管理で登録したページの「URL上の名前」を指定します。
      ※ 指定したページが、ショッピングサイトのトップページとして表示されます。
    END_OF_HINT

      m1.setting_div = '0011'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      ※ ページ管理で登録したページの「URL上の名前」を指定します。
      ※ 指定したページが、カートの中で「買い物を続ける」ボタンを押したときに表示されます。
    END_OF_HINT

      m1.setting_div = '0012'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      ※ ページ管理で登録したページの「URL上の名前」を指定します。
      ※ 指定したファイルが「個人情報の収集についてのお知らせ」画面で、テキストエリアに表示されます。
      ※ アンダースコア( _ )で始まるページを選択してください。
    END_OF_HINT

      m1.setting_div = '0013'
      m1.setting_div_entry[:hint].should == "入力例：　EC-Riderショッピングサイト"
      m1.setting_div = '0015'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      ※ 日本円からの変換レートを入力します。
      入力例：　0.0735
      END_OF_HINT

      m1.setting_div = '0016'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      ※ 端数の処理方法を指定します。
      ※ 切り上げ：「round_up」を指定します。
      ※ 切り捨て：「round_down」を指定します。
      ※ 四捨五入：「round_off」を指定します。
      END_OF_HINT

      m1.setting_div = '0017'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      ※ アリペイ口座側画面で表示される商品名称を指定します。
      ※ 簡体字で入力してください。
      ※ 指定しない場合は「Web－Shopping」となります。
      END_OF_HINT

      m1.setting_div = '0018'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      ※ アリペイ決済エラー時に送信する、決済取り消し依頼メールの送信先を指定します。
      入力例：　payment_cancel1@deliver.com, payment_cancel2@deliver.com, payment_cancel3@deliver.com"
      END_OF_HINT

      m1.setting_div = '0021'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      ※ ページ管理で登録したページの「URL上の名前」を指定します。
      ※ 指定したページが、ショッピングサイトのサイト入り口ページとして表示されます。
      ※ サイト入り口アクションを登録した場合、トップページアクション名も登録してください。
      END_OF_HINT

      m1.setting_div = '0022'
      m1.setting_div_entry[:hint].should == "会員情報入力フォームで性別を必須入力にするかを設定します。trueの場合必須入力になります。"

      m1.setting_div = '0023'
      m1.setting_div_entry[:hint].should == "会員情報入力フォームで生年月日を必須入力にするかを設定します。trueの場合必須入力になります。"

      m1.setting_div = '0024'
      m1.setting_div_entry[:hint].should == "会員情報入力フォームで職業を必須入力にするかを設定します。trueの場合必須入力になります。"

      m1.setting_div = '0025'
      m1.setting_div_entry[:hint].should == "入力例：　test_tenpo_address@ecrider.com"

      m1.setting_div = '0026'
      m1.setting_div_entry[:hint].should == "会員情報入力フォームで国選択の初期に表示する国を設定します。"

      m1.setting_div = '0027'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      ※ 遠隔地・離島の送料を指定します。
      ※ 郵便番号,送料(円)　の書式で入力します。
      ※ 複数の地域を登録する場合は、改行し列挙してください。
      入力例： 1002101,450[改行]
               1002211,500
      END_OF_HINT

      m1.setting_div = '0028'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      ※ 送料無料キャンペーンの遠隔地・離島の送料設定を行います。
      ※ 遠隔地・離島の送料も無料にする場合⇒０（ゼロ）
      ※ 遠隔地・離島の別途送料のみ請求する場合⇒１

      ※ 設定しない場合は「１」が設定されます
      END_OF_HINT

      m1.setting_div = '0029'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      ※ 代金引換の手数料を日本円で入力します。
      入力例：　315
      END_OF_HINT

      m1.setting_div = '0030'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      ※ Google Analyticsなどアクセス解析のためのスクリプトを設定できます。アクセス解析以外の用途では使用はお控えください。
      ※ (Google Analyticsについては http://www.google.com/analytics/ をご参照ください)
      ※ ここで設定されたものは本番環境でのみ出力され、テスト環境では出力されません。
      ※ 2000文字まで入力可能です。
      ※ <script type="text/javascript"> から </script> までを入力してください。
      END_OF_HINT

      m1.setting_div = '0031'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      ※ Googleウェブマスターなど。アクセス解析以外の用途では使用はお控えください。
      ※ (Googleウェブマスターについては http://www.google.com/webmasters をご参照ください)
      ※ ここで設定されたものは本番環境でのみ出力され、テスト環境では出力されません。
      ※ 2000文字まで入力可能です。
      例）
      <meta name="xxxxx1" content="xxxxxxxx"/>
      <meta name="xxxxx2" content="xxxxxxxx"/>

      ※ 各metaタグは /> で閉じるようにしてください。
      ○ <meta name="xxxxx" content="xxxxxxxx"/>
      × <meta name="xxxxx" content="xxxxxxxx">
      END_OF_HINT

      m1.setting_div = '0032'
      m1.setting_div_entry[:hint].should == "会員情報入力フォームでメールマガジン送信の有無を必須入力にするかを設定します。trueの場合必須入力になります。"

      m1.setting_div = '0033'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      電子決済時、決済代行会社に送信されるお問合せ先です。店舗名、部署名等を指定してください。
      ※ 半角記号「^ ` { | } ~ & < > " '」は使用できません。
      ※ 42文字以内（全角の場合は21文字以内）で指定してください。
      入力例：　お客様サポートセンター
      END_OF_HINT

      m1.setting_div = '0034'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      電子決済時、決済代行会社に送信されるお問合せ先電話番号です。
      ※ 半角数字とハイフン( - )のみ使用可能です。
      入力例：　092-123-1234
      END_OF_HINT

      m1.setting_div = '0035'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      電子決済時、決済代行会社に送信されるお問合せ先受付時間です。
      ※ 「2桁:2桁-2桁:2桁」書式で指定してください。
      入力例：
      09:00-18:00
      END_OF_HINT

      m1.setting_div = '0036'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      クレジットカード決済時に、セキュリティコード(クレジットカード裏面に印字されている末尾3桁または4桁の数字)の入力をするか否かを設定します。
      設定のない場合はセキュリティコードを利用しない決済となります。
      END_OF_HINT

      m1.setting_div = '0037'
      m1.setting_div_entry[:hint].should == <<-"END_OF_HINT"
      ログイン時のIDとしてログインIDを使用するかどうかを指定します。
      ※ ログインIDを使用する場合は「true」を、使用しない場合は「false」を指定してください。
      END_OF_HINT
    end
  end

  it "should create a new instance given valid attributes" do
    ShopSetting.create!(@valid_attributes)
  end

  it "should not create a new instance given empty setting_div" do
    invalid_setting1 = ShopSetting.create({})
    invalid_setting1.errors.length.should == 1
    invalid_setting1.errors.on(:setting_div).should == 'を入力してください。'
  end

  it "should not create another instance given duplicated setting_div" do
    ShopSetting.create!(@valid_attributes)
    invalid_setting1 = ShopSetting.create(@valid_attributes)
    invalid_setting1.errors.length.should == 1
    invalid_setting1.errors.on(:setting_div).should == 'はすでに存在します。'
  end

  it "should create another instance given duplicated setting_div and another locale" do
    ShopSetting.create!(@valid_attributes)
    valid_setting1 = ShopSetting.create({:locale => 'en'}.update(@valid_attributes))
    valid_setting1.errors.should be_empty
  end

  it "should not create another instance given duplicated setting_div and locale" do
    ShopSetting.create!(@valid_attributes)
    valid_setting1 = ShopSetting.create({:locale => 'en'}.update(@valid_attributes))
    valid_setting1.errors.should be_empty
    invalid_setting1 = ShopSetting.create({:locale => 'en'}.update(@valid_attributes))
    invalid_setting1.errors.length.should == 1
    invalid_setting1.errors.on(:setting_div).should == 'はすでに存在します。'
  end

  it "should be able to access value with [](setting_div_key)" do
    ShopSetting.create(
      :locale => 'en', :setting_div_key => :shop_name,
      :value => 'ecRider')

    I18n.locale = 'ja'
    I18n.locale.to_s.should == 'ja'
    ShopSetting[:shop_name].should == 'いーしーらいだー'

    I18n.locale = 'en'
    I18n.locale.to_s.should == 'en'
    ShopSetting[:shop_name].should == 'ecRider'

    ShopSetting.create(
      :locale => 'ja', :setting_div_key => :shop_name,
      :value => 'イーシーライダー')

    I18n.locale = 'ja'
    I18n.locale.to_s.should == 'ja'
    ShopSetting[:shop_name].should == 'イーシーライダー'
  end

  it "should raise ArgumentError when access [] with unexist setting_div_key" do
    lambda{ ShopSetting[:unexist_setting_div_key] }.should raise_error(ArgumentError)
  end

  it "should return :default value when access [] with key which has :default" do
    ShopSetting.count.should == 17
  end

  it "image_list should return Array" do
    Dir.stub!(:glob).and_return(['tmp/test01.jpg', 'tmp/test02.gif', 'tmp/test03.txt'])
    images = ShopSetting.image_list
    images.class.should == Array
  end

  it "#450" do
    Dir.stub!(:glob).and_return(['tmp/test01.jpg', 'tmp/test01-20091010101010.jpg'])
    images = ShopSetting.image_list
    images.should == ['tmp/test01.jpg']

  end

  # STEP2からはサイトテーマは用意しないことになりました
  # it "theme_list should return Array" do
  #   Dir.stub!(:glob).and_return(['tmp/test01.jpg', 'tmp/test02.gif', 'tmp/test03.txt'])
  #   themes = ShopSetting.theme_list
  #   themes.class.should == Array
  # end

  it "should not be create with value length over 2000" do
    valid_setting1 = ShopSetting.create(:locale => nil, :setting_div_key => :shop_zip_code, :value => ('あ' * 2000))
    valid_setting1.errors.should be_empty

    invalid_setting1 = ShopSetting.create(:locale => nil, :setting_div_key => :shop_address, :value => ('あ' * 2001))
    invalid_setting1.errors.length.should == 1
    invalid_setting1.errors.on(:value).should == 'は2000文字以内で入力してください。'
  end

  it "get_setting should get value" do
    ShopSetting.create(
      :locale => 'en', :setting_div_key => :shop_name,
      :value => 'ecRider')

    I18n.locale = 'ja'

    ShopSetting.get_setting(:shop_name, :ja).should == 'いーしーらいだー'
    ShopSetting.get_setting(:shop_name, :en).should == 'ecRider'
  end

  it "get_setting should get url" do
    EcRider.config.stub!(:ec_front_url).and_return('http://ecrider.jp/')
    ShopSetting.create(:setting_div_key => :shop_logo, :value => 'logo.jpg')

    ShopSetting.get_setting(:shop_logo, :ja).should == 'logo.jpg'
    ShopSetting.get_setting(:shop_logo, :ja, :value => :url).should == 'http://ecrider.jp/logo.jpg'
  end

  it "test url" do
    EcRider.config.stub!(:ec_front_url).and_return('http://ecrider.jp/')
    mss = ShopSetting.new(:setting_div_key => :shop_logo, :value => 'logo.jpg')
    mss.url.should == 'http://ecrider.jp/logo.jpg'
  end

  it "test url return nil" do
    EcRider.config.stub!(:ec_front_url).and_return('http://ecrider.jp/')
    mss = ShopSetting.new(:setting_div_key => :shop_name, :value => 'aaaaa')
    mss.url.should be_nil
  end

  describe "setting_div_entry.validate" do
    it "do nothing if setting_div is invalid" do
      setting = ShopSetting.new
      setting.valid?.should == false
      setting.errors.on(:setting_div).should == 'を入力してください。'

      setting.setting_div = 'unexist div'
      setting.valid?.should == true # いいのか？
      setting.errors.on(:setting_div).should == nil
    end
  end

  # STEP2からはサイトテーマは用意しないことになりました
  # describe "site_theme validation" do
  #   it "valid theme" do
  #     setting = ShopSetting.new(:setting_div_key => :site_theme)
  #     setting.value = 'ec_ver2'
  #     setting.valid?.should == true
  #   end

  #   it "add error when theme is blank" do
  #     setting = ShopSetting.new(:setting_div_key => :site_theme)
  #     setting.value = ''
  #     setting.valid?.should == false
  #     setting.errors.on(:value).should == 'を入力してください。'
  #   end

  #   it "add error when theme isn't exist" do
  #     setting = ShopSetting.new(:setting_div_key => :site_theme)
  #     setting.value = 'unexist theme name'
  #     setting.valid?.should == false
  #     setting.errors.on(:value).should == 'に設定できるのは次のいずれかのテーマです[ec_ver2]'
  #   end
  # end

  describe "shop_name validation" do
    it "valid 文字数" do
      setting = ShopSetting.new(:setting_div_key => :shop_name)
      setting.value = '1234567890１２３４５６'
      setting.valid?.should be_true
    end
    it "invalid 文字数" do
      setting = ShopSetting.new(:setting_div_key => :shop_name)
      setting.value = '1234567890１２３４５６7'
      setting.valid?.should be_false
      setting.errors.on(:value).should == 'は16文字以内で入力してください。'
    end
  end

  describe "shop_mail validation" do
    it "valid email" do
      setting = ShopSetting.new(:setting_div_key => :shop_mail)
      setting.value = 'test@ecrider.com'
      setting.valid?.should == true
    end

    it "add error when theme is blank" do
      setting = ShopSetting.new(:setting_div_key => :shop_mail)
      setting.value = ''
      setting.valid?.should == false
      setting.errors.on(:value).should == 'を入力してください。'
    end

    it "add error when theme isn't exist" do
      setting = ShopSetting.new(:setting_div_key => :shop_mail)
      setting.value = 'wrong_email_address'
      setting.valid?.should == false
      setting.errors.on(:value).should == 'は正しくありません。'
    end
  end

  describe "shipment_instruction_mail validation" do
    it "valid email" do
      setting = ShopSetting.new(:setting_div_key => :shipment_instruction_mail)
      setting.value = 'test@ecrider.com'
      setting.valid?.should == true
    end

    it "add error when theme is blank" do
      setting = ShopSetting.new(:setting_div_key => :shipment_instruction_mail)
      setting.value = ''
      setting.valid?.should == false
      setting.errors.on(:value).should == 'を入力してください。'
    end

    it "add error when theme isn't exist" do
      setting = ShopSetting.new(:setting_div_key => :shipment_instruction_mail)
      setting.value = 'wrong_email_address'
      setting.valid?.should == false
      setting.errors.on(:value).should == 'は正しくありません。'
    end
  end

  describe "shipment_complete_mail validation" do
    it "valid email" do
      setting = ShopSetting.new(:setting_div_key => :shipment_complete_mail)
      setting.value = 'test@ecrider.com'
      setting.valid?.should == true
    end

    it "valid email" do
      setting = ShopSetting.new(:setting_div_key => :shipment_complete_mail)
      setting.value = 'test@ecrider.com, test2@ecrider.com'
      setting.valid?.should == true
    end

    it "add error when theme is blank" do
      setting = ShopSetting.new(:setting_div_key => :shipment_complete_mail)
      setting.value = ''
      setting.valid?.should == false
      setting.errors.on(:value).should == 'を入力してください。'
    end

    it "add error when theme isn't exist" do
      setting = ShopSetting.new(:setting_div_key => :shipment_complete_mail)
      setting.value = 'wrong_email_address'
      setting.valid?.should == false
      setting.errors.on(:value).should == 'は正しくありません。'
    end
  end

  describe "policy_confirmation_page_path" do
    it "locale = ja" do
      I18n.stub!(:locale).and_return('ja')
      ShopSetting.stub!(:get_setting).and_return('_policy_text')
      ShopSetting.policy_confirmation_page_path.should =~ %r{/cms/_policy_text.html.erb}
    end

    it "locale = en" do
      # 秋間コメント
      pending "TO 栗山さん、このメソッドは実際にファイルがpublic/cmsに存在するかどうかをチェックして、見つからなければ'/cms/_policy_text.html.erb'を返しています。projects/1/public/cmsにこれを入れるべきか教えてください"
      I18n.stub!(:locale).and_return('en')
      ShopSetting.stub!(:get_setting).and_return('_policy_text')
      ShopSetting.policy_confirmation_page_path.should =~ %r{/cms/_policy_text_en.html.erb}
    end

    it "file isn't exit" do
      I18n.stub!(:locale).and_return('ja')
      ShopSetting.stub!(:get_setting).and_return('wrong_text')
      ShopSetting.policy_confirmation_page_path.should =~ %r{/cms/_policy_text.html.erb}
    end
    it "add error when shipment_instruction_mail is too long" do
      long_address = "aaaaaaa@bbbbb.cc.jp,aaaaaaa@bbbbb.cc.jp,aaaaaaa@bbbbb.cc.jp,aaaaaaa@bbbbb.cc.jp,aaaaaaa@bbbbb.cc.jp,aaaaaaa@bbbbb.cc.jp,aaaaaaa@bbbbb.cc.jp,aaaaaaa@bbbbb.cc.jp,aaaaaaa@bbbbb.cc.jp,aaaaaaa@bbbbb.cc.jp,aaaaaaa@bbbbb.cc.jp,aaaaaaa@bbbbb.cc.jp"
      invalid_setting1 = ShopSetting.create(:locale => nil, :setting_div_key => :shipment_instruction_mail, :value => long_address)
      invalid_setting1.errors.length.should == 0

      invalid_setting1 = ShopSetting.create(:locale => nil, :setting_div_key => :shipment_instruction_mail, :value => long_address + ",aaaaaaa@bbbbb.cc.jp,aaaaaaa@bbbbb.cc.jp,aaaaaaa@bbbbb.cc.jp")
      invalid_setting1.errors.length.should == 2
      invalid_setting1.errors.on(:value).should == 'は255文字以内で入力してください。'
    end
  end

  describe "exchange_rate validation" do
    it "exchange_rate is valid (pattern 1)" do
      setting = ShopSetting.new(:setting_div_key => :exchange_rate)
      setting.value = '012.3450'
      setting.valid?.should == true
    end

    it "exchange_rate is valid (pattern 2)" do
      setting = ShopSetting.new(:setting_div_key => :exchange_rate)
      setting.value = '0120'
      setting.valid?.should == true
    end

    it "exchange_rate is invalid (pattern 1)" do
      setting = ShopSetting.new(:setting_div_key => :exchange_rate)
      setting.value = 'abcde'
      setting.valid?.should == false
      setting.errors.on(:value).should == 'は数値で入力してください。'
    end

    it "exchange_rate is invalid (pattern 2)" do
      setting = ShopSetting.new(:setting_div_key => :exchange_rate)
      setting.value = '１２３４５'
      setting.valid?.should == false
      setting.errors.on(:value).should == 'は数値で入力してください。'
    end

    it "exchange_rate is invalid (pattern 3)" do
      setting = ShopSetting.new(:setting_div_key => :exchange_rate)
      setting.value = '1.'
      setting.valid?.should == false
      setting.errors.on(:value).should == 'は数値で入力してください。'
    end

    it "exchange_rate is invalid (pattern 4)" do
      setting = ShopSetting.new(:setting_div_key => :exchange_rate)
      setting.value = '.1'
      setting.valid?.should == false
      setting.errors.on(:value).should == 'は数値で入力してください。'
    end

    it "exchange_rate is invalid (pattern 5)" do
      setting = ShopSetting.new(:setting_div_key => :exchange_rate)
      setting.value = '1..1'
      setting.valid?.should == false
      setting.errors.on(:value).should == 'は数値で入力してください。'
    end

    it "add error when exchange_rate is blank" do
      setting = ShopSetting.new(:setting_div_key => :exchange_rate)
      setting.value = ''
      setting.valid?.should == false
      setting.errors.on(:value).should == 'を入力してください。'
    end
  end
  describe ":rounding_processing validation" do
    it "rounding_processing is valid" do
      setting = ShopSetting.new(:setting_div_key => :rounding_processing)
      setting.value = 'round_up'
      setting.valid?.should == true
    end

    it "add error when rounding_processing is blank" do
      setting = ShopSetting.new(:setting_div_key => :rounding_processing)
      setting.value = ''
      setting.valid?.should == false
      setting.errors.on(:value).should == 'を入力してください。'
    end
  end

  describe ":aliyap_product_name validation" do
    it "aliyap_product_name is valid" do
      setting = ShopSetting.new(:setting_div_key => :aliyap_product_name)
      setting.value = '在线购入编号'
      setting.valid?.should == true
    end

    it "aliyap_product_name is invalid" do
      setting = ShopSetting.new(:setting_div_key => :aliyap_product_name)
      setting.value = 'a，§a，´a，?a'
      setting.valid?.should == false
      setting.errors.on(:value).should == 'は簡体字で入力してください。'
    end

    it "add error when aliyap_product_name is blank" do
      setting = ShopSetting.new(:setting_div_key => :aliyap_product_name)
      setting.value = ''
      setting.valid?.should == false
      setting.errors.on(:value).should == 'を入力してください。'
    end
  end
  describe ":aliyap_product_name validation" do
    it "add error when aliyap_product_name is blank" do
      setting = ShopSetting.new(:setting_div_key => :payment_cancel_mail)
      setting.value = ''
      setting.valid?.should == false
      setting.errors.on(:value).should == 'を入力してください。'
    end
    it "1つ追加" do
      setting = ShopSetting.new(:setting_div_key => :payment_cancel_mail)
      setting.value = 'm-user@ec.one.com'
      setting.valid?.should be_true
    end
    it "複数追加" do
      setting = ShopSetting.new(:setting_div_key => :payment_cancel_mail)
      setting.value = 'm-user@ec.one.com, m-user@ec-one.com'
      setting.valid?.should be_true
    end
    it "複数追加(エラー)" do
      setting = ShopSetting.new(:setting_div_key => :payment_cancel_mail)
      setting.value = 'm-user@ec.one.com m-user@ec-one.com '
      setting.valid?.should be_false
    end
  end

  describe "shipping_cost_outlier" do
    before do
      ShopSetting.destroy_all(:setting_div => ShopSetting.setting_div_id_by_key(:campaign_outlier))
      setting = ShopSetting.new(:setting_div_key => :campaign_outlier)
      setting.value = <<-"EOS"
        4600002,200
        4330021,300
      EOS
      setting.save!
    end
    
    it "離島でない" do
      I18n.stub!(:locale).and_return('ja')
      ShopSetting.shipping_cost_outlier_or_nil('4780003').should be_nil
      ShopSetting.shipping_cost_outlier('4780003').should == 0
    end
    
    it "離島" do
      I18n.stub!(:locale).and_return('ja')
      ShopSetting.shipping_cost_outlier_or_nil('4600002').should == 200
      ShopSetting.shipping_cost_outlier('4600002').should == 200
    end
  end
  
  describe "cod_charge validation" do
    it "valid" do
      setting = ShopSetting.new(:setting_div_key => :cod_charge)
      setting.value = '315'
      setting.valid?.should be_true
    end
    it "invalid　未入力" do
      setting = ShopSetting.new(:setting_div_key => :cod_charge)
      setting.value = ''
      setting.valid?.should be_false
      setting.errors.on(:value).should == "を入力してください。"
    end
    it "invalid　数値以外" do
      setting = ShopSetting.new(:setting_div_key => :cod_charge)
      setting.value = '315円'
      setting.valid?.should be_false
      setting.errors.on(:value).should == "は整数で入力してください。"
    end
    it "invalid　カンマ" do
      setting = ShopSetting.new(:setting_div_key => :cod_charge)
      setting.value = '1,000'
      setting.valid?.should be_false
      setting.errors.on(:value).should == "は整数で入力してください。"
    end
    it "invalid　小数" do
      setting = ShopSetting.new(:setting_div_key => :cod_charge)
      setting.value = '315.5'
      setting.valid?.should be_false
      setting.errors.on(:value).should == "は整数で入力してください。"
    end
  end

  describe "settlement_inquiries validation" do
    it "invalid 空文字列" do
      setting = ShopSetting.new(:setting_div_key => :settlement_inquiries)
      setting.value = ''
      setting.valid?.should == false
      setting.errors.on(:value).should == 'を入力してください。'
    end
    it "valid 入力可能文字" do
      setting = ShopSetting.new(:setting_div_key => :settlement_inquiries)
      setting.value = 'お客様サポートセンター09azAZ.+-*/=()'
      setting.valid?.should be_true
    end
    it "invalid 入力可能文字" do
      setting = ShopSetting.new(:setting_div_key => :settlement_inquiries)
      setting.value = 'お客様サポート}センター'
      setting.valid?.should be_false
      setting.errors.on(:value).should == "は正しくありません。"
    end
    it "valid バイト数" do
      setting = ShopSetting.new(:setting_div_key => :settlement_inquiries)
      setting.value = '12345678901234567890１２３４５６７８９０12'
      setting.valid?.should be_true
    end
    it "invalid バイト数" do
      setting = ShopSetting.new(:setting_div_key => :settlement_inquiries)
      setting.value = '12345678901234567890１２３４５６７８９０123'
      setting.valid?.should be_false
      setting.errors.on(:value).should == "は長すぎます。"
    end
  end

  describe "settlement_inquiries_tel_num validation" do
    it "invalid 空文字列" do
      setting = ShopSetting.new(:setting_div_key => :settlement_inquiries_tel_num)
      setting.value = ''
      setting.valid?.should == false
      setting.errors.on(:value).should == 'を入力してください。'
    end
    it "valid 入力可能文字" do
      setting = ShopSetting.new(:setting_div_key => :settlement_inquiries_tel_num)
      setting.value = '012-345-6789'
      setting.valid?.should be_true
    end
    it "invalid 入力可能文字" do
      setting = ShopSetting.new(:setting_div_key => :settlement_inquiries_tel_num)
      setting.value = 'a'
      setting.valid?.should be_false
      setting.errors.on(:value).should == "は正しくありません。"
    end
    it "valid バイト数" do
      setting = ShopSetting.new(:setting_div_key => :settlement_inquiries_tel_num)
      setting.value = '123456789012'
      setting.valid?.should be_true
    end
    it "invalid バイト数" do
      setting = ShopSetting.new(:setting_div_key => :settlement_inquiries_tel_num)
      setting.value = '1234567890123'
      setting.valid?.should be_false
      setting.errors.on(:value).should == "は12文字以内で入力してください。"
    end
  end

  describe "settlement_inquiries_time_in validation" do
    it "invalid 空文字列" do
      setting = ShopSetting.new(:setting_div_key => :settlement_inquiries_time_in)
      setting.value = ''
      setting.valid?.should == false
      setting.errors.on(:value).should == 'を入力してください。'
    end
    it "valid" do
      setting = ShopSetting.new(:setting_div_key => :settlement_inquiries_time_in)
      setting.value = '09:00-18:00'
      setting.valid?.should be_true
    end
    it "invalid" do
      setting = ShopSetting.new(:setting_div_key => :settlement_inquiries_time_in)
      setting.value = '9:00-18:00'
      setting.valid?.should be_false
      setting.errors.on(:value).should == "は正しくありません。"
    end
  end
end
